<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN')) {
    include(dirname(dirname(dirname(__FILE__))) . '/includes/404.php');
}

/**
 * Frame_admin
 *
 * Сортировка by Gar|k
 */
class Frame_admin {

    /**
     * @var object основной объект системы
     */
    public $diafan;
    /**
     * @var string таблица в базе данных
     */
    public $table;
    /**
     * @var array настройки отображения
     */
    public $config_module = array();
    /**
     * @var array поля таблицы с типами
     */
    public $variable_table = array();
    /**
     * @var array переводимые поля
     */
    public $language_names = array();
    /**
     * @var string SQL-условия для списка
     */
    protected $where;

    /**
     * Конструктор класса
     *
     * @return void
     */
    public function __construct($diafan) {
        $this->diafan = $diafan;
    }

    /**
     * Сортирует элементы
     *
     * @return boolean
     */
    public function move_module() {
        // Прошел ли пользователь проверку идентификационного хэша
        if (!$this->diafan->_user->checked) {
            echo "{error: 'HASH'}";
            return FALSE;
        }

        //проверка прав на сортировку
        if ($this->diafan->admin_roles('order')) {
            echo "{error: 'ROLES'}";
            return FALSE;
        }

        if(empty($_POST['sort'])) {
            echo "{error: 'SORT'}";
            return FALSE;
        }

        $result["status"] = TRUE;
        $result["hash"] = $this->diafan->_user->get_hash();

        foreach($_POST['sort'] as $id=>$sort) {
            if(!DB::query("UPDATE {" . $this->table . "} SET sort=%d WHERE id=%d",$sort,$id)) {
                 $result["status"] = FALSE;
                 break;
            }
        }

        //$this->diafan->_cache->delete("", $this->diafan->rewrite);
	$this->diafan->_cache->delete("", $this->diafan->module);
       
        include_once(ABSOLUTE_PATH . 'plugins/json.php');
        echo to_json($result);

        return TRUE;
    }

}