<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Frame_admin
 * 
 * Список элементов
 */
class Frame_admin extends Theme_admin
{
	/**
	 * @var object основной объект системы
	 */
	public $diafan;

	/**
	 * @var string таблица в базе данных
	 */
	public $table;

	/**
	 * @var string таблица, которая делит элементы на категории (если отлична от $table.'_category')
	 */
	public $category_table;

	/**
	 * @var array настройки отображения
	 */
	public $config_module;

	/**
	 * @var array поля таблицы с типами
	 */
	public $variable_table = array();

	/**
	 * @var array варианты значений переменной с типом список, которые берутся из таблицы
	 */
	public $select = array();

	/**
	 * @var array варианты значений переменной с типом список
	 */
	public $select_arr = array();

	/**
	 * @var array переводимые поля
	 */
	public $language_names = array();

	/**
	 * @var array список дополнительных полей, выводимых в списке
	 */
	public $config_other_row;
	
	/**
	 * @var integer|string язык поля, обозначающего активность
	 */
	public $lang_act;

	/**
	 * @var integer количество элементов на странице, участвующих в сортировке
	 */
	public $count_order;

	/**
	 * @var integer счетчик
	 */
	public $k;

	/**
	 * @var array родители текущего раскрытого элемента
	 */
	public $parent_parents = array();

	/**
	 * @var string название поля таблицы, используемое для ссылки на страницу редактирования
	 */
	protected $name = 'name';

	/**
	 * @var string SQL-условия для списка
	 */
	protected $where;

	/**
	 * @var string GET переменные, участвующие в навигации для постраничного вывода
	 */
	protected $get_nav;

	/**
	 * @var integer количество элементов, показанных на странице
	 */
	protected $nastr = 30;

	/**
	 * @var integer количество ссылок постраничной навигации, показанных на одной страние
	 */
	protected $navnastr = 10;

	/**
	 * @var string ссылка на текущую страницу, используемая в постраничной навигации
	 */
	private $navlink;

	/**
	 * @var string ссылка на текущую страницу, используемая при раскрытии/закрытии дерева
	 */
	private $enterlink;

	/**
	 * @var integer порядковый номер элемента, с которого начинается вывод элементов
	 */
	private $polog = 0;

	/**
	 * @var integer количество элементов в списке
	 */
	private $nen;

	/**
	 * @var boolean отображать групповые операции
	 */
	protected $group_actions = FALSE;

	/**
	 * @var integer общее количество елементов
	 */
	protected $count;

	/**
	 * @var array кэш класса
	 */
	protected $cache;

	/**
	 * @var boolean ширина колонок задана в шапке
	 */
	protected $width_column = FALSE;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;	
	}

	/**
	 * Формирует список элементов
	 *
	 * @param integer $id родитель
	 * @param integer $r подрядковый номер
	 * @return boolean true
	 */
	public function list_row($id = 0, $r = '')
	{
		$this->prepare_variables($id);
		
		$links  = $this->prepare_paginator($id);
		$nen = $this->nen;
		if (! $id || ! $this->config_module["parent"])
		{
			$this->group_actions_show();
		}

		$result = $this->sql_query($id);

		while ($row = DB::fetch_array($result))
		{ 
			$this->k++;

	        $link = $this->get_base_link($row);

			echo '
			<tr altcolor="#eeeeee" class="tr">'

				//выводит название раздела
				.$this->get_parent_name($row)
				
				//выводит дату
				.($this->config_module["date"]
				 ? '
				 <td>'.date("d.m.Y", $row["created"]).'</td>'
				 : '')
				
				//выводит дату и время
				.($this->config_module["datetime"]
				 ? '
				 <td>'.date("d.m.Y H:i", $row["created"]).'</td>'
				 : '')

				.$this->get_image_link($row["id"], $link).'

				<td class="tdedit'.$r.'"';
				if (! $this->width_column)
				{
					echo 'style="padding-left: '.($r * 10 + 5).'px; width:'.(70 - count($this->config_other_row) * 20 - ($this->config_module["element"] ? 10 : 0)).'%;"';
				}
				echo '><a name="'.$row["id"].'"></a>';

				if ($this->config_module["view"] && $row["block"])
				{
					echo '('._ADMIN_BLOCK_SITE.')';
				}
				echo '<font>'
				
				//выводит + в виде ссылке на вложенные элементы
				.$this->get_plus($row)
				
				//выводит ссылку на редактирование
				.($link ? $link.($this->diafan->short_text($row["name"]) ? $this->diafan->short_text($row["name"]) : $row["id"]).'</a>' : '')
				.'</font>';
				
				$this->get_menu($row["id"]);

				if ($this->config_module["view"] && $row["addmodule"] && file_exists(ABSOLUTE_PATH.'adm/img/'.$row["addmodule"].'_18.gif'))
				{
					echo '<img src="'.BASE_PATH.'adm/img/'.$row["addmodule"].'_18.gif" align="absmiddle" title="'._ADMIN_MODULE.'" alt="'._ADMIN_MODULE.'">';
				}
				
				//выводит прочие поля таблицы
				$this->get_other_rows($row);
				
				echo '</td><td>'
				
				//выводит кнопки удаление, добавление, сортировка
				.$this->get_action($row, $r, $nen);
			if ($this->group_actions)
			{
				echo '
				</td><td class="checkbox">';
			
				if ($this->config_module["del"]
				   && ! $this->diafan->admin_roles('del')
				   && ($this->table != "trash" || ! $row["parent_id"])
				   && ($this->table != "language" || $row["id"] != 1)
				   && ($this->table != "users" || $this->diafan->_user->id != $row["id"])
				   ||
				   $this->config_module["act"]
				   && ! $this->diafan->admin_roles('act')
				   && ($this->table != "users" || $this->diafan->_user->id != $row["id"])
				   && ($this->table != "trash" || ! $row["parent_id"])
				   && ($this->table != "language" || $row["id"] != 1))
				{
					echo '<input type="checkbox" name="ids[]" value="'.$row["id"].'">';
				}
			}
			echo '
			</td></tr>'."\n";
			
			//выводит вложенные элементы
			if (! empty($this->config_module["parent"])
				&& in_array($row["id"], $this->parent_parents)
				&& $this->config_module["parent"] != $r + 2
			)
			{
				$k = $this->k;
				$this->list_row($row["id"], $r + 1);
				$this->k = $k;
			}
	
		}
		$this->group_actions($links, $id);
				
		if (empty($r) && in_array($this->diafan->module, array('site', 'menu')))
			{
			echo '<tr>
				<td align="right" colspan="7">
					Для сортировки пунктов перетащите их мышкой
				</td>
			</tr>';
			}
			
		return TRUE;
	}

	private function group_actions_show()
	{
		if (! $this->config_module["parent"])
		{
			$this->count = $this->nen;
		}
		else
		{
			$this->count = DB::query_result("SELECT COUNT(DISTINCT e.id) FROM {".$this->table."} as e"
											.($this->config_module["element_multiple"] && $this->diafan->cat
											  ? " INNER JOIN {".$this->table."_category_rel} AS c ON e.id=c.element_id"
												." AND e.id=c.element_id AND c.cat_id='".$this->diafan->cat."'"
											  : '')
											." WHERE 1=1"
											.($this->config_module["element"] && ! $this->config_module["element_multiple"] && $this->diafan->cat ?" AND e.cat_id='".$this->diafan->cat."'" : '')
											.($this->config_module["element_site"] && $this->diafan->site ? " AND e.site_id='".$this->diafan->site."'" : '')
											.($this->where ? " ".$this->where : '')
											.($this->table == 'site' ? " AND e.id<>1" : '')
											.($this->config_module["trash"] ? " AND e.trash='0'" : ''));
		}
		$this->group_actions = $this->count > 3;
	}

	/**
	 * Определяет свойства класса
	 *
	 * @param integer $id родитель
	 * @return boolean true
	 */
	private function prepare_variables($id)
	{	
		$this->name .= in_array($this->name, $this->language_names) ? _LANG : '';

		$this->k = 1;
		$this->lang_act = in_array("act", $this->language_names) ? _LANG : '';

		if ($this->config_other_row)
		{
			foreach ($this->config_other_row as $key => $value)
			{
				$this->config_other_row[$key] .= in_array($value,$this->language_names) ? _LANG : '';
			}
		}

		//для корректной сортировки не должно быть элементов в нулевым значением поля sort
		if ($this->config_module["order"])
		{
			$this->count_order = $this->count_order($id);
		}

		if ($this->config_module["parent"] && $this->diafan->parent && empty($this->parent_parents))
		{
			$this->parent_parents = $this->diafan->get_parents($this->diafan->parent, $this->table);
			$this->parent_parents[] = $this->diafan->parent;
		}
		return TRUE;
	}

	/**
	 * Подсчитывает сколько элементов на данной странице нужно сортировать, если в конфигурации разрешена соритовка
	 *
	 * @param integer $id родитель
	 * @return integer
	 */
	private function count_order($id)
	{
		return 
		$this->config_module["order"]
		?
			DB::query_result("SELECT COUNT(DISTINCT e.id) FROM {".$this->table."} as e"
			                 .($this->config_module["element_multiple"] && $this->diafan->cat
			                  ? " INNER JOIN {".$this->table."_category_rel} AS c ON e.id=c.element_id"
			                    ." AND e.id=c.element_id AND c.cat_id='".$this->diafan->cat."'"
			                  : '')
			                 ." WHERE 1=1"
			                 .($this->config_module["parent"]  ?" AND e.parent_id='".$id."'" : '')
			                 .($this->config_module["element"] && ! $this->config_module["element_multiple"] && $this->diafan->cat ?" AND e.cat_id='".$this->diafan->cat."'" : '')
			                 .($this->config_module["element_site"] && $this->diafan->site ? " AND e.site_id='".$this->diafan->site."'" : '')
			                 .($this->where                    ? " ".$this->where : '')
			                 .($this->config_module["act"]     ? " AND e.act".$this->lang_act."='1'" : '')
			                 .($this->table == 'site'          ? " AND e.id<>1" : '')
			                 .($this->config_module["trash"]   ? " AND e.trash='0'" : '')
			                 .' LIMIT '.$this->polog.', '.($this->nastr + 1)
			)
		: 0;
	}

	/**
	 * Формирует постраничную навигацию
	 *
	 * @return array
	 */
	private function prepare_paginator($id)
	{
		if ($this->nastr)
		{
			$this->diafan->_paginator->nastr = $this->nastr;
		}
		if (! $id || ! $this->config_module["parent"])
		{
			$this->diafan->_paginator->page    = $this->diafan->page;
			$this->diafan->_paginator->navlink = ($this->diafan->rewrite ? $this->diafan->rewrite.'/' : '')
			                                     .($this->diafan->site    ? 'site'.$this->diafan->site.'/' : '')
			                                     .($this->diafan->cat     ? 'cat'.$this->diafan->cat.'/' : '');
			$this->enterlink                   = $this->diafan->_paginator->navlink.'parent%d/'
			                                     .($this->diafan->_paginator->page ? 'page'.$this->diafan->_paginator->page.'/' : '').'?';
			$this->diafan->_paginator->get_nav = $this->get_nav;
			$this->navlink                    .= $this->diafan->_paginator->navlink.'parent%d/'
			                                     .($this->diafan->_paginator->page ? 'page'.$this->diafan->_paginator->page.'/' : '')
			                                     .($this->get_nav ? $this->get_nav.'&' : '?');
		}
		elseif ($this->config_module["parent"])
		{
			$this->diafan->_paginator->page    = ! empty($_GET["page".$id]) ? intval($_GET["page".$id]) : 0;
			$this->diafan->_paginator->urlpage = 'page'.$id.'=%d';
			$this->enterlink                   = $this->enterlink.($this->diafan->_paginator->page ? 'page'.$id.'='.$this->diafan->_paginator->page : '').'&';
			$this->diafan->_paginator->navlink = sprintf($this->navlink, $id);
			$this->diafan->_paginator->get_nav = '';
			$this->navlink                    .= $this->diafan->_paginator->page ? 'page'.$id.'='.$this->diafan->_paginator->page.'&' : '';
		}

		$this->nen = DB::query_result("SELECT COUNT(DISTINCT e.id) FROM {".$this->table."} as e"
		                              .($this->config_module["element_multiple"] && $this->diafan->cat
		                                ? " INNER JOIN {".$this->table."_category_rel} AS c ON e.id=c.element_id"
		                                  ." AND e.id=c.element_id AND c.cat_id='".$this->diafan->cat."'"
		                                : '')
		                              ." WHERE 1=1"
		                              .($this->config_module["parent"]  ? " AND e.parent_id='".$id."'" : '')
		                              .($this->config_module["element"] && ! $this->config_module["element_multiple"] && $this->diafan->cat ? " AND e.cat_id='".$this->diafan->cat."'" : '')
		                              .($this->config_module["element_site"] && $this->diafan->site ? " and e.site_id='".$this->diafan->site."'" : '')
		                              .($this->where                    ? " ".$this->where : '')
		                              .($this->table == 'site'          ? " AND e.id<>1" : '')
		                              .($this->config_module["trash"]   ? " AND e.trash='0'" : '')
		                             );
		$this->diafan->_paginator->nen = $this->nen;

		$links       = $this->diafan->_paginator->get();
		$this->polog = $this->diafan->_paginator->polog;
		$this->nastr = $this->diafan->_paginator->nastr;

		return $links;
	}

	/**
	 * Формирует SQL-запрос для списка элементов
	 *
	 * @param integer $id родитель
	 * @return resource
	 */
	private function sql_query($id)
	{
		return DB::query("SELECT e.id, e.".$this->name." AS name"
			.($this->config_module["act"]      ? ', e.act'.$this->lang_act.' AS act' : '')
			.($this->config_module["parent"]   ? ', e.parent_id, e.count_children' : '')
			.($this->config_other_row          ? ', e.'.implode(', e.', $this->config_other_row) : '')
			.($this->config_module["date"] || $this->config_module["datetime"] ? ', e.created' : '')
			.($this->config_module["view"]     ? ', e.addmodule, e.block' : '')
			.($this->config_module["element_site"] ? ', e.site_id' : '')
			.($this->config_module["element_multiple"] ? ', e.cat_id' : '')
			.($this->config_module["order"] ? ', e.sort' : '')
			." FROM {".$this->table."} as e"
			.($this->config_module["element_multiple"] && $this->diafan->cat
			  ? " INNER JOIN {".$this->table."_category_rel} AS c ON e.id=c.element_id"
				." AND e.id=c.element_id AND c.cat_id='".$this->diafan->cat."'"
			  : '')
			." WHERE 1=1"
			.($this->config_module["parent"]   ? " AND e.parent_id='".$id."'" : '')
			.($this->config_module["element"] && ! $this->config_module["element_multiple"] && $this->diafan->cat ? " AND e.cat_id='".$this->diafan->cat."'" : '')
			.($this->config_module["element_site"] && $this->diafan->site ? " AND e.site_id='".$this->diafan->site."'" : '')
			.($this->where                     ? " ".$this->where : '')
			.($this->table == 'site'           ? " AND e.id<>1" : '')
			.($this->config_module["trash"]    ? " AND e.trash='0'" : '')
			.($this->config_module["element_multiple"] && $this->diafan->cat ? " GROUP BY e.id" : '')
			." ORDER BY "
			.($this->config_module["prior"]    ? 'e.prior DESC, ' : '')
			.($this->config_module["date"] || $this->config_module["datetime"] ? 'e.created DESC, ' : '')
			.($this->config_module["act"]      ? 'e.act'.$this->lang_act.' DESC, ' : '')
                        .($this->table == 'site' ? " e.is_menu DESC, e.block ASC, " : '')
			.($this->config_module["order"]    ? 'e.sort ASC, e.id ASC' : 'e.id DESC')
			.' LIMIT '.$this->polog.', '.$this->nastr
		);
	}

	/**
	 * Выводит название раздела/категории в списке
	 *
	 * @param array $row информация о текущем элменте списка
	 * @return string
	 */
	protected function get_parent_name($row)
	{
		$text  = '';
		if ($this->config_module["element_site"] && ! $this->diafan->site)
		{
			if (! isset($this->cache["site"][$row["site_id"]]["name"]))
			{
				$this->cache["site"][$row["site_id"]]["name"] = DB::query_result("SELECT name FROM {site} WHERE id=%d AND trash='0'", $row["site_id"]);
			}
			$text = '<td class="parent_name">'.$this->cache["site"][$row["site_id"]]["name"].'</td>';
		}
		if ($this->config_module["element_multiple"])
		{
			$cats = array();
			$result = DB::query("SELECT s.[name] FROM {".$this->diafan->module."_category_rel} as c INNER JOIN {".$this->diafan->module."_category} as s ON s.id=c.cat_id"
								." WHERE element_id='%d'", $row["id"]);
			while ($row_cat = DB::fetch_array($result))
			{
				$cats[] = $row_cat["name"];
			}
			$text .= '<td class="parent_name">'.implode(', ', $cats).'</td>';
		}
		return $text;
	}

	/**
	 * Выводит ссылку на вложенные элементы
	 *
	 * @param array $row информация о текущем элменте списка
	 * @return string
	 */
	private function get_plus($row)
	{
                $html='';
                if($this->config_module["parent"])
                {
                    if($row["count_children"])
                    {
                        if(in_array($row["id"], $this->parent_parents))
                        {
                            $html='<a href="'.BASE_PATH_HREF.sprintf($this->enterlink,$row["parent_id"]).'" class="plus" title="'._ADMIN_CURTAIL.'">&#151;</a>';
                        }
                        else
                        {
                            $html='<a href="'.BASE_PATH_HREF.sprintf($this->enterlink,$row["id"]).'#'.$row["id"].'" class="plus" title="'._ADMIN_UNWRAP.'">+</a>';
                        }
                    }
                    else
                    {
                        $html='&nbsp;&nbsp;';
                    }
                }
		return $html;
	}

	/**
	 * Выводит пометку "Отображается в меню"
	 *
	 * @param integer $id номер текущего элемента
	 * @return boolean true
	 */
	private function get_menu($id)
	{
		if ($this->config_module["menu"])
		{
			if ($this->diafan->module == 'site')
			{
				$name_menu = 'site_id';
			}
			elseif ($this->config_module["category"])
			{
				$name_menu = 'module_cat_id';
			}
			else
			{
				$name_menu = 'element_id';
			}
                        $is_menu=0;
			if (DB::query_result("SELECT COUNT(*) FROM {menu} WHERE module_name='%h' AND ".$name_menu."=%d AND trash='0' AND [act]='1'", $this->diafan->module, $id))
			{
				echo ' <span title="'._ADMIN_MENU.'">(м)</span>';
                                if ($this->diafan->module == 'site')
                                {
                                    $is_menu=1;
                                }
			}
                        if ($this->diafan->module == 'site')
                        {
                                DB::query("UPDATE {site} SET is_menu='%d' WHERE id=%d",$is_menu,$id);

                        }
		}
		return TRUE;
	}

	/**
	 * Формирует основную ссылку для элемента в списке
	 *
	 * @param array $row информация о текущем элменте списка
	 * @return string
	 */
	private function get_base_link($row)
	{
		if ($this->diafan->module == "trash")
			return '';
		
		$link = ' <a href="';
			if ($this->config_module["view"] && $row["addmodule"] && file_exists(ABSOLUTE_PATH.'modules/'.$row["addmodule"].'/admin/'.$row["addmodule"].'.admin.php'))
			{
				$link .= BASE_PATH_HREF.$row["addmodule"].'/site'.$row["id"].'/';
			}
			elseif ($this->config_module["link_to_element"])
			{
				$link .= $this->diafan->_route->current_admin_link(array("page", "parent")).'cat'.$row["id"].'/';
			}
			elseif($this->config_module["element_site"] && ! $this->diafan->admin_roles('edit'))
			{
			    $link .= $this->diafan->_route->current_admin_link('site').'site'.$row['site_id'].'/edit'.$row["id"].'/" title="'._LANG_EDIT.' ('.$row["id"].')';
			}
			elseif (! $this->diafan->admin_roles('edit'))
			{
				
				$link .= $this->diafan->_route->current_admin_link().'edit'.$row["id"].'/" title="'._LANG_EDIT.' ('.$row["id"].')';
			}
			else
			{
				$link .= '#';
			}
			$link .= '"';
			if ($this->config_module["act"] && ! $row["act"])
			{
				$link .= ' class="noplus"';
			}
			$link .= '>';
		return $link;
	}

	/**
	 * Выводит изображение элемента в списке
	 *
	 * @param integer $id номер элемета
	 * @param string $link основная ссылка
	 * @return string
	 */
	private function get_image_link($id, $link)
	{
		if (! $this->config_module["image"])
		{
			return FALSE;
		}
		$row = DB::fetch_array(DB::query("SELECT id, name FROM {images} WHERE element_id=%d AND module_name='%s' AND trash='0' ORDER BY sort ASC LIMIT 1" ,$id, $this->table));
		if ($row && file_exists(ABSOLUTE_PATH.USERFILES."/".$this->table."/small/".$row["name"]))
		{
			$image = '<img src="http://'.BASE_URL.'/'.USERFILES.'/'.$this->table."/small/".$row["name"].'" border="0">';
		}
		
		
		return '<td>'.(! empty($image) ? $link.$image.'</a>' : '').'</td>';
	}

	/**
	 * Выводит дополнительную информацию для элемента в списке
	 *
	 * @param array $row информация о текущем элменте списка
	 * @return boolean true
	 */
	private function get_other_rows($row)
	{
		if ($this->config_other_row)
		{
			foreach ($this->config_other_row as $value)
			{
				$func = 'other_row_'.preg_replace('/[^a-z_]+/', '', $value);
				echo 
				(method_exists($this,$func)
				? $this->$func($row)
				: '</td><td class="comment">
					<div>
						<span></span>
						<table><tbody><tr><td>
							'.$this->diafan->short_text($row[$value]).'
						</td></tr></tbody></table>
					</div>
				'
				);
			}
		}
		return TRUE;
	}

	/**
	 * Выводит ссылки на добавление, удаление, активацию, сортировку
	 *
	 * @param array $row информация о текущем элменте списка
	 * @param integer $r порядковый номер
	 * @param integer $nen количество элеметнов в списке
	 * @return string
	 */
	private function get_action($row, $r, $nen)
	{
		if ($this->config_module["menu"] && $row["act"])
		{
			if ($this->diafan->module == "site")
			{
				$row["view_link"] = $this->diafan->_route->link($row["id"]);
			}
			elseif ($this->config_module["category"])
			{
				$row["view_link"] = $this->diafan->_route->link($row["site_id"], $this->diafan->module, $row["id"]);
			}
			else
			{
				if (! $this->config_module["element"])
				{
					$row["cat_id"] = 0;
				}
				$row["view_link"] = $this->diafan->_route->link($row["site_id"], $this->diafan->module, $row["cat_id"], $row["id"]);
			}
		}
		$text = '<div class="actions" row_id="'.$row["id"].'"><span><nobr> ';
		
		//add
		if ($this->config_module["parent"] && ! $this->diafan->admin_roles('addnew') && $this->table != "trash"
		   && (! $this->config_module["view"] || ! $row["block"]))
		{
			$text .= '<a href="'.path_module($this->diafan, 0, 1).'parent'.$row["id"].'/'.'addnew'.$row["id"].'/"'
			 .'title="'._ADMIN_ADD_SUBPAGE.'"><img src="'.BASE_PATH.'adm/img/add.gif"></a> ';
		}
		//act
		if ($this->config_module["act"] && ! $this->diafan->admin_roles('act')
			  && ($this->table != "users" || $row["id"] != $this->diafan->_user->id))
		{
			$text .= '<a href="javascript:void(0);" title="'.($row["act"] ? _ADMIN_BLOCK : _ADMIN_UNBLOCK).'" action="'.($row["act"] ? 'un' : '').'block">'
				.'<img src="'.BASE_PATH.'adm/img/'.($row["act"] ? 'unblock' : 'block').'.gif"></a> ';
		}
		//del|trash
		if ($this->config_module["del"]
			&& ($this->table != "trash" || ! $row["parent_id"])
			&& ! $this->diafan->admin_roles('del') 
			&& ($this->table != "language" || $row["id"] != 1)
			&& ($this->table != "menu_category" || $row["id"] != 1)
			&& ($this->table != "users" || $this->diafan->_user->id != $row["id"]))
		{
			$text .= '<a href="javascript:void(0);" title="'._LANG_DELETE.'"'
				.' confirm="'.($this->config_module["trash"]
				     ?
				     (! empty($row["count_children"]) ? _ADMIN_CONFIRM_TRASH_PARENT : _ADMIN_CONFIRM_TRASH)
				     :
				     (! empty($row["count_children"]) ? _ADMIN_CONFIRM_DELETE_PARENT : _ADMIN_CONFIRM_DELETE)
				    ).'" action="'.($this->config_module["trash"] ? 'trash' : 'delete').'">'
				.'<img src="'.BASE_PATH.'adm/img/delete.gif"></a>';
		}
		/*//sort
		if ((! $this->config_module["element_multiple"] || $this->diafan->cat)
			&& (! $this->config_module["element_site"] || $this->diafan->site)
			&& $this->config_module["order"] && ! $this->diafan->admin_roles('order')
			&& (! $this->config_module["act"] || $row["act"]))
		{
			//up
			if ($this->k != 2 || $this->diafan->page > 1)
			{
				$text .= '<a href="javascript:void(0);" title="'._ADMIN_UP.'" action="up"><img src="'.BASE_PATH.'adm/img/up.gif"></a> ';
			}
			//down
			if ($this->k < ($this->count_order + 1 - (($this->diafan->page ? $this->diafan->page : 1) - 1) * $this->nastr))
			{
				$text .= '<a href="javascript:void(0);" title="'._ADMIN_DOWN.'" action="down"><img src="'.BASE_PATH.'adm/img/down.gif"></a> ';
			}
		}*/
		//show
		
		
		if ($this->config_module["menu"] && $row["act"] && (! $this->config_module["view"] || ! $row["block"]))
		{
			$text .= '<a href="'.BASE_PATH._SHORTNAME.$row["view_link"].'" title="'._ADMIN_SHOW_PAGE_SITE.'" target="_blank">'
			.'<img src="'.BASE_PATH.'adm/img/show.gif" alt="'._ADMIN_SHOW_PAGE_SITE.'"></a> ';
		}
		$text .= '</nobr></span></div>';
		if ($this->config_module["order"] && empty($row["sort"]))
		{
			DB::query("UPDATE {".$this->table."} SET sort=id WHERE id=%d", $row["id"]);
		}
		return $text;
	}

	/**
	 * Выводит кнопки для групповых операций и постраничную навигацию
	 *
	 * @param array $links ссылки для постраничной навигации
	 * @param integer $nen количество  элементов в списке
	 * @param integer $id родитель текущего уровня
	 * @return boolean true
	 */
	private function group_actions($links, $id)
	{
		if (! $this->group_actions)
		{
			return FALSE;
		}
		if (! $id || ! $this->config_module["parent"])
		{
			$count = 0;
			if ($this->config_module["date"])
			{
				$count++;
			}
			if ($this->config_module["datetime"])
			{
				$count++;
			}
			if ($this->config_module["element_site"])
			{
				$count++;
			}
			if ($this->config_module["image"])
			{
				$count++;
			}
			$count += count($this->config_other_row) + ($this->config_module["element"] ? 1 : 0);
			$count_group = 3;
			if ($count > 3)
			{
				$count_group = $count - 3 + 3;
				$count = 3;
			}
			echo '<tr>
				<td align="center" colspan="'.$count.'">
					'.$this->diafan->_tpl->get('get_admin', 'paginator', $links).'
				</td>
				<td colspan="'.$count_group.'" align="right">'.(! $id || ! $this->config_module["parent"] ? ' '._ADMIN_CHECK_ALL.': <input type="checkbox" name="check_all" value="1">' : '').'</td>
			</tr>
			<tr>
				<td align="right" colspan="'.($count + $count_group).'" class="group_actions">
					'._ADMIN_GROUP_ACTION.': '
					.($this->config_module["act"] && ! $this->diafan->admin_roles('act') && $this->table != "users"
					?
					       '<a href="javascript:void(0)" title="'._ADMIN_UNBLOCK.'" action="block">'
					       .'<img src="'.BASE_PATH.'adm/img/unblock.gif"></a> '
					       .'<a href="'.URL.'" title="'._ADMIN_BLOCK.'" action="unblock">'
					       .'<img src="'.BASE_PATH.'adm/img/block.gif"></a> '
					: '')
	       
				       .($this->config_module["del"] && ! $this->diafan->admin_roles('del') 
				       ?
					    '<a href="javascript:void(0)" title="'._LANG_DELETE.'" action="'.($this->config_module["trash"] ? 'trash' : 'delete').'"
						confirm="'.($this->config_module["trash"] ?  _ADMIN_CONFIRM_TRASH : _ADMIN_CONFIRM_DELETE).'">'
					       .'<img src="'.BASE_PATH.'adm/img/delete.gif"></a>'
				       : '')
	       
				       .($this->table == "trash" 
				       ?
					       '<a href="javascript:void(0)" title="'._LANG_RESTORE.'" action="restore">'._LANG_RESTORE.'</a>'
				       : '')
				.'</td>
			</tr>
		';
		}
		elseif ($links)
		{
			echo '<tr>
				<td align="center" colspan="7">
					'.$this->diafan->_tpl->get('get_admin', 'paginator', $links).'
				</td>
			</tr>';
		}
		return TRUE;
	}

	/**
	 * Выводит ссылку на добавление элемента
	 *
	 * @param string $text текст ссылки "Добавить элемент"
	 * @return boolean true
	 */
	protected function addnew_init($text)
	{
	    
		echo '
		<div class="add">
			<a href="'.URL;
		if($this->config_module['element_site'] && strpos(URL,'site') === false && !empty($this->diafan->site))
		{
		    echo 'site'.$this->diafan->site.'/';
		}
		echo 'addnew1/" title="'.$text.'">'.$text.'</a>
		</div>';
		return TRUE;
	}
}