<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Config
 * Набор функций для работы c параметрами сайта
 */
class Config
{
	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct(){}

	/**
	 * Сохраняет параметры сайта
	 *
	 * @param array $new_values новые значения параметров сайта
	 * @param array $language_all языки сайта
	 * @return boolean true
	 */
	static public function save($new_values, $language_all)
	{
		/*$fields = array('DB_URL', 'DB_PREFIX', 'DB_CHARSET', 'EMAIL_CONFIG', 'HTMLEDITOR', 'USERFILES', 'LANGUAGE_BASE', 'VERSION_CMS', 'DATE_UPDATE',
						'DIAFAN_CODE', 'ADMIN_FOLDER', 'USERADMIN', 'MOD_DEVELOPER', 'MOD_DEVELOPER_CACHE', 'MOD_DEVELOPER_PROFILING', 'FTP_HOST', 'FTP_DIR',
						'FTP_LOGIN', 'FTP_PASSWORD', 'SMTP_MAIL', 'SMTP_HOST', 'SMTP_LOGIN', 'SMTP_PASSWORD', 'SMTP_PORT', 'ROUTE_END', 'ROUTE_AUTO_MODULE',
						'ROBOX_LOGIN', 'ROBOX_PASS_1', 'ROBOX_PASS_2', 'ROBOX_PASS_2', 'WM_SECRET', 'WM_SECRET', 'WM_TARGET', 'TIMEZONE');
		*/
		$fields = array('DB_URL', 'DB_PREFIX', 'DB_CHARSET', 'EMAIL_CONFIG', 'HTMLEDITOR', 'USERFILES', 'LANGUAGE_BASE', 'VERSION_CMS', 'DATE_UPDATE',
						'DIAFAN_CODE', 'ADMIN_FOLDER', 'USERADMIN', 'MOD_DEVELOPER', 'MOD_DEVELOPER_CACHE', 'MOD_DEVELOPER_PROFILING', 'FTP_HOST', 'FTP_DIR',
						'FTP_LOGIN', 'FTP_PASSWORD', 'SMTP_MAIL', 'SMTP_HOST', 'SMTP_LOGIN', 'SMTP_PASSWORD', 'SMTP_PORT', 'ROUTE_END', 'ROUTE_AUTO_MODULE',
						 'TIMEZONE');
		foreach ($language_all as $l => $langarr)
		{
			$fields[] = 'TIT'.$langarr[0];
		}
		foreach ($fields as $field)
		{
			if (! isset($new_values[$field]))
			{
				$new_values[$field] = defined($field) ? constant($field): '';
			}
		}
		$text = '<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined(\'DIAFAN\'))
{
	include(dirname(__FILE__).\'/includes/404.php\');
}
define("REVATIVE_PATH", "'.REVATIVE_PATH.'");
//папка, в которой лежит сайт. Для корня домена оставьте пустым

';
		foreach ($language_all as $l => $langarr)
		{
			$text .= '
define("TIT'.$langarr[0].'", "'.$new_values["TIT".$langarr[0]].'");
//название сайта, добавляется к тегу title в конце через -

';
		}
		$text.='

define("DB_URL", "'.$new_values["DB_URL"].'");
//параметры подключения к БД

define("DB_PREFIX", "'.$new_values["DB_PREFIX"].'");
//префикс таблиц сайта в БД

define("DB_CHARSET", "'.$new_values["DB_CHARSET"].'");
//кодировка БД


define("EMAIL_CONFIG", "'.$new_values["EMAIL_CONFIG"].'");
//главный ящик администратора, владельца сайта, используется по умолчанию во всех уведомлениях

define("HTMLEDITOR", '.($new_values["HTMLEDITOR"] ? 'TRUE' : 'FALSE').');
//использовать ли визуальный редактор TRUE/FALSE (да/нет)

define("USERFILES", "'.$new_values["USERFILES"].'");
//название папки с визуальным редактором

define("LANGUAGE_BASE", "'.$new_values["LANGUAGE_BASE"].'");
//язык, используемый по умолчанию при загрузке сайта

define("VERSION_CMS", "'.$new_values["VERSION_CMS"].'");
//версия diafan.CMS

define("DATE_UPDATE", "'.$new_values["DATE_UPDATE"].'");
//дата последнего автообновления в UNIX-формате

define("DIAFAN_CODE", "'.$new_values["DIAFAN_CODE"].'");
//код обновления

define("ADMIN_FOLDER", "'.$new_values["ADMIN_FOLDER"].'");
//ЧПУ папки панели администрирования

define("USERADMIN", '.($new_values["USERADMIN"] ? 'TRUE' : 'FALSE').');
//использовать редактирование сайта с пользовательской части TRUE/FALSE (да/нет)

define("MOD_DEVELOPER", '.($new_values["MOD_DEVELOPER"] ? 'TRUE' : 'FALSE').');
//включить режим разработки, когда на сайт выводятся все возможные ошибки TRUE/FALSE (да/нет)

define("MOD_DEVELOPER_TECH", '.($new_values["MOD_DEVELOPER_TECH"] ? 'TRUE' : 'FALSE').');
//включить режим технического обслуживания сайта, сайт станет недоступен для пользователей (шаблон оформления сообщения в /themes/tech.php) TRUE/FALSE (да/нет)

define("MOD_DEVELOPER_CACHE", '.($new_values["MOD_DEVELOPER_CACHE"] ? 'TRUE' : 'FALSE').');
//отключить кеширование TRUE/FALSE (да/нет)

define("MOD_DEVELOPER_PROFILING", '.($new_values["MOD_DEVELOPER_PROFILING"] ? 'TRUE' : 'FALSE').');
//выводить запросы к БД на сайте TRUE/FALSE (да/нет)


define("FTP_HOST", "'.$new_values["FTP_HOST"].'");
//адрес ftp текущего сайта

define("FTP_DIR", "'.$new_values["FTP_DIR"].'");
//путь к diafan.CMS, после входа ftp-пользователя, например, www/site.ru/docs/

define("FTP_LOGIN", "'.$new_values["FTP_LOGIN"].'");
//имя ftp-пользователя

define("FTP_PASSWORD", "'.$new_values["FTP_PASSWORD"].'");
//пароль ftp-пользователя


define("SMTP_MAIL", '.($new_values["SMTP_MAIL"] ? 'TRUE' : 'FALSE').');
//использовать smtp-авторизацию при отправке почтовых сообщений TRUE/FALSE (да/нет)

define("SMTP_HOST", "'.$new_values["SMTP_HOST"].'");
//url почтового сервера (например, http://mail.ru/)

define("SMTP_LOGIN", "'.$new_values["SMTP_LOGIN"].'");
//логин почты

define("SMTP_PASSWORD", "'.$new_values["SMTP_PASSWORD"].'");
//пароль к почте

define("SMTP_PORT", "'.$new_values["SMTP_PORT"].'");
//порт (по умолчанию 25)


define("TIMEZONE", "'.$new_values["TIMEZONE"].'");
//часовой пояс сайта, в формате http://www.php.net/manual/en/timezones.php

define("ROUTE_END", "'.$new_values["ROUTE_END"].'");
//конец строки ЧПУ, по умолчанию "/". Можно ввести ".htm"

define("ROUTE_AUTO_MODULE", '.($new_values["ROUTE_AUTO_MODULE"] ? 'TRUE' : 'FALSE').');
//использовать автоматическое формирование ЧПУ для модулей TRUE/FALSE (да/нет)

';
		/*
.($new_values["ROBOX_LOGIN"] ? '
define("ROBOX_LOGIN", "'.$new_values["ROBOX_LOGIN"].'");
' : '').($new_values["ROBOX_PASS_1"] ? '
define("ROBOX_PASS_1", "'.$new_values["ROBOX_PASS_1"].'");
' : '').($new_values["ROBOX_PASS_2"] ? '
define("ROBOX_PASS_2", "'.$new_values["ROBOX_PASS_2"].'");
' : '').($new_values["WM_SECRET"] ? '

define("WM_SECRET", "'.$new_values["WM_SECRET"].'");
' : '').($new_values["WM_TARGET"] ? '
define("WM_TARGET", "'.$new_values["WM_TARGET"].'");' : '');*/

		$fp = fopen(ABSOLUTE_PATH."config.php", "w");
		fwrite($fp, $text);
		fclose($fp);
		return TRUE;
	}
}