<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Adminsite_admin
 *
 * Редактирование страниц административной части сайта
 */
class Adminsite_admin extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'adminsite';

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'adminsite';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		//поля в базе данных для редактирования	
		$this->variable_table = array(
			'name'      => 'text',
			'rewrite'   => 'text',
			'group_id'  => 'select',
			'act'       => 'checkbox',
			'parent_id' => 'select',
			'text'      => 'editor'
		);

		$this->config_module = array(
			'parent' => 1, //содержит вложенности
			'act'    => 1, //показать/скрыть
			'del'    => 1, //удалить
			'order'  => 1
		);

		$this->select_arr["group_id"] = array(1 => _ADMIN_GROUP_MENU_1, 2 => _ADMIN_GROUP_MENU_2, 3 => _ADMIN_GROUP_MENU_3);
	}

	/**
	 * Выводит контент модуля
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->addnew_init(_ADMIN_ADMINSITE_ADD);
		echo '<table class="list">';
		$this->list_row();
		echo '</table>';

		return TRUE;
	}

	/**
	 * Редактирование поля "Псевдоссылка"
	 * 
	 * @return boolean
	 */
	protected function edit_rewrite_module()
	{
		echo '
		<tr'.$this->get_other().' valign="top">
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<input type="text" name="'. $this->key.'" size="40" value="'
				.(! $this->diafan->addnew ? str_replace('"', '&quot;', $this->value) : '')
				.'">
				'.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Сохранение поля "Псевдоссылка"
	 * 
	 * @return boolean
	 */
	protected function save_rewrite_module()
	{
		$this->query[] = "rewrite='%h'";
		$this->value[] = $_POST["rewrite"];
		return TRUE;
	}
}