<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Basket_ajax
 *
 * Обработка запроса при пересчете суммы покупки в корзине товаров
 */
class Basket_ajax extends Model
{
	/**
	 * @var object основной объект системы
	 */
	public $diafan;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
	}

	/**
	 * Обрабатывает полученные данные из формы
	 * 
	 * @return boolean
	 */
	public function ajax_request()
	{
		if (! empty($_POST['module']) && $_POST['module'] == 'basket' && $this->diafan->module == 'basket' && (! $this->diafan->configmodules('security_user', 'shop') || $this->diafan->_user->id))
		{
			$summ  = 0;
			$count = 0;
                        if(!empty($_SESSION["basket"])) {
			foreach ($_SESSION["basket"] as $good_id => $array)
			{
				foreach ($array as $param => $c)
				{
					if (! empty($_POST['del'.$good_id.'_'.$param]) || empty($_POST['editshop'.$good_id.'_'.$param]))
					{
						unset($_SESSION["basket"][$good_id][$param]);
					}
					else
					{
						$edit_count = intval($_POST['editshop'.$good_id.'_'.$param]);
						if ($edit_count <= 0)
						{
							unset($_SESSION["basket"][$good_id][$param]);
							continue;
						}
						if (! isset($c["param"]["depend"]))
						{
							$c["param"]["depend"] = 0;
						}
						if (empty($cache[$good_id." ".$c["param"]["depend"]]))
						{
							$row = DB::fetch_array(DB::query("SELECT price, count_goods FROM {shop_price} WHERE good_id=%d AND param_value=%d", $good_id, $c["param"]["depend"]));
							$cache[$good_id." ".$c["param"]["depend"]] = $row;
						}
						else
						{
							$row = $cache[$good_id." ".$c["param"]["depend"]];
						}
						$this_not_good = FALSE;
						if ($edit_count > $_SESSION["basket"][$good_id][$param]["count"])
						{
							$this_not_good = $this->check_count_good($good_id, $c["param"]["depend"], $row["count_goods"]);
							if ($this_not_good)
							{
								$not_goods = TRUE;
							}
						}
						if (! $this_not_good)
						{
							$_SESSION["basket"][$good_id][$param]["count"] = $edit_count;
						}
						else
						{
							$edit_count = $_SESSION["basket"][$good_id][$param]["count"];
						}
                                                $row['id']=$good_id;
                                                $this->diafan->_shop->pricing($row);
						//$discount = $this->get_discount($good_id);
						//$row["price"] = $row["price"] * (100 - $discount) / 100;
						$summ += $row["price"] * $edit_count;
                                               
						$count += $edit_count;
					}
				}
			}
                        }
			if (! empty($not_goods))
			{
				$json["error"] = _LANG_NOT_GOODS;
			}
			else
			{
				$json["error"] = _LANG_CHANGES_SAVED;
			}
                        $_SESSION["basket_delivery"]=intval(preg_replace('/\D/','',$_POST['delivery']));
                        //$summ +=DB::title('shop_delivery', $_SESSION["basket_delivery"], 'price');
                        
			$_SESSION["basket_summ"]  = $summ;
			$_SESSION["basket_count"] = $count;
			$json["basket"] = $summ;
			$json["basketcount"] = $count;

			if (! empty($_POST['ajax']))
			{
				include_once(ABSOLUTE_PATH.'modules/basket/basket.model.php');
				$model  = new Basket_model($this->diafan);
				$result = $model->form();
                               
				$json["table"] = $this->diafan->_tpl->get('table_basket', 'basket', $result);
				if (! $count)
				{
					$json["empty"] = 1;
				}

				include_once(ABSOLUTE_PATH.'plugins/json.php');
				echo to_json($json);
			}
			else
			{
				$this->diafan->redirect($this->diafan->_route->current_link().'?error=basket&error='.$json["error"]);
			}
			return TRUE;
		}
		return FALSE;
	}

/**
	 * Определяет скидку на товар
	 *
	 * @param array $row данные о товаре
	 * @return float
	 */
	private function get_discount($id)
	{
		// выбираем все скидки, актуальные на текущий момент
		$discounts = array();
		$result = DB::query("SELECT id, discount FROM {shop_discount} WHERE trash='0' AND act='1' AND (date_start='0' OR date_start<=%d) AND (date_finish='0' OR date_finish>=%d)", time(), time());
		while ($dis = DB::fetch_array($result))
		{
			$discounts[$dis["id"]] = $dis["discount"];
		}
		if ($discounts)
		{
			// проверяем установлена ли скидка на товар
			$discount = DB::query_result("SELECT discount_id FROM {shop_discount_object} WHERE good_id=%d AND discount_id IN (%h) ORDER BY id ASC LIMIT 1", $id, implode(",", array_keys($discounts)));
			if ($discount)
			{
				return $discounts[$discount];
			}
			$cat_id = DB::query_result("SELECT cat_id FROM {shop} WHERE id=%d", $id);

			// проверяем установлена ли скидка на категорию
			if ($cat_id)
			{
				$discount = DB::query_result("SELECT discount_id FROM {shop_discount_object} WHERE cat_id=%d AND discount_id IN (%h) ORDER BY id ASC LIMIT 1", $cat_id, implode(",", array_keys($discounts)));
				if ($discount)
				{
					return $discounts[$discount];
				}
			}

			// проверяем установлена ли скидка на все товары
			$discount = DB::query_result("SELECT discount_id FROM {shop_discount_object} WHERE cat_id=0 AND good_id=0 AND discount_id IN (%h) ORDER BY id ASC LIMIT 1", implode(",", array_keys($discounts)));
			if ($discount)
			{
				return $discounts[$discount];
			}
		}
		return 0;
	}

	/**
	 * Определяет превышает ли количество заказанного товара количества товара на складе
	 *
	 * @param integer $id номер товара
	 * @param integer $param_id номер зависимой характеристики
	 * @param integer $count_goods количество товара на складе
	 * @return boolean
	 */
	private function check_count_good($id, $param_id, $count_goods)
	{
		if (! $this->diafan->configmodules('use_count_goods', 'shop'))
		{
			return FALSE;
		}
		$count = 0;
		foreach ($_SESSION["basket"] as $good_id => $array)
		{
			foreach ($array as $param => $c)
			{
				$edit_count = intval($_POST['editshop'.$good_id.'_'.$param]);
				if ($good_id == $id && (empty($c["param"]["depend"]) && ! $param_id || $param_id == $c["param"]["depend"]))
				{
					$count += $edit_count;
				}
			}
		}
		return $count > $count_goods;
	}
}
