<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Basket
 *
 * Контроллер модуля "Корзина товаров"
 */
class Basket extends Controller
{
	/**
	 * Инициализация модуля
	 * 
	 * @return void
	 */
	public function init()
	{
		$model = new Basket_model($this->diafan);
		$this->result = $model->form();
	}

	/**
	 * Выводит контент модуля
	 * 
	 * @return boolean true
	 */
	public function show_module()
	{
                if ($this->diafan->configmodules('not_buy', 'shop') || ($this->diafan->configmodules('security_user', 'shop') && ! $this->diafan->_user->id))
			return FALSE;
		
                $this->diafan->_tpl->get('form', 'basket', $this->result);
		return TRUE;
	}

	/**
	 * Шаблонная функция: количество товаров в корзине
	 * 
	 * @param array $attributes атрибуты шаблонного тэга
	 * @return boolean
	 */
	public function show_basket($attributes)
	{
                
		if ($this->diafan->configmodules('not_buy', 'shop') || ($this->diafan->configmodules('security_user', 'shop') && ! $this->diafan->_user->id))
			return FALSE;

		$attributes = $this->get_attributes($attributes, 'template');

		include_once(ABSOLUTE_PATH.'modules/basket/basket.model.php');
		$model = new Basket_model($this->diafan);
		$result = $model->show_basket();

		if (! $attributes["template"] || ! $this->diafan->_tpl->get('show_basket_'.$attributes["template"], 'basket', $result))
		{
			$this->diafan->_tpl->get('show_basket', 'basket', $result);
		}
		return TRUE;
	}
}