<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN')) {
    include(dirname(dirname(dirname(__FILE__))) . '/includes/404.php');
}

/**
 * Basket_view
 *
 * Шаблон модуля "Корзина товаров"
 */
class Basket_view extends View {

    /**
     * Шаблон вывода формы редактирования корзины товаров
     * 
     * @param array $result данные, сгенерированные в моделе
     * @return boolean true
     */
    public function form($result) {
        echo '<script type="text/javascript" src="' . BASE_PATH . 'modules/basket/basket.js"></script>';

		echo '<form action="" method="POST" enctype="multipart/form-data" class="basket_form">
		<input type="hidden" name="module" value="basket">
		<input type="hidden" name="ajax" value="">
		<div class="errors error"' . ($result["error"] ? '>' . $result["error"] : ' style="display:none">') . '</div>
		<div class="basket_table">';
		
		echo self::table_basket($result); //вывод таблицы с товарами
		
		echo '</div>';
        
		if(!empty($_SESSION["basket_count"])) {
            
			echo '<div class="basket_recalc">';
			echo '<span class="button_wrap"><input type="submit" class="button" value="' . $this->_('RECALCULATE', FALSE) . '"></span>'; // кнопка пересчитать
			echo '</div>';
		}
		
		if (!empty($result["to_order"])) {
            echo '<div class="to_order" '.(empty($_SESSION['basket_delivery'])?'style="display:none"':'').'>';  //кнопка "оформить заказ"
			echo '<a href="' . $result["to_order"] . '">'; //ссылка на страницу заказа, авторизации и регистрации
			//echo '<a href="' . $result["to-step-2"] . '">'; //ссылка на быстрое оформление заказа
			echo $this->_('ORDER');
			echo '</a>';
			echo '</div>';
			
        }
		
        echo '</form>';

        return TRUE;
    }

    /**
     * Шаблон вывода таблицы с товарами в корзине
     * 
     * @param array $result данные, сгенерированные в моделе
     * @return boolean true
     */
    public function table_basket($result) {
        //шапка таблицы
        $text = '<table class="basket">
			<tr>
				<th class="basket_first_th"></th>
				<th>' . $this->_('NAME_GOOD') . '</th>
				<th>' . $this->_('COUNT') . '</th>
				<th>' . $this->_('PRICE') . ', ' . $result["currency"] . '</th>
				<th>' . $this->_('SUM') . ', ' . $result["currency"] . '</th>
				<th class="basket_last_th">' . $this->_('DELETE') . '</th>
			</tr>';
        //товары
        if (!empty($result["rows"])) {
            foreach ($result["rows"] as $row) {
                $text .= '
				<tr>
					<td class="basket_img">';
                if (!empty($row["img"])) {
                    $text .= '<a href="' . BASE_PATH_HREF . $row["link"] . '"><img src="' . $row["img"]["src"] . '" width="' . $row["img"]["width"] . '" height="' . $row["img"]["height"] . '" alt="' . $row["img"]["alt"] . '" title="' . $row["img"]["title"] . '"></a> ';
                }
                $text .= '</td>
					<td class="basket_name"><a href="' . BASE_PATH_HREF . $row["link"] . '">' . $row["name"] . (!empty($row["article"]) ? '<br/>' . _LANG_ARTICLE . ': ' . $row["article"] : '') . '</a></td>
					<td class="basket_count"><input type="text" value="' . $row["count"] . '" name="editshop' . $row["id"] . '" class="inpnum" size="2"></td>
					<td class="basket_price">' . $row["price"] . '</td>
					<td class="basket_summ">' . $row["summ"] . '</td>
					<td class="basket_delete"><input type="checkbox" name="del' . $row["id"] . '" value="1"></td>
				</tr>';
            }

            //способы доставки
            
            if (!empty($result["delivery"])) {
                $d=0;
                $price=$result["delivery"][0]['price'];
                $text.='<tr><td colspan="4" align="right">
		    
' . $this->_('DELIVERY') . ': <select name="delivery" rel="'.$result["summ_goods"].'" class="delivery">';
                if(!empty($_SESSION["basket_delivery"])) $d=$_SESSION["basket_delivery"];
                
                foreach ($result["delivery"] as $r) {
                    
                    $text.='<option value="' . $r['id'] . '" title="' . $r['text'] . '" act="'.$r['amount'].'" rel="' . $r['price'] . '"';
                    if($r['id']==$d) {$text.=' selected'; $price=$r['price'];}
                    $text.='>' . $r['name'] . '</option>';
                }
                $text.='</select></td>
                       <td class="basket_summ" id="delivery_price">' . $price . '</td>
                       <td></td>
</tr>';
            }
        }


        //итоговая строка таблицы
        $text .= '
			<tr class="basket_last_tr">
				<td class="basket_total" colspan="2">' . $this->_('GOODS_TOTAL') . '</td>
				<td class="basket_count">' . $result["count"] . '</td>
				<td>&nbsp;</td>
				<td class="basket_summ">' . $result["summ"] . '</td>
				<td class="basket_last_td">&nbsp;</td>
			</tr>
		</table>';
        return $text;
    }

    /**
     * Шаблонная функция: выводит информацию о заказанных товарах
     * 
     * @param array $result данные, сгенерированные в моделе
     * @return boolean true
     */
    public function show_basket($result) {
		
		echo '<div class="basket_right">';
		echo '<div class="basket_right_top"></div>';
		echo '<div class="basket_right_bottom"></div>';
	    echo '<div class="basket_block">
			<a href="' . $result["link"] . '">' . $this->_('BASKET') . '</a>';
        echo sprintf($this->_('OF_GOODS_FOR_SUM'), ' <span class="basket_count">' . $result["count"] . '</span> ', ' <span class="basket_summ">' . $result["summ"] . '</span>&nbsp;' . $result["currency"]
        );
        echo '</div>';
		echo '</div>';

        return TRUE;
    }

}