<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Clauses
 *
 * Контроллер модуля "Статьи"
 */
class Clauses extends Controller
{
	/**
	 * Инициализация модуля
	 * 
	 * @return void
	 */
	public function init()
	{
		$this->rewrite_variable_names = array('page', 'show', 'cat');
		if ($this->diafan->configmodules("comments") || $this->diafan->configmodules("comments_cat") && ! $this->diafan->show && $this->diafan->cat)
		{
			$this->rewrite_variable_names[] = 'comments';
		}
		$this->diafan->rewrite_variable_names = $this->rewrite_variable_names;
		
		$model = new Clauses_model($this->diafan);
		
		if ($this->diafan->show)
		{
			$this->result = $model->id();
		}
		elseif (! $this->diafan->configmodules("cat"))
		{
			$this->result = $model->list_();
		}
		elseif (! $this->diafan->cat)
		{
			$this->result = $model->first_page();
		}
		else
		{
			$this->result = $model->list_category();
		}
		$this->get_global_variables();
	}

	/**
	 * Выводит контент модуля
	 * 
	 * @return boolean true
	 */
	public function show_module()
	{
		if ($this->diafan->show)
		{
			$this->diafan->_tpl->get('id', 'clauses', $this->result);
		}
		elseif ($this->diafan->configmodules("cat") && ! $this->diafan->cat && !$this->diafan->year && !$this->diafan->month)
		{
			$this->diafan->_tpl->get('first_page', 'clauses', $this->result);
		}
		else
		{
			if (empty($this->result["level"]) || ! $this->diafan->_tpl->get('list_level_'.$this->result["level"], 'clauses', $this->result))
			{
				$this->diafan->_tpl->get('list_', 'clauses', $this->result);
			}
		}
		return TRUE;
	}

	/**
	 * Шаблонная функция: блок статей
	 * 
	 * @param array $attributes атрибуты шаблонного тэга
	 * @return boolean
	 */
	public function show_block($attributes)
	{
		$attributes = $this->get_attributes($attributes, 'count', 'cat_id', 'images', 'sort', 'site_id', 'template');
		
		$count   = $attributes["count"] ? intval($attributes["count"]) : 3;
		$cat_id  = intval($attributes["cat_id"]);
		$site_id = intval($attributes["site_id"]);
		$sort    = $attributes["sort"] == "date" || $attributes["sort"] == "rand" ? $attributes["sort"] : "date";
		$images  = intval($attributes["images"]);

		include_once(ABSOLUTE_PATH.'modules/clauses/clauses.model.php');
		$model = new Clauses_model($this->diafan);
		$result = $model->show_block($count, $cat_id, $images, $sort, $site_id);

		if (! $attributes["template"] || ! $this->diafan->_tpl->get('show_block_'.$attributes["template"], 'clauses', $result))
		{
			$this->diafan->_tpl->get('show_block', 'clauses', $result);
		}
		return TRUE;
	}
}