<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Comments_admin_param
 *
 * Конструктор комментариев
 */
class Comments_admin_param extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'commentsparam';

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'comments_param'; 
        
        private $module = '';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
                
                $this->module=!empty ($_GET["module"])?(string)preg_replace('/[^A-Za-z_]+/', '', $_GET["module"]):'';

		//поля в базе данных для редактирования
		$this->variable_table = array(
                        'module_name'=>'function',
			'name'     => 'text',
			'type'     => 'select',
			
			'required' => 'checkbox',
			'param'    => 'function',
                        
                        
			//'sort'     => 'function',
			'text'     => 'editor'
		);



		//переводимые поля
		$this->language_names = array(
			'name',
			'text'
		);

		$this->config_module = array(
			'del'          => 1,	//удалить
			'order'        => 1,	//сортируется
			'trash'        => 1 	//использовать корзину
		);

		//выводить в списке содержание полей:
		$this->config_other_row = array(
			'type',
			'module_name'
		);

		$this->select_arr["type"] = array(
			"text"     => _ADMIN_PARAM_TEXT_FIELD,
			"numtext"  => _ADMIN_PARAM_NUMTEXT_FIELD,
			"date"     => _ADMIN_PARAM_DATE_FIELD,
			"textarea" => _ADMIN_PARAM_TEXTAREA_FIELD,
			"checkbox" => _ADMIN_PARAM_CHECKBOX_FIELD,
			"select"   => _ADMIN_PARAM_SELECT_FIELD,
			"multiple" => _ADMIN_PARAM_MULTIPLE_FIELD,
			"email"    => _ADMIN_PARAM_EMAIL_FIELD
		);

		
	}
        
        protected function select_modules($module) {
            $array=array(''=>_LANG_ALL);
            
            echo '<option value="">'._LANG_ALL.'</option>';
            $result=DB::query("SELECT DISTINCT e.[name], o.module_name FROM {config} AS o INNER JOIN {adminsite} AS e ON o.module_name = e.rewrite WHERE o.name = 'comments' AND o.value = '1' AND e.parent_id = '0'");
            while ($row = DB::fetch_array($result))
            {
                $array[$row['module_name']]=$row['name'];
                echo '<option '.(($module==$row['module_name'])?'selected':'').' value="'.$row['module_name'].'">'.$row['name'].'</option>';
            }
            return $array;
        }

	/**
	 * Выводит список полей формы
	 * @return boolean true
	 */
	public function show_module()
	{
           
            if($this->module) $this->where=" AND module_name='".$this->module."'";
            
            echo '<script type="text/javascript" src="'.BASE_PATH.'modules/comments/admin/comments.admin.param.js"></script>
            <p>'._ADMIN_MODULE_NAME.': <select rel="'.path_module($this->diafan, 0, 0, 0, 1, 1).'" class="inpselect" name="module" id="select_module">';
            
            $this->select_arr["modules"]=$this->select_modules($this->module);
            
            echo '</select></p>';
			
		echo '<div class="add">
			<a href="'.URL.'addnew1/'.($this->module?'?module='.$this->module:'').'" title="'._ADMIN_FEEDBACK_ADD_PARAM.'">'._ADMIN_FEEDBACK_ADD_PARAM.'</a>
		</div>'; 
		
		echo '<table class="list">';
		$this->list_row();
		echo '</table>';

		return TRUE;
	}

	/**
	 * Вывод типа поля в списке полей
	 * @return string
	 */
	protected function other_row_type($row)
	{
		return '</td><td>'.$this->select_arr["type"][$row["type"]];
	}
        
        /**
	 * Вывод типа поля в списке полей
	 * @return string
	 */
	protected function other_row_module_name($row)
	{
		return '</td><td class="parent_name">'.$this->select_arr["modules"][$row["module_name"]];
	}

	
        
        /**
	 * Редактирование поля "Модуль"
	 * @return boolean true
	 */
        protected function edit_module_name_module()
        {
            echo '<tr valign="top"><td class="td_first">'._ADMIN_MODULE_NAME.'</td><td><select name="'.$this->key.'">';
            $this->select_modules(($this->diafan->addnew==1?$this->module:$this->value));
            echo '</select></td></tr>';
            return TRUE;
        }

	/**
	 * Редактирование поля "Параметры"
	 * @return boolean true
	 */
	protected function edit_param_module()
	{
		$value = array();
		if (empty($this->values["type"]))
		{
			$this->values["type"] = '';
		}
		if (! $this->diafan->addnew && in_array($this->values["type"], array('select', 'multiple', 'checkbox')))
		{
			$result_select = DB::query("SELECT [name], value, id FROM {comments_param_select} WHERE param_id=%d ORDER BY sort ASC", $this->diafan->edit);
			while ($row_select = DB::fetch_array($result_select))
			{
				if ($this->values["type"] == 'checkbox')
				{
					$value[$row_select["value"]] = $row_select["name"];
				}
				else
				{
					$value[$row_select["id"]] = $row_select["name"];
				}
			}
		}

		echo '
		<script type="text/javascript" src="'.BASE_PATH.'modules/feedback/admin/feedback.admin.param.js"></script>

		<tr id="param" valign="top">
			<td class="td_first">'.$this->variable_names().'</td>
			<td>
			<table>';

		$fileds = false;
		$m = 1;
		if (in_array($this->values["type"], array('select', 'multiple')))
		{
			foreach ($value as $k => $v)
			{
				echo '
				<tr class="param">
					<td>
						<input type="hidden" name="param_id[]" value="'.$k.'" class="param_id">
						<input type="text" name="paramv[]" size="40" value="'.str_replace('"', '&quot;', $v).'">
						<span class="param_actions">
							<a href="javascript:void(0)" action="delete_param" confirm="'._ADMIN_CONFIRM_DELETE.'">
								<img src="'.BASE_PATH.'adm/img/delete.gif" width="15" height="15" alt="'._LANG_DELETE.'">
							</a>
							<a href="javascript:void(0)" action="up_param">
								<img src="'.BASE_PATH.'adm/img/up.gif" width="14" height="16" alt="'._ADMIN_UP.'">
							</a>
							<a href="javascript:void(0)" action="down_param">
								<img src="'.BASE_PATH.'adm/img/down.gif" width="14" height="16" alt="'._ADMIN_DOWN.'">
							</a>
						</span>
					</td>
				</tr>';
				$m++;
				$fileds = true;
			}
		}
		if (! $fileds)
		{
			echo '
			<tr class="param">
				<td>
					<input type="text" name="paramv[]" size="40" value="">
					<span class="param_actions">
						<a href="javascript:void(0)" action="delete_param" confirm="'._ADMIN_CONFIRM_DELETE.'">
							<img src="'.BASE_PATH.'adm/img/delete.gif" width="15" height="15" alt="'._LANG_DELETE.'">
						</a>
					</span>
				</td>
			</tr>';
		}
		echo '</table>
				<a href="javascript:void(0)" class="param_plus" title="'._LANG_ADD.'"><img src="'.BASE_PATH.'adm/img/add.gif" width="16" height="16" alt="'._LANG_ADD.'"></a>
			</td>
		</tr>
		<tr id="param_check">
			<td class="td_first">'.$this->variable_names().'</td>
			<td>
				'._LANG_YES.' <input type="text" name="paramk_check1" size="20" value="'
				.(! empty($value[1]) && $this->values["type"] == 'checkbox' ? str_replace('"', '&quot;', $value[1]) : '')
				.'">
				&nbsp;&nbsp;
				'._LANG_NO.' <input type="text" name="paramk_check0" size="20" value="'
				.(! empty($value[0]) && $this->values["type"] == 'checkbox' ? str_replace('"', '&quot;', $value[0]) : '').'">
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Сохранение поля "Параметры"
	 * @return boolean true
	 */
	protected function save_param_module()
	{
		if (($_POST["type"] == "select" || $_POST["type"] == "multiple") && ! empty($_POST["paramv"]))
		{
			$ids = array();
			foreach ($_POST["paramv"] as $key => $value)
			{
				$id = 0;
				if (! empty($_POST["param_id"][$key]))
				{
					$id = $_POST["param_id"][$key];
				}
				if ($id)
				{
					DB::query("UPDATE {comments_param_select} SET [name]='%h' WHERE id=%d", $value, $id);
				}
				elseif ($value)
				{
					DB::query("INSERT INTO {comments_param_select} (param_id, [name]) VALUES (%d, '%h')", $this->diafan->save, $value);
					$id = DB::next_id("comments_param_select");
					DB::query("UPDATE {comments_param_select} SET sort=id WHERE id=%d", $id);
				}
				$ids[] = $id;
			}
			DB::query("DELETE FROM {comments_param_select} WHERE param_id=%d AND id NOT IN (%h)", $this->diafan->save, implode(",", $ids));
		}
		elseif ($_POST["type"] = "checkbox")
		{
			if ($this->oldrow["type"] == "checkbox")
			{
				$result = DB::query("SELECT id, value FROM {comments_param_select} WHERE param_id=%d", $this->diafan->save);
				while ($row = DB::fetch_array($result))
				{
					if ($row["value"] == 1)
					{
						DB::query("UPDATE {comments_param_select} SET [name]='%h' WHERE id=%d", $_POST["paramk_check1"], $row["id"]);
						$check1 = TRUE;
					}
					elseif ($row["value"] == 0)
					{
						DB::query("UPDATE {comments_param_select} SET [name]='%h' WHERE id=%d", $_POST["paramk_check0"], $row["id"]);
						$check0 = TRUE;
					}
				}
				DB::query("DELETE FROM {comments_param_select} WHERE param_id=%d AND value NOT IN (0,1)", $this->diafan->save);
			}
			else
			{
				DB::query("DELETE FROM {comments_param_select} WHERE param_id=%d", $this->diafan->save);
			}
			if (empty($check0) && $_POST["paramk_check0"])
			{
				DB::query("INSERT INTO {comments_param_select} (param_id, value, [name]) VALUES (%d, 0, '%h')", $this->diafan->save, $_POST["paramk_check0"]);
			}
			elseif (empty($check1) && $_POST["paramk_check1"])
			{
				DB::query("INSERT INTO {comments_param_select} (param_id, value, [name]) VALUES (%d, 1, '%h')", $this->diafan->save, $_POST["paramk_check1"]);
			}
		}
		else
		{
			DB::query("DELETE FROM {comments_param_select} WHERE param_id=%d", $this->diafan->save);
		}
		return TRUE;
	}

	/**
	 * Сопутствующие действия при удалении элемента модуля
	 * @return boolean true
	 */
	protected function delete($del_id, $trash_id)
	{
		$this->del_or_trash_where("comments_param_element", "param_id=".$del_id, $trash_id);
		$this->del_or_trash_where("comments_param_select",  "param_id=".$del_id, $trash_id);

		return TRUE;
	}
}