<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Comments_admin
 *
 * Редактирование комментариев
 */
class Comments_admin extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file	=	'comments';

	/**
	 * @var string таблица в базе данных
	 */
	public $table	=	'comments';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		//поля в базе данных для редактирования
		$this->variable_table = array(
			'text'			=> 'textarea',
			'created'		=> 'datetime',
			'act'			=> 'checkbox',
			'hr1'			=> 'hr',
			'element_id'	=> 'function',
			'hr2'			=> 'hr',
			'user_id'		=> 'function',
			'param'			=> 'function'
		);

		$this->config_module = array(
			'act'		=> 1,	//показать/скрыть
			'del'		=> 1,	//удалить
			'datetime'	=> 1,	//показывать дату и время в списке
			'trash'		=> 1	//использовать корзину
		);

		//выводить в списке содержание полей:
		$this->config_other_row = array(
			'element_id',
			'module_name'
		);
	}

	/**
	 * Выводит контент модуля
	 * 
	 * @return boolean true
	 */
	function show_module()
	{
		$this->name  = 'text';
		$this->where = (! empty($_GET["rew"])
                               ? " AND module_name='".preg_replace('/[^A-Za-z_]+/', '', $_GET["rew"])
			         ."' AND element_id='".preg_replace('/[^0-9]+/', '', $_GET["rew"])."'"
			       : '');

		echo '<table border="0" cellpadding="1" cellspacing="3" class="list">';
		$this->list_row();	
		echo '</table>';
		if (! $this->count)
		{
			echo _ADMIN_COMMENTS_NONE;
		}

		return TRUE;
	}

	/**
	 * Выводит объект, к которому прикреплен комментарий, в списке
	 * 
	 * @return string
	 */
	protected function other_row_element_id($row)
	{
		global $elements;
		if (empty($elements[$row["module_name"]][$row["element_id"]]))
		{
			$name = DB::query_result("SELECT ".($row["module_name"] != 'faq' ? 'name' : 'anons')." FROM {".$row["module_name"]."} where id='%d'", $row["element_id"]);
			$name = $this->diafan->short_text($name);
			$elements[$row["module_name"]][$row["element_id"]] = ($name ? $name : $row["element_id"]);
		}
		return '</td><td>'.$elements[$row["module_name"]][$row["element_id"]];
	}

	/**
	 * Выводит название модуля в списке
	 * 
	 * @return string
	 */
	protected function other_row_module_name($row)
	{					
		$const = strtoupper('_LANG_'.$row["module_name"]);
		return '</td><td>'.(defined($const) ? constant($const) : $row["module_name"]);
	}

	/**
	 * Редактирование поля "Объект"
	 * 
	 * @return boolean true
	 */
	protected function edit_element_id_module()
	{
		$module_name = str_replace('_category', '', $this->values["module_name"]);
		
		$link = BASE_PATH_HREF.$module_name
		.($this->diafan->configmodules('cat', $this->values["module_name"]) && $module_name == $this->values["module_name"]
		 ? '/cat'.DB::title($this->values["module_name"], $this->value, "cat_id")
		 : '')
		.'/edit'.$this->value.'/';

		echo '
		<tr valign="top">
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<a href="'.$link.'" target="_blank">'.$link.'</a>
				<br>
				<a href="'.path_module($this->diafan, 1).'?rew='.$this->values["module_name"].$this->value.'">'._ADMIN_COMMENTS_ALL_COMMENTS.'</a>'
				.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}
        
        /**
	 * Редактирование поля "Дополнительные параметры"
	 * 
	 * @return boolean true
	 */
	protected function edit_param_module()
	{
		$values = array();
		$rvalues = array();
		$result_el = DB::query("SELECT value as rv, [value], param_id FROM {comments_param_element} WHERE element_id=%d", $this->diafan->edit);
		while ($row_el = DB::fetch_array($result_el))
		{
			$values[$row_el["param_id"]][]  = $row_el["value"];
			$rvalues[$row_el["param_id"]][] = $row_el["rv"];
		}

		/*echo '
		<tr>
			<td></td>
			<td>
				<a href="'.BASE_PATH_HREF.$this->diafan->rewrite.'/param/addnew1/'.($this->values["module_name"] ? '?module='.$this->values["module_name"] : '').'" target="_blank">'. _ADMIN_FEEDBACK_ADD_PARAM.'</a>
				'.$this->show_help_row().'
			</td>
		</tr>';*/
                
                

		$result = DB::query("SELECT p.id, p.name, p.type FROM {comments_param} as p "
		                    ." WHERE p.trash='0' AND (module_name='%s' or module_name='')"
		                    ." ORDER BY p.sort ASC", $this->values["module_name"]
		                   );

		while ($row = DB::fetch_array($result))
		{
			$option = array();
			if (! $this->diafan->addnew && in_array($row["type"], array('select', 'multiple')))
			{
				$result_select = DB::query("SELECT [name], id FROM {comments_param_select} WHERE param_id=%d ORDER BY sort ASC", $row["id"]);
				while ($row_select = DB::fetch_array($result_select))
				{
					$option[] = $row_select;
				}
			}
			if ($row["type"] == 'text')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="text" name="param'.$row["id"].'" size="40" value="'
						.(! empty($values[$row["id"]]) ? str_replace('"', '&quot;', $values[$row["id"]][0]) : '')
						.'">
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'email')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="text" name="param'.$row["id"].'" size="40" value="'
						.(! empty($values[$row["id"]]) ? str_replace('"', '&quot;', $values[$row["id"]][0]) : '')
						.'">
						<br>
						<input type="checkbox" value="1" name="param'.$row["id"].'send"> '._ADMIN_SEND_ANSWER.'
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'date')
			{
				if (! $this->show_datepicker)
				{
					echo '
					<link rel="stylesheet" href="'.BASE_PATH.'css/timecalendar.css" />
					<script type="text/javascript" src="'.BASE_PATH.'js/timecalendar.js"></script>';
					$this->show_datepicker = TRUE;
				}
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="text" id="param'.$row["id"].'" name="param'.$row["id"].'" size="20" value="'.(! empty($rvalues[$row["id"]]) ? str_replace('"', '&quot;', date("d.m.Y", $rvalues[$row["id"]][0])) : '').'" class="timecalendar" showTime="false">
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'numtext')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="text" name="param'.$row["id"].'" size="20" value="'
						.(! empty($values[$row["id"]]) ? str_replace('"', '&quot;', $values[$row["id"]][0]) : '')
						.'" class="inpnum">
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'textarea')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<textarea name="param'.$row["id"].'" cols="60" rows="5">'
						.(! empty($values[$row["id"]]) ? str_replace('"', '&quot;', $values[$row["id"]][0]) : '')
						.'</textarea>
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'checkbox')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="checkbox" name="param'.$row["id"].'" value="1"'
						.(! $this->diafan->addnew && ! empty($values[$row["id"]]) ? " checked":'').'>
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'select')
			{
				$value = (! empty($rvalues[$row["id"]][0]) ? $rvalues[$row["id"]][0] : '');
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<select name="param'.$row["id"].'">
						<option value="">-</option>';
						foreach ($option as $select)
						{
							echo '<option value="'.$select["id"].'"'.($value == $select["id"] ? ' selected' : '').'>'.$select["name"].'</option>';
						}
						echo '</select>
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'multiple')
			{
				$value = (! empty($rvalues[$row["id"]]) ? $rvalues[$row["id"]] : array());
				echo '
				<tr>
					<td align="right">
						'.$row["name"].'
					</td>
					<td>
						<select name="param'.$row["id"].'[]" multiple="multiple">';
						foreach ($option as $select)
						{
							echo '<option value="'.$select["id"].'"'.(in_array($select["id"], $value) ? ' selected' : '').'>'.$select["name"].'</option>';
						}
						echo '</select>
					</td>
				</tr>';
			}
		}
		return TRUE;
	}
        
        /**
	 * Сохранение поля "Дополнительные параметры"
	 * 
	 * @return boolean true
	 */
	protected function save_param_module()
	{
		$ids = array();
		$result = DB::query("SELECT p.id, p.name, p.type FROM {comments_param} as p "
		                    ." WHERE p.trash='0' AND (module_name='%s' or module_name='')"
		                    ." ORDER BY p.sort ASC", $this->oldrow["module_name"]
		                   );

		while ($row = DB::fetch_array($result))
		{
			if ($row["type"] == "multiple")
			{
				DB::query("DELETE FROM {comments_param_element} WHERE param_id=%d AND element_id=%d", $row["id"], $this->diafan->save);
				if (! empty($_POST['param'.$row["id"]]) && is_array($_POST['param'.$row["id"]]))
				{
					foreach ($_POST['param'.$row["id"]] as $v)
					{
						DB::query(
							"INSERT INTO {comments_param_element} (value, param_id, element_id) VALUES ('%s', %d, %d)",
							$v,
							$row["id"],
							$this->diafan->save
						);
					}
				}
				$ids[] = $row["id"];
			}
			elseif (! empty($_POST['param'.$row["id"]]))
			{
				$id = 0;
				if (! $this->diafan->savenew)
				{
					$id = DB::query_result("SELECT id FROM {comments_param_element} WHERE param_id=%d AND element_id=%d", $row["id"], $this->diafan->save);
				}
				if ($row["type"] == "date")
				{
					$_POST['param'.$row["id"]] = $this->diafan->unixdate($_POST['param'.$row["id"]]);
				}
				if ($id)
				{
					DB::query(
						"UPDATE {comments_param_element} SET ".(in_array($row["type"], array("text", "editor", "textarea")) ? '[value]' : 'value')
						."='%s' WHERE id=%d",
						$_POST['param'.$row["id"]],
						$id
					);
					DB::query("DELETE FROM {comments_param_element} WHERE param_id=%d AND element_id=%d AND id<>%d", $row["id"], $this->diafan->save, $id);
				}
				else
				{
					DB::query(
						"INSERT INTO {comments_param_element} (".(in_array($row["type"], array("text", "editor", "textarea")) ? '[value]' : 'value')
						.", param_id, element_id) VALUES ('%s', %d, %d)",
						$_POST['param'.$row["id"]],
						$row["id"],
						$this->diafan->save
					);
				}

				if ($row["type"] == "email" && ! empty($_POST['param'.$row["id"].'send']))
				{
					$this->save_sendmail($_POST['param'.$row["id"]]);
				}
				$ids[] = $row["id"];
			}
		}
		DB::query("DELETE FROM {comments_param_element} WHERE param_id NOT IN (".implode(", ", $ids).") AND element_id=%d", $this->diafan->save);
		return TRUE;
	}

	/**
	 * Редактирование поля "Пользователь"
	 * 
	 * @return boolean true
	 */
	protected function edit_user_id_module()
	{
		echo '
		<tr>
			<td align="right">
				'.$this->variable_names().'
			</td>
			<td>
			'.($this->value
			  ? '<a href="'.BASE_PATH_HREF.'usersite/edit'.$this->value.'/">'
			    .DB::title("users_site", $this->value, "fio").'</a>'
			  : _ADMIN_COMMENTS_ANONYMOUSY)
			.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Сохранение поля "Объект"
	 * 
	 * @return boolean true
	 */
	protected function save_element_id_module()
	{
		return TRUE;
	}

	/**
	 * Сохранение поля "Пользователь"
	 * 
	 * @return boolean true
	 */
	protected function save_user_id_module()
	{
		return TRUE;
	}
}