<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
    include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Сomments_inc
 *
 * Подключение модуля "Комментарии"
 */
class Comments_inc extends Model
{

    /**
     * @var array сгенерированные в моделе данные, передаваемые в шаблон
     */
    private $result;

    /**
     * @var object основной объект системы
     */
    protected $diafan;

    /**
     * Конструктор класса
     * 
     * @return void
     */
    public function __construct(&$diafan)
    {
	$this->diafan = &$diafan;
    }

    /**
     * Показывает комментарии, прикрепленные к элементу, и форму добавления комментария
     *
     * @param integer $element_id номер элемента
     * @param string $module_name модуль
     * @return string|boolean false
     */
    public function get()
    {
	$id = $this->diafan->module ? ($this->diafan->show ? $this->diafan->show : $this->diafan->cat) : $this->diafan->cid;

	$module_name = $this->diafan->module ? $this->diafan->module.(!$this->diafan->show ? "_category" : '') : 'site';

	////navigation//
	$this->diafan->_paginator->page = $this->diafan->comments;
	$this->diafan->_paginator->nastr = $this->diafan->configmodules("nastr", 'comments');
	$this->diafan->_paginator->urlpage = 'comments%d/';
	$this->diafan->_paginator->navlink = $this->diafan->_route->current_link('comments');
	$this->diafan->_paginator->navlink_tpl = $this->diafan->_route->current_link("", array("comments" => "%d"));
	$this->diafan->_paginator->nen = DB::query_result("SELECT COUNT(id) FROM {comments} WHERE module_name='%h'"
			." AND element_id='%d' and act='1' AND trash='0'", $module_name, $id);
	$links = $this->diafan->_paginator->get();
	////navigation///

	$cache_meta = array(
	    "name" => "form_param",
	    "language" => _LANG,
	    "module_name" => $module_name
	);

	if (!$rows_param = $this->diafan->_cache->get($cache_meta, "comments"))
	{
	    $rows_param = array();
	    $result__ = DB::query("SELECT id, [name], type, required, [text] FROM {comments_param} WHERE (module_name='%s' OR module_name='')"
			    ." AND trash='0' ORDER BY sort ASC", $module_name);

	    while ($row = DB::fetch_array($result__))
	    {
		if ($row["type"] == 'select' || $row["type"] == 'multiple')
		{
		    $result_select = DB::query("SELECT [name], id FROM {comments_param_select} WHERE param_id=%d"
				    ." ORDER BY sort ASC", $row["id"]);
		    while ($row_select = DB::fetch_array($result_select))
		    {
			$row["select_array"][] = $row_select;
		    }
		}
		$rows_param[] = $row;
	    }
	    //сохранение кеша
	    $this->diafan->_cache->save($rows_param, $cache_meta, "comments");
	}

	$result["param"] = $rows_param;

	$result_ = DB::query_range("SELECT created, user_id, text, id FROM {comments} WHERE module_name='%h' AND element_id='%d'"
			." AND act='1' AND trash='0' ORDER BY created ASC", $module_name, $id, $this->diafan->_paginator->polog, $this->diafan->_paginator->nastr);
	$result["rows"] = array();
	while ($row = DB::fetch_array($result_))
	{
	    $row['date'] = $this->diafan->_useradmin->get($this->format_date($row['created'], "comments"), 'created', $row["id"], 'comments');
	    unset($row['created']);
	    if ($this->diafan->configmodules('user_name', 'comments') && $row["user_id"])
	    {
		$row["name"] = $this->get_author($row["user_id"]);
	    }
	    $row["text"] = $this->diafan->_useradmin->get(nl2br($row["text"]), 'text', $row["id"], 'comments');

	    $params = array();
	    $q = DB::query("SELECT value,param_id FROM {comments_param_element} WHERE element_id=%d AND trash='0'", $row['id']);
	    while ($r = DB::fetch_array($q))
		$params[$r['param_id']] = $r['value'];
	    $row['param'] = $params;

	    $result["rows"][] = $row;
	}



	$result["paginator"] = $this->diafan->_tpl->get('get', 'paginator', $links);

	if (!empty($_POST["module"]) && $_POST["module"] == "comments")
	{
	    include_once(ABSOLUTE_PATH.'plugins/json.php');
	    $result["new"] = TRUE;
	    $json["content"] = $this->diafan->_tpl->get('get', 'comments', $result);
	    echo to_json($json);
	    exit;
	}
	else
	{
	    $text = $this->diafan->_tpl->get('get', 'comments', $result);
	    if (!$this->diafan->configmodules('security_user', 'comments') || $this->diafan->_user->id)
	    {
		$this->result["first"] = count($result["rows"]) ? FALSE : TRUE;

		$this->result["captcha"] = '';
		if ($this->diafan->configmodules('security_code', 'comments') == 1)
		{
		    $this->result["captcha"] = $this->diafan->_captcha->get("comments", $this->get_error("comments", "code"));
		}



		foreach ($rows_param as $row)
		{
		    $this->result['error_p'.$row["id"]] = $this->get_error("comments", 'p'.$row["id"]);
		}

		$this->result["error"] = $this->get_error("comments");
		$this->result["rows"] = $rows_param;

		$text .= $this->diafan->_tpl->get('form', 'comments', $this->result);
	    }
	    else
	    {
		$text .= "Чтобы комментировать, зарегистрируйтесь или авторизуйтесь";
	    }
	    return $text;
	}
    }

}
