<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Comments_install
 *
 * Установка модуля "Комментарии"
 */

$title = "Комментарии";

$sql = array(
	"CREATE TABLE {comments} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		user_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		text text NOT NULL DEFAULT '',
		act ENUM('0', '1') NOT NULL DEFAULT '0',
		created INT(12) UNSIGNED NOT NULL DEFAULT '0',
		module_name VARCHAR(17) NOT NULL DEFAULT '',
		element_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		trash ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (id),
		KEY element_id (element_id),
		KEY module_name (module_name(2))
	) CHARSET=utf8",
	
	"CREATE TABLE {comments_param} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		name VARCHAR(250) NOT NULL DEFAULT '',
		type VARCHAR(20) NOT NULL DEFAULT '',
		module_name VARCHAR(17) NOT NULL DEFAULT '',
		sort INT(11) UNSIGNED NOT NULL DEFAULT '0',
		required ENUM('0', '1') NOT NULL DEFAULT '0',
		text text NOT NULL DEFAULT '',
		trash ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (id)
	) CHARSET=utf8",
	
	"CREATE TABLE {comments_param_element} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		value text NOT NULL DEFAULT '',
		param_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		element_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		trash ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (id),
		KEY element_id (element_id),
		KEY param_id (param_id),
		KEY value (value(5))
	) CHARSET=utf8",	
	
	"CREATE TABLE {comments_param_select} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		param_id int(11) unsigned NOT NULL default '0',
		value tinyint(2) unsigned NOT NULL default '0',
		name varchar(50) NOT NULL default '',
		sort int(11) unsigned NOT NULL default '0',
		trash enum('0','1') NOT NULL default '0',
		PRIMARY KEY (id),
		KEY param_id (param_id)
	) CHARSET=utf8",		

	"INSERT INTO {adminsite} (id, group_id, count_children, name, rewrite, text, act, numrow, sort) VALUES (
		30,
		'2',
		2,
		'Комментарии',
		'comments',
		'<p>Комментарии оставляются пользователями на сайте и прикрепляются к продуктам магазина, к новостям, статьям, фотогалереям и пр. Все комментарии с сайта собираются в этом модуле в неактивном виде. Чтобы комментарий начал отображаться на сайте, его необходимо активировать.<br />\r\n<a href=\"base_path/comments/config/\">Настройки модуля &quot;Комментарии&quot;</a>.</p>\r\n<p><a target=\"_blank\" href=\"http://cms.diafan.ru/dokument/\">Полная документация и помощь</a></p>',
		'1',
		255772,
		28
	);",

	"INSERT INTO {adminsite} (`id`, `parent_id`, `group_id`, `name`, `rewrite`, `text`, `numrow`, `sort`) VALUES (
		31,
		30,
		'2',
		'Настройки',
		'comments/config',
		'<p><a target=\"_blank\" href=\"http://cms.diafan.ru/dokument/\">Полная документация и помощь</a></p>',
		5631,
		31
	);",
	
	"INSERT INTO {adminsite} (id, parent_id, group_id, name, rewrite, text, act, numrow, sort) VALUES (
		69,
		30,
		'2',
		'Конструктор формы',
		'comments/param',
		'<p><a target=\"_blank\" href=\"http://cms.diafan.ru/dokument/\">Полная документация и помощь</a></p>',
		'1',
		3429843,
		69
	);",
	
	"UPDATE {adminsite} SET `act` = '1' WHERE id=69",
	"INSERT INTO {adminsite_parents} (`element_id`, `parent_id`) VALUES (31, 30)",
	
	"INSERT INTO {adminsite_parents} (`element_id`, `parent_id`) VALUES (69, 30)",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('comments', 'security_code', '1')",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('comments', 'format_date', '5')",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('comments', 'nastr', '10')",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('comments', 'user_name', '1')",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('comments', 'error_insert_message', 'Ваше сообщение уже имеется в базе.')",
	
	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('comments', 'error_empty_fields', 'Не заполнены обязательные поля')",

	"INSERT INTO {config} (`module_name`, `name`, `value`, `lang_id`) VALUES ('comments', 'error_insert_message', 'Your message is already in data base.', 2)",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('comments', 'add_message', 'Спасибо! Ваш комментарий будет проверен в ближайшее время и появиться на сайте.')",

	"INSERT INTO {config} (`module_name`, `name`, `value`, `lang_id`) VALUES ('comments', 'add_message', 'Thank you! Your comment will check in near time and will publish on this page.', 2)",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('comments', 'error_add_message', 'Ваш комментарий не может быть добавлен.')",

	"INSERT INTO {config} (`module_name`, `name`, `value`, `lang_id`) VALUES ('comments', 'error_add_message', 'Impossible to add your comment.<br>Сheсk if input data is correct.', 2)"
);
	
$example = array();


if (! empty($_POST["photo"]))
{
	$example[] = "INSERT INTO {comments} (id, text, act, created, module_name, element_id, user_id) VALUES (
		3,
		'Лошадь просто супер. Сынишка в восторге. Спасибо!',
		'1',
		'".(time()-86400*5)."',
		'photo',
		'2',
		1
	)";
	$example[] = "INSERT INTO {comments} (id, text, act, created, module_name, element_id, user_id) VALUES (
		8,
		'Вау, какая изворотливая!',
		'1',
		'".time()."',
		'photo',
		'9',
		2
	);";
}

if (! empty($_POST["shop"]))
{
	$example[] = "INSERT INTO {comments} (id, text, act, created, module_name, element_id, user_id) VALUES (
		1,
		'Хороший коршун, я купил себе три на дачу.',
		'1',
		'".(time()-86400*6)."',
		'shop',
		'1',
		1
	)";
	$example[] = "INSERT INTO {comments} (id, text, act, created, module_name, element_id, user_id) VALUES (
		4,
		'Отличный пеликан. Купил и не нарадуюсь.',
		'1',
		'".(time()-86400*4)."',
		'shop',
		'3',
		2
	)";
	$example[] = "INSERT INTO {comments} (id, text, act, created, module_name, element_id, user_id) VALUES (
		5,
		'Очень хочется познакомиться с вашим создателем.',
		'1',
		'".(time()-86400*3)."',
		'shop',
		'30',
		1
	)";
	$example[] = "INSERT INTO {comments} (id, text, act, created, module_name, element_id, user_id) VALUES (
		6,
		'Красавец',
		'1',
		'".(time()-86400*2)."',
		'shop',
		'19',
		2
	)";
}

if (! empty($_POST["clauses"]))
{
	$example[] = "INSERT INTO {comments} (id, text, act, created, module_name, element_id, user_id) VALUES (
		7,
		'Отличная статья. Я в восторге. Автор.',
		'1',
		'".(time()-86400)."',
		'clauses',
		'1',
		1
	)";
}

/**
 * Деинсталлирует модуль
 * 
 * @return void
 */
function module_basic_uninstall_comments()
{
	$module = 'comments';
	DB::query("DROP TABLE {".$module."};");
	DB::query("DELETE FROM {config} WHERE module_name='".$module."';");
	DB::query("DELETE FROM {config} WHERE name='".$module."';");
	DB::query("DELETE FROM {config} WHERE name='".$module."_cat';");
	$admin_ids = DB::query_result("SELECT GROUP_CONCAT(id SEPARATOR ',') FROM {adminsite} WHERE rewrite IN ('".$module."', '".$module."/config')");
	if ($admin_ids)
	{
		DB::query("DELETE FROM {adminsite} WHERE id IN (".$admin_ids.")");
		DB::query("DELETE FROM {adminsite_parents} WHERE element_id IN (".$admin_ids.")");
	}
	$trash_ids = DB::query_result("SELECT GROUP_CONCAT(id SEPARATOR ',') FROM {trash} WHERE module_name='".$module."'");
	if ($trash_ids)
	{
		DB::query("DELETE FROM {trash} WHERE id IN (".$trash_ids.")");
		$trash_child_ids = DB::query_result("SELECT GROUP_CONCAT(element_id SEPARATOR ',') FROM {trash_parents} WHERE parent_id IN (".$trash_ids.")");
		if ($trash_child_ids)
		{
			DB::query("DELETE FROM {trash_parents} WHERE element_id IN (".$trash_child_ids.")");
		}
		DB::query("DELETE FROM {trash_parents} WHERE element_id IN (".$trash_ids.")");
	}
}
