<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Comments_view
 *
 * Шаблон модуля "Комментарии"
 */
class Comments_view extends View
{
	/**
	 * Шаблон формы добавления комментария
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return string
	 */
	public function form($result)
	{
		$text = '<form method="POST" action="" id="comments" class="ajax comments_form">';

		$text .= '<h2>'.$this->_('ADD_COMMENTS').'</h2>';

		$text .= '<input type="hidden" name="module" value="comments">
		<input type="hidden" name="ajax" value="0" class="ajax">';

		if ($result["first"])
		{
			$text .= '<input type="hidden" name="first" value="1">';
		}
                
                if (! empty($result["rows"]))
		{
                    
			foreach ($result["rows"] as $row)
			{
				$text .= '<div class="comments_form_param'.$row["id"].'">';
				if ($row["type"] == 'text' || $row["type"] == "email")
				{
					$text .= '<div class="infofield">'.$row["name"].($row["required"] ? '<font color="red">*</font>' : '').':</div>';
					$text .= '<input type="text" name="p'.$row["id"].'" size="40" value="" class="inptext">';
				}
				elseif ($row["type"] == 'textarea')
				{
					$text .= '<div class="infofield">'.$row["name"].($row["required"] ? '<font color="red">*</font>' : '').':</div>';
					$text .= '<textarea name="p'.$row["id"].'" class="inptextarea" rows="10" cols="30"></textarea>';
				}
				elseif ($row["type"] == 'date')
				{
					if (empty($timecalendar))
					{
						$text .= '<link rel="stylesheet" href="'.BASE_PATH.'css/timecalendar.css" />
						<script type="text/javascript" src="'.BASE_PATH.'js/timecalendar.js"></script>';
					}
					$text .= '<div class="infofield">'.$row["name"].($row["required"] ? '<font color="red">*</font>' : '').':</div>
					<input type="text" name="p'.$row["id"].'" size="20" value="" class="inptext timecalendar" showTime="false">';
					$timecalendar  = TRUE;
				}
				elseif ($row["type"] == 'numtext')
				{
					$text .= '<div class="infofield">'.$row["name"].($row["required"] ? '<font color="red">*</font>' : '').':</div>';
					$text .= '<input type="text" name="p'.$row["id"].'" size="5" value="" class="inpnum">';
				}
				elseif ($row["type"] == 'checkbox')
				{
					$text .= '<div class="infofield"><input type="checkbox" name="p'.$row["id"].'" value="1" class="inpcheckbox">
					'.$row["name"].($row["required"] ? '<font color="red">*</font>' : '').'</div>';
				}
				elseif ($row["type"] == 'select')
				{
					$text .= '<div class="infofield">'.$row["name"].($row["required"] ? '<font color="red">*</font>' : '').':</div>';
					$text .= '<select name="p'.$row["id"].'" class="inpselect">';
					$text .= '<option value="">-</option>';
					foreach ($row["select_array"] as $select)
					{
						$text .= '<option value="'.$select["id"].'">'.$select["name"].'</option>';
					}
					$text .= '</select>';
				}
				elseif ($row["type"] == 'multiple')
				{
					$text .= '<div class="infofield">'.$row["name"].($row["required"] ? '<font color="red">*</font>' : '').':</div>';
					foreach ($row["select_array"] as $select)
					{
						$text .= '<br><input name="p'.$row["id"].'[]" value="'.$select["id"].'" class="inpcheckbox"> '.$select["name"];
					}
				}
				$text .= '<div class="comments_form_param_text">'.$row["text"].'</div>';
				$text .= '</div>';
				$text .= '<div class="errors error_p'.$row["id"].'"'.($result["error_p".$row["id"]] ? '>'.$result["error_p".$row["id"]] : ' style="display:none">').'</div>';
			}
		}


		$text .= '<div class="errors error"'.($result["error"] ? '>'.$result["error"] : ' style="display:none">').'</div>
		<textarea name="comment" class="inptextarea"></textarea><br>';

		//Защитный код
		$text .= $result["captcha"];

		//Кнопка Отправить
		$text .= '<span class="button_wrap"><input type="submit" value="'.$this->_('SEND', FALSE).'" class="button"></span>'
		.'</form>';
		return $text;
	}

	/**
	 * Шаблон вывода комментариев
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return string
	 */
	public function get($result)
	{
		$text = '';
		if ($result["rows"] && empty($result["new"]))
		{
			$text .= '<h2>'.$this->_('COMMENTS').'</h2>';
		}
		
		
		
		
		
		if ($result["rows"])
		{
			if (empty($result["new"]))
			{
				$text .= '<div class="comments">';
			}
			foreach ($result["rows"] as $row)
			{
				
				if (! empty($row["name"]))
				{
					$text .= '<div class="comments_name">';
					if (! empty($row["name"]["avatar"]))
					{
						$text .= '<img src="'.$row["name"]["avatar"].'" width="'.$row["name"]["avatar_width"].'" height="'.$row["name"]["avatar_height"].'" alt="'.$row["name"]["fio"].' ('.$row["name"]["name"].')" class="avatar"> ';
					}
					$text .= $row["name"]["fio"].' ('.$row["name"]["name"].')</div>';
				}
				if ($row['date'])
				{
					$text .= '<div class="comments_date">'.$row['date'].'</div>';
				}
				
				if(!empty($row["param"]))
				{
				    $text.='<div class="comments_param">';
				    foreach($row["param"] as $id=>$value)
				    {
					$name='';
					
					foreach($result['param'] as $param)
					{
					    if($param['id']==$id)
					    {
						$name=$param['name'];
						if($param['type']=='select' || $param['type']=='multiple')
						{
						    $value=$param['select_array'][$value-1]['name'];
						}
						break;
					    }
					}
					$text.=$name.': '.$value.'<br>';
				    }
				    $text.='</div>';
				}
				
				$text .= '<div class="comments_text">'.$row['text']."</div>"
				;
			}

			if (! empty($result["paginator"]))
			{
				$text .= $result["paginator"];
			}

			if (empty($result["new"]))
			{
				$text .= '</div>';
				$text .= '<script type="text/javascript" src="'.BASE_PATH.'modules/comments/comments.js"></script>';
			}
		}
		return $text;
	}
}