<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Feedback_admin_param
 *
 * Конструктор обратной связи
 */
class Feedback_admin_param extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'feedbackparam';

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'feedback_param'; 

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		//поля в базе данных для редактирования
		$this->variable_table = array(
			'name'     => 'text',
			'type'     => 'select',
			'site_id'  => 'select',
			'required' => 'checkbox',
			'param'    => 'function',
			//'sort'     => 'function',
			'text'     => 'editor'
		);

		//поля, которые прячутся в Дополнительно
		$this->variable_other = array(
			//'sort' => 1
		);

		//переводимые поля
		$this->language_names = array(
			'name',
			'text'
		);

		$this->config_module = array(
			'del'          => 1,	//удалить
			'order'        => 1,	//сортируется
			'element_site' => 1,	//делит элементы по разделам (страницы сайта, к которым прикреплен модуль)
			'trash'        => 1 	//использовать корзину
		);

		//выводить в списке содержание полей:
		$this->config_other_row = array(
			'type'
		);

		$this->select_arr["type"] = array(
			"text"     => _ADMIN_PARAM_TEXT_FIELD,
			"numtext"  => _ADMIN_PARAM_NUMTEXT_FIELD,
			"date"     => _ADMIN_PARAM_DATE_FIELD,
			"textarea" => _ADMIN_PARAM_TEXTAREA_FIELD,
			"checkbox" => _ADMIN_PARAM_CHECKBOX_FIELD,
			"select"   => _ADMIN_PARAM_SELECT_FIELD,
			"multiple" => _ADMIN_PARAM_MULTIPLE_FIELD,
			"email"    => _ADMIN_PARAM_EMAIL_FIELD
		);

		$this->where = $this->diafan->site ? ' AND site_id='.($this->diafan->site == 999999 ? 0 : $this->diafan->site) : '';
	}

	/**
	 * Выводит список полей формы
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->addnew_init(_ADMIN_FEEDBACK_ADD_PARAM);

		echo '<table class="list">';
		$this->list_row();
		echo '</table>';

		return TRUE;
	}

	/**
	 * Вывод типа поля в списке полей
	 * @return string
	 */
	protected function other_row_type($row)
	{
		return '</td><td>'.$this->select_arr["type"][$row["type"]];
	}

	/**
	 * Редактирование поля "Страницаы"
	 * 
	 * @return boolean
	 */
	protected function edit_site_id_module()
	{
		if (! $this->value)
		{
			$this->value = $this->diafan->site;
		}

		echo '
		<tr'.$this->get_other().' valign="top">
			<td class="td_first">'.$this->variable_names().'</td>
			<td>
				<select name="'.$this->key.'">';
		$result = DB::query("SELECT id, name FROM {site} WHERE trash='0' AND addmodule='%s' ORDER BY id ASC", $this->diafan->module);
		while ($row = DB::fetch_array($result))
		{
			$cats[0][] = $row;
		}
		echo $this->get_options($cats, $cats[0], array($this->value)).'
				</select>
				'.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Редактирование поля "Параметры"
	 * @return boolean true
	 */
	protected function edit_param_module()
	{
		$value = array();
		if (empty($this->values["type"]))
		{
			$this->values["type"] = '';
		}
		if (! $this->diafan->addnew && in_array($this->values["type"], array('select', 'multiple', 'checkbox')))
		{
			$result_select = DB::query("SELECT [name], value, id FROM {feedback_param_select} WHERE param_id=%d ORDER BY sort ASC", $this->diafan->edit);
			while ($row_select = DB::fetch_array($result_select))
			{
				if ($this->values["type"] == 'checkbox')
				{
					$value[$row_select["value"]] = $row_select["name"];
				}
				else
				{
					$value[$row_select["id"]] = $row_select["name"];
				}
			}
		}

		echo '
		<script type="text/javascript" src="'.BASE_PATH.'modules/feedback/admin/feedback.admin.param.js"></script>

		<tr id="param" valign="top">
			<td class="td_first">'.$this->variable_names().'</td>
			<td>
			<table>';

		$fileds = false;
		$m = 1;
		if (in_array($this->values["type"], array('select', 'multiple')))
		{
			foreach ($value as $k => $v)
			{
				echo '
				<tr class="param">
					<td>
						<input type="hidden" name="param_id[]" value="'.$k.'" class="param_id">
						<input type="text" name="paramv[]" size="40" value="'.str_replace('"', '&quot;', $v).'">
						<span class="param_actions">
							<a href="javascript:void(0)" action="delete_param" confirm="'._ADMIN_CONFIRM_DELETE.'">
								<img src="'.BASE_PATH.'adm/img/delete.gif" width="15" height="15" alt="'._LANG_DELETE.'">
							</a>
							<a href="javascript:void(0)" action="up_param">
								<img src="'.BASE_PATH.'adm/img/up.gif" width="14" height="16" alt="'._ADMIN_UP.'">
							</a>
							<a href="javascript:void(0)" action="down_param">
								<img src="'.BASE_PATH.'adm/img/down.gif" width="14" height="16" alt="'._ADMIN_DOWN.'">
							</a>
						</span>
					</td>
				</tr>';
				$m++;
				$fileds = true;
			}
		}
		if (! $fileds)
		{
			echo '
			<tr class="param">
				<td>
					<input type="text" name="paramv[]" size="40" value="">
					<span class="param_actions">
						<a href="javascript:void(0)" action="delete_param" confirm="'._ADMIN_CONFIRM_DELETE.'">
							<img src="'.BASE_PATH.'adm/img/delete.gif" width="15" height="15" alt="'._LANG_DELETE.'">
						</a>
					</span>
				</td>
			</tr>';
		}
		echo '</table>
				<a href="javascript:void(0)" class="param_plus" title="'._LANG_ADD.'"><img src="'.BASE_PATH.'adm/img/add.gif" width="16" height="16" alt="'._LANG_ADD.'"></a>
			</td>
		</tr>
		<tr id="param_check">
			<td class="td_first">'.$this->variable_names().'</td>
			<td>
				'._LANG_YES.' <input type="text" name="paramk_check1" size="20" value="'
				.(! empty($value[1]) && $this->values["type"] == 'checkbox' ? str_replace('"', '&quot;', $value[1]) : '')
				.'">
				&nbsp;&nbsp;
				'._LANG_NO.' <input type="text" name="paramk_check0" size="20" value="'
				.(! empty($value[0]) && $this->values["type"] == 'checkbox' ? str_replace('"', '&quot;', $value[0]) : '').'">
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Сохранение поля "Параметры"
	 * @return boolean true
	 */
	protected function save_param_module()
	{
		if (($_POST["type"] == "select" || $_POST["type"] == "multiple") && ! empty($_POST["paramv"]))
		{
			$ids = array();
			foreach ($_POST["paramv"] as $key => $value)
			{
				$id = 0;
				if (! empty($_POST["param_id"][$key]))
				{
					$id = $_POST["param_id"][$key];
				}
				if ($id)
				{
					DB::query("UPDATE {feedback_param_select} SET [name]='%h' WHERE id=%d", $value, $id);
				}
				elseif ($value)
				{
					DB::query("INSERT INTO {feedback_param_select} (param_id, [name]) VALUES (%d, '%h')", $this->diafan->save, $value);
					$id = DB::next_id("feedback_param_select");
					DB::query("UPDATE {feedback_param_select} SET sort=id WHERE id=%d", $id);
				}
				$ids[] = $id;
			}
			DB::query("DELETE FROM {feedback_param_select} WHERE param_id=%d AND id NOT IN (%h)", $this->diafan->save, implode(",", $ids));
		}
		elseif ($_POST["type"] = "checkbox")
		{
			if ($this->oldrow["type"] == "checkbox")
			{
				$result = DB::query("SELECT id, value FROM {feedback_param_select} WHERE param_id=%d", $this->diafan->save);
				while ($row = DB::fetch_array($result))
				{
					if ($row["value"] == 1)
					{
						DB::query("UPDATE {feedback_param_select} SET [name]='%h' WHERE id=%d", $_POST["paramk_check1"], $row["id"]);
						$check1 = TRUE;
					}
					elseif ($row["value"] == 0)
					{
						DB::query("UPDATE {feedback_param_select} SET [name]='%h' WHERE id=%d", $_POST["paramk_check0"], $row["id"]);
						$check0 = TRUE;
					}
				}
				DB::query("DELETE FROM {feedback_param_select} WHERE param_id=%d AND value NOT IN (0,1)", $this->diafan->save);
			}
			else
			{
				DB::query("DELETE FROM {feedback_param_select} WHERE param_id=%d", $this->diafan->save);
			}
			if (empty($check0) && $_POST["paramk_check0"])
			{
				DB::query("INSERT INTO {feedback_param_select} (param_id, value, [name]) VALUES (%d, 0, '%h')", $this->diafan->save, $_POST["paramk_check0"]);
			}
			elseif (empty($check1) && $_POST["paramk_check1"])
			{
				DB::query("INSERT INTO {feedback_param_select} (param_id, value, [name]) VALUES (%d, 1, '%h')", $this->diafan->save, $_POST["paramk_check1"]);
			}
		}
		else
		{
			DB::query("DELETE FROM {feedback_param_select} WHERE param_id=%d", $this->diafan->save);
		}
		return TRUE;
	}

	/**
	 * Сопутствующие действия при удалении элемента модуля
	 * @return boolean true
	 */
	protected function delete($del_id, $trash_id)
	{
		$this->del_or_trash_where("feedback_param_element", "param_id=".$del_id, $trash_id);
		$this->del_or_trash_where("feedback_param_select",  "param_id=".$del_id, $trash_id);

		return TRUE;
	}
}