<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Feedback_admin
 *
 * Редактирование сообщений из формы обратной связи
 */
class Feedback_admin extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'feedback';

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'feedback';

	/**
	 * @var string номера дополнительных полей, выводимых в списке; если пустой, генерируется автоматически
	 */
	private $other_rows_param = array();

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		//поля в базе данных для редактирования
		$this->variable_table = array(
			'created'     => 'datetime',
			'site_id'     => 'select',
			'language'    => 'select',
			'hr1'         => 'hr',
			'param'       => 'function',
			'attachments' => 'module',
			'hr2'         => 'hr',
			'text'        => 'editor'
		);

		$this->config_module = array(
			'del'          => 1, //удалить
			'datetime'     => 1, //показывать дату в списке, сортировать по дате 
			'element_site' => 1, //делит элементы по разделам (страницы сайта, к которым прикреплен модуль)
			'trash'        => 1  //использовать корзину
		);
		
		//выводить в списке содержание полей:
		$this->config_other_row = array(
			'id'
		);

		foreach ($this->diafan->language_all as $key => $language)
		{
			$this->select_arr["language"][$language[0]] = $language[2];
		}
	}

	/**
	 * Выводит список обращений в обратную связь
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->width_column = TRUE;

		echo '<table class="list">
		<tr>
			<td width="8%"></td>
			<td width="12%"></td>
			<td width="10%"></td>
			<td width="65%"></td>
			<td width="5%"></td>
		</tr>';
		$this->name = "id, '"._LANG_EDIT."'";
		$this->list_row();
		echo '</table>';

		return TRUE;
	}

	/**
	 * Выводит дополнительные поля в списке
	 * 
	 * @return string
	 */
	protected function other_row_id($row)
	{
		$text = '</td><td class="comment">
			<div>
				<span></span>
				<table><tbody><tr><td>';
		$values = '';

		$result = DB::query("SELECT e.value, e.param_id, p.type, p.name FROM {feedback_param_element} AS e"
		                    ." INNER JOIN {feedback_param} AS p ON e.param_id=p.id"
		                    ." WHERE e.trash='0' AND e.element_id=%d", $row["id"]);
		while ($row = DB::fetch_array($result))
		{
			if ($row["value"])
			{
				switch($row["type"])
				{
					case 'date':
						$row["value"] = date("d.m.Y", $row["value"]);
						break;

					case 'select':
					case 'multiple':
						$row["value"] = DB::query_result("SELECT name FROM {feedback_param_select} WHERE id=%d", $row["value"]);
						break;

					case 'checkbox':
						$v = DB::query_result("SELECT name FROM {feedback_param_select} WHERE param_id=%d AND value=1", $row["param_id"]);
						if($v)
						{
							$row["value"] = $row["name"].': '.$v;
						}
						else
						{
							$row["value"] = $row["name"];
						}
						break;
				}
				$values .= ($values ? ', ' : '').$row["value"];
			}
		}
		$text .= $values.'</td></tr></tbody></table>
			</div>';
		return $text;
	}

	/**
	 * Редактирование поля "Дополнительные параметры"
	 * 
	 * @return boolean true
	 */
	protected function edit_param_module()
	{
		$values = array();
		$rvalues = array();
		$result_el = DB::query("SELECT value as rv, [value], param_id FROM {feedback_param_element} WHERE element_id=%d", $this->diafan->edit);
		while ($row_el = DB::fetch_array($result_el))
		{
			$values[$row_el["param_id"]][]  = $row_el["value"];
			$rvalues[$row_el["param_id"]][] = $row_el["rv"];
		}

		/*echo '
		<tr>
			<td></td>
			<td>
				<a href="'.BASE_PATH_HREF.$this->diafan->rewrite.'/param/addnew1/'.($this->diafan->site ? 'site'.$this->diafan->site.'/' : '').'" target="_blank">'. _ADMIN_FEEDBACK_ADD_PARAM.'</a>
				'.$this->show_help_row().'
			</td>
		</tr>';*/

		$result = DB::query("SELECT p.id, p.name, p.type FROM {feedback_param} as p "
		                    ." WHERE p.trash='0' AND p.site_id IN (0,%d)"
		                    ." ORDER BY p.sort ASC", $this->values["site_id"]
		                   );

		while ($row = DB::fetch_array($result))
		{
			$option = array();
			if (! $this->diafan->addnew && in_array($row["type"], array('select', 'multiple')))
			{
				$result_select = DB::query("SELECT [name], id FROM {feedback_param_select} WHERE param_id=%d ORDER BY sort ASC", $row["id"]);
				while ($row_select = DB::fetch_array($result_select))
				{
					$option[] = $row_select;
				}
			}
			if ($row["type"] == 'text')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="text" name="param'.$row["id"].'" size="40" value="'
						.(! empty($values[$row["id"]]) ? str_replace('"', '&quot;', $values[$row["id"]][0]) : '')
						.'">
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'email')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="text" name="param'.$row["id"].'" size="40" value="'
						.(! empty($values[$row["id"]]) ? str_replace('"', '&quot;', $values[$row["id"]][0]) : '')
						.'">
						<br>
						<input type="checkbox" value="1" name="param'.$row["id"].'send"> '._ADMIN_SEND_ANSWER.'
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'date')
			{
				if (! $this->show_datepicker)
				{
					echo '
					<link rel="stylesheet" href="'.BASE_PATH.'css/timecalendar.css" />
					<script type="text/javascript" src="'.BASE_PATH.'js/timecalendar.js"></script>';
					$this->show_datepicker = TRUE;
				}
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="text" id="param'.$row["id"].'" name="param'.$row["id"].'" size="20" value="'.(! empty($rvalues[$row["id"]]) ? str_replace('"', '&quot;', date("d.m.Y", $rvalues[$row["id"]][0])) : '').'" class="timecalendar" showTime="false">
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'numtext')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="text" name="param'.$row["id"].'" size="20" value="'
						.(! empty($values[$row["id"]]) ? str_replace('"', '&quot;', $values[$row["id"]][0]) : '')
						.'" class="inpnum">
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'textarea')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<textarea name="param'.$row["id"].'" cols="60" rows="5">'
						.(! empty($values[$row["id"]]) ? str_replace('"', '&quot;', $values[$row["id"]][0]) : '')
						.'</textarea>
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'checkbox')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="checkbox" name="param'.$row["id"].'" value="1"'
						.(! $this->diafan->addnew && ! empty($values[$row["id"]]) ? " checked":'').'>
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'select')
			{
				$value = (! empty($rvalues[$row["id"]][0]) ? $rvalues[$row["id"]][0] : '');
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<select name="param'.$row["id"].'">
						<option value="">-</option>';
						foreach ($option as $select)
						{
							echo '<option value="'.$select["id"].'"'.($value == $select["id"] ? ' selected' : '').'>'.$select["name"].'</option>';
						}
						echo '</select>
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'multiple')
			{
				$value = (! empty($rvalues[$row["id"]]) ? $rvalues[$row["id"]] : array());
				echo '
				<tr>
					<td align="right">
						'.$row["name"].'
					</td>
					<td>
						<select name="param'.$row["id"].'[]" multiple="multiple">';
						foreach ($option as $select)
						{
							echo '<option value="'.$select["id"].'"'.(in_array($select["id"], $value) ? ' selected' : '').'>'.$select["name"].'</option>';
						}
						echo '</select>
					</td>
				</tr>';
			}
		}
		return TRUE;
	}

	/**
	 * Отправляет письмо пользователю
	 * @return boolean true
	 */
	protected function save_sendmail($email)
	{
		if (! empty($_POST["text"]) && $email)
		{
			$message = $this->get_message();
			$subject = str_replace(
				array('%title', '%url'),
				array(TITLE, BASE_URL),
				$this->diafan->configmodules('subject', 'feedback', $_POST["site_id"], _LANG)
			);

			$message = str_replace(
				array(
					'%title',
					'%url',
					'%message',
					'%answer'
				),
				array(
					TITLE,
					BASE_URL,
					$message,
					$_POST["text"]
				),
				$this->diafan->configmodules('message', 'feedback', $_POST["site_id"], _LANG)
			);

			include_once(ABSOLUTE_PATH.'includes/mail.php');
			send_mail(
				$email,
				$subject,
				$message,
				($this->diafan->configmodules("emailconf", 'feedback', $_POST["site_id"]) && $this->diafan->configmodules("email", 'feedback', $_POST["site_id"])
				? $this->diafan->configmodules("email", 'feedback', $_POST["site_id"])
				: '')
			);
			$this->diafan->err = 5;
		}

		return TRUE;
	}

	/**
	 * Формирует текст письма пользователю
	 * @return string
	 */
	private function get_message()
	{
		$cache_meta = array(
				"name"     => "form_param",
				"language" => _LANG,
				"site_id"  => $this->oldrow["site_id"]
			);
		if (! $rows_param = $this->diafan->_cache->get($cache_meta, "feedback"))
		{
			$rows_param = array();
			$result = DB::query("SELECT id, [name], type, required, [text] FROM {feedback_param} WHERE site_id=%d"
			                    ." AND trash='0' ORDER BY sort ASC", $this->oldrow["site_id"]);

			while ($row = DB::fetch_array($result))
			{
				if ($row["type"] == 'select' || $row["type"] == 'multiple')
				{
					$result_select = DB::query("SELECT [name], id FROM {feedback_param_select} WHERE param_id=%d"
					                           ." ORDER BY sort ASC", $row["id"]);
					while ($row_select = DB::fetch_array($result_select))
					{
						$row["select_array"][] = $row_select;
					}
				}
				$rows_param[] = $row;
			}
			//сохранение кеша
			$this->diafan->_cache->save($rows_param, $cache_meta, "feedback");
		}
		$message = array();

		foreach ($rows_param as $row)
		{
			if (empty($_POST["param".$row["id"]]) && $row["type"] != "checkbox")
				continue;
			
			if ($row["type"] == "text" || $row["type"] == "textarea" || $row["type"] == "email")
			{
				$message[] = $row["name"].': '.htmlspecialchars(htmlspecialchars($_POST["param".$row["id"]]));
			}
			elseif ($row["type"] == "numtext")
			{
				$message[] = $row["name"].': '.$this->diafan->get_param($_POST, "param".$row["id"], '', 2);
			}
			elseif ($row["type"] == "date")
			{
				if ($_POST["param".$row["id"]])
				{
					$message[] = $row["name"].': '.date('d.m.Y', $_POST["param".$row["id"]]);
				}
			}
			elseif ($row["type"] == "checkbox")
			{
				$value = ! empty($_POST["param".$row["id"]]) ? 1 : 0;
				$value_sel = DB::query_result("SELECT [name] FROM {feedback_param_select} WHERE value=%d AND param_id=%d", $value, $row["id"]);
				if (! $value_sel && $value == 1)
				{
					$message[] = $row["name"];
				}
				elseif ($value_sel)
				{
					$message[] = $row["name"].': '.$value_sel;
				}
			}
			elseif ($row["type"] == "select" && ! empty($row["select_array"]))
			{
				foreach ($row["select_array"] as $select)
				{
					if ($select["id"] == $_POST["param".$row["id"]])
					{
						$message[] = $row["name"].': '.$select["name"];
					}
				}
			}
			elseif ($row["type"] == "multiple" && ! empty($row["select_array"]) && ! empty($_POST["param".$row["id"]]) && is_array($_POST["param".$row["id"]]))
			{
				$vals = array();
				foreach ($row["select_array"] as $select)
				{
					if (in_array($select["id"], $_POST["param".$row["id"]]))
					{
						$vals[] = $select["name"];
					}
				}
				$message[] = $row["name"].': '.implode(", ", $vals);
			}
		}
		return implode('<br>', $message);
	}

	/**
	 * Сохранение поля "Дополнительные параметры"
	 * 
	 * @return boolean true
	 */
	protected function save_param_module()
	{
		$ids = array();
		$result = DB::query("SELECT p.id, p.name, p.type FROM {feedback_param} as p "
		                    ." WHERE p.trash='0' AND p.site_id IN (0,%d)"
		                    ." ORDER BY p.sort ASC", $this->oldrow["site_id"]
		                   );

		while ($row = DB::fetch_array($result))
		{
			if ($row["type"] == "multiple")
			{
				DB::query("DELETE FROM {feedback_param_element} WHERE param_id=%d AND element_id=%d", $row["id"], $this->diafan->save);
				if (! empty($_POST['param'.$row["id"]]) && is_array($_POST['param'.$row["id"]]))
				{
					foreach ($_POST['param'.$row["id"]] as $v)
					{
						DB::query(
							"INSERT INTO {feedback_param_element} (value, param_id, element_id) VALUES ('%s', %d, %d)",
							$v,
							$row["id"],
							$this->diafan->save
						);
					}
				}
				$ids[] = $row["id"];
			}
			elseif (! empty($_POST['param'.$row["id"]]))
			{
				$id = 0;
				if (! $this->diafan->savenew)
				{
					$id = DB::query_result("SELECT id FROM {feedback_param_element} WHERE param_id=%d AND element_id=%d", $row["id"], $this->diafan->save);
				}
				if ($row["type"] == "date")
				{
					$_POST['param'.$row["id"]] = $this->diafan->unixdate($_POST['param'.$row["id"]]);
				}
				if ($id)
				{
					DB::query(
						"UPDATE {feedback_param_element} SET ".(in_array($row["type"], array("text", "editor", "textarea")) ? '[value]' : 'value')
						."='%s' WHERE id=%d",
						$_POST['param'.$row["id"]],
						$id
					);
					DB::query("DELETE FROM {feedback_param_element} WHERE param_id=%d AND element_id=%d AND id<>%d", $row["id"], $this->diafan->save, $id);
				}
				else
				{
					DB::query(
						"INSERT INTO {feedback_param_element} (".(in_array($row["type"], array("text", "editor", "textarea")) ? '[value]' : 'value')
						.", param_id, element_id) VALUES ('%s', %d, %d)",
						$_POST['param'.$row["id"]],
						$row["id"],
						$this->diafan->save
					);
				}

				if ($row["type"] == "email" && ! empty($_POST['param'.$row["id"].'send']))
				{
					$this->save_sendmail($_POST['param'.$row["id"]]);
				}
				$ids[] = $row["id"];
			}
		}
		DB::query("DELETE FROM {feedback_param_element} WHERE param_id NOT IN (".implode(", ", $ids).") AND element_id=%d", $this->diafan->save);
		return TRUE;
	}

	/**
	 * Сопутствующие действия при удалении элемента модуля
	 * @return boolean true
	 */
	protected function delete($del_id, $trash_id)
	{
		$this->del_or_trash_where("feedback_param_element", "element_id=".$del_id, $trash_id);

		return TRUE;
	}
}