<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Files_admin
 *
 * Редактирование файлов в файловом архиве
 */
class Files_admin extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'files';

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'files';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
		
		//поля в базе данных для редактирования
		$this->variable_table = array(
			'files'       => 'function',
			'hr'          => 'hr',
			'name'        => 'text',
			'act'         => 'checkbox',
			'hr1'         => 'hr',
			'images'      => 'module',
			'hr2'         => 'hr',
			'cat_id'      => 'function',
			'hr3'         => 'hr',
			'tags'        => 'module',
			'hr4'         => 'hr',
			'comments'    => 'module',
			'rating'      => 'module',
			'hr5'         => 'hr',
			'menu'        => 'module',
			'number'      => 'function',
			'timeedit'    => 'function',
			'title_meta'  => 'text',
			'keywords'    => 'text',
			'descr'       => 'textarea',
			'rewrite'     => 'function',
			'site_id'     => 'function',
			'map_no_show' => 'checkbox',
			'anons'       => 'editor',
			'text'        => 'editor'
		);
		
		//поля, которые прячутся в Дополнительно
		$this->variable_other = array(
			'keywords'    => 1,
			'title_meta'  => 1,
			'descr'       => 1,
			'site_id'     => 1,
			'tags'        => 1,
			'comments'    => 1,
			'rating'      => 1,
			'rewrite'     => 1,
			'timeedit'    => 1,
			'number'      => 1,
			'hr3'         => 1,
			'hr4'         => 1,
			'hr5'         => 1,
			'map_no_show' => 1,
			'menu'        => 1
		);
		
		//переводимые поля
		$this->language_names = array(
			'name',
			'title_meta',
			'act',
			'keywords',
			'descr',
			'text',
			'anons'
		);

		$this->config_module = array(
			'act'              => 1, //показать/скрыть
			'del'              => 1, //удалить
			'order'            => 1, //сортируется
			'menu'             => 1, //используется в меню
			'element_site'     => 1, //модуль может быть прикреплен к нескольким страницам
			'element'          => $this->diafan->configmodules("cat", "files", $this->diafan->site) ? 1 : 0, //используются группы
			'element_multiple' => $this->diafan->configmodules("cat", "files", $this->diafan->site) ? 1 : 0, //модуль может быть прикреплен к нескольким группам
			'search_name'      => 1, //искать по названию
			'trash'            => 1, //использовать корзину
			'image'            => 1  //показать фотографию в списке
		);

		if (! extension_loaded('gd') && ! extension_loaded('gd2'))
		{
			$this->diafan->error = 7;
		}

		//высота поля для Визуального редактора
		$this->editor_height = array(
			'anons' => 200,
			'text'  => 400
		);
	}

	/**
	 * Выводит список файлов
	 * @return boolean true
	 */
	public function show_module()
	{
		if ($this->config_module['element'] && ! $this->not_empty_categories)
		{
			echo '<p class="red">'.sprintf(_ADMIN_FILES_EMPTY_CATEGORIES, '<a href="'.BASE_PATH_HREF.'files/category/'.($this->diafan->site ? 'site'.$this->diafan->site.'/' : '').'">', '</a>').'</p>';
		}
		else
		{
			$this->addnew_init(_ADMIN_FILES_ADD_FILE);
		}
		echo '<table class="list">';
			$this->list_row();
		echo '</table>';

		return TRUE;
	}

	/**
	 * Выводит подсказки к полю (заменяет основную функцию)
	 * @return boolean true
	 */
	public function show_help_row($key = '')
	{
		$const = strtoupper('_ADMIN_'.$this->file.'_'.$this->key.'_HELP');
		$const2 = strtoupper('_ADMIN_'.$this->key.'_HELP');
		if (! defined($const) && ! defined($const2))
		{
			return;
		}
		$const = str_replace(
				 '%attachment_extensions',
				 $this->diafan->configmodules('attachment_extensions'),
				 (defined($const) ? constant($const) : constant($const2))
			);

		return ' <a href="#" onClick="javascript:show_div(\'help'.$this->key.'\'); return false;"><img src="'.BASE_PATH.'adm/img/quest.gif"></a>'
		.'<div id="help'.$this->key.'" class="help_row">'.$const.'</div>';

		return TRUE;
	}

	/**
	 * Редактирование поля "Файлы"
	 * @return boolean true
	 */
	protected function edit_files_module()
	{
		$file_type = 1;
		echo '
		<tr>
			<td align="right">'.$this->variable_names().'</td>
			<td>';
			if (! empty($this->values["link"]))
			{
				$file_type = 2;
			}
			else
			{
				$this->values["link"] = '';
				$result = DB::query("SELECT id,name FROM {attachments} WHERE module_name='".$this->table."' AND element_id='%d'", $this->diafan->edit);
				while ($row = DB::fetch_array($result))
				{
					echo '<input type="checkbox" name="filedel[]" value="'.$row["id"].'" />
					<a href="'.BASE_PATH.'attachments/get/'.$row["id"]."/".$row["name"].'">'.$row["name"].'</a><br>
					';
				}
			}
		echo '
		<input type="radio" name="file_type" value="1"'.($file_type == 1 ? ' checked' : '').'> '._ADMIN_FILES_UPLOAD.'
		<input type="radio" name="file_type" value="2"> '._ADMIN_FILES_UPLOAD_LINK.'
		<input type="radio" name="file_type" value="3"'.($file_type == 2 ? ' checked' : '').'> '._ADMIN_FILES_LINK.'

			<div class="file_type1'.($file_type == 2 ? ' hide' : '').'"><input type="file" name="attachment" size="40">'.$this->show_help_row().'</div>
			<div class="file_type2 hide"><input type="text" name="attachment_link_upload" size="40" value="">'.$this->show_help_row().'</div>
			<div class="file_type3'.($file_type == 1 ? ' hide' : '').'"><input type="text" name="attachment_link" size="40" value="'.$this->values["link"].'"></div>
			</td>
		</tr>';

		return TRUE;
	
	}

	/**
	 * Сохранение поля "Файлы"
	 * @return boolean true
	 */
	protected function save_files_module()
	{
		$altname = str_replace('/', '_', strtolower(substr($this->diafan->translit($_POST["name"]), 0, 40)));

		$result = DB::query("SELECT id FROM {attachments} WHERE module_name='".$this->table."' AND element_id='%d'", $this->diafan->save);
		while ($row = DB::fetch_array($result))
		{
			if (! empty($_POST["filedel"]) && in_array($row["id"], $_POST["filedel"]))
			{
				DB::query("DELETE FROM {attachments} WHERE id='%d'", $row["id"]);
				unlink(ABSOLUTE_PATH.USERFILES.'/'.$this->table.'/files/'.$row["id"]);
			}
		}
		
		if (empty($_POST["file_type"]))
			return;
		if ($_POST["file_type"] == 1 && isset($_FILES["attachment"]) && is_array($_FILES["attachment"]) && $_FILES["attachment"]['name'] != '')
		{
			$oldid = DB::query_result("SELECT id FROM {attachments} WHERE module_name='%s' AND element_id='%d'", $this->table,  $this->diafan->save);
			if ($oldid)
			{
				unlink(ABSOLUTE_PATH.USERFILES.'/'.$this->table.'/files/'.$oldid);
				DB::query("DELETE FROM {attachments} WHERE module_name='%s' AND element_id='%d'", $this->table, $this->diafan->save);
			}

			include_once (ABSOLUTE_PATH."modules/attachments/attachments.inc.php");

			$err = $this->diafan->_attachments->upload($_FILES['attachment'], $this->table, $this->diafan->save);

			if (! empty($err))
			{
				echo '
				<script language="javascript" type="text/javascript">
					alert(\''.strip_tags($err).'\');
					window.location="'.BASE_PATH_HREF.$this->diafan->rewrite.'/'
					.($this->diafan->cat ? 'cat'.$this->diafan->cat.'/' : '')
					.($_POST["id"] ? 'edit'.$_POST["id"].'/' : 'addnew1/')
					.'";
				</script>';
				exit;
				echo '<script language="javascript" type="text/javascript">alert(\''.strip_tags($err).'\');history.go(-1);</script>';
				exit;
			}

			$this->query[] = "link='%h'";
			$this->value[] = "";
		}
		if ($_POST["file_type"] == 2 && ! empty($_POST['attachment_link_upload']))
		{
			$oldid = DB::query_result("SELECT id FROM {attachments} WHERE module_name='%s' AND element_id='%d'", $this->table,  $this->diafan->save);
			if ($oldid)
			{
				unlink(ABSOLUTE_PATH.USERFILES.'/'.$this->table.'/files/'.$oldid);
				DB::query("DELETE FROM {attachments} WHERE module_name='%s' AND element_id='%d'", $this->table, $this->diafan->save);
			}

			$extension = strtolower(substr(strrchr($_POST['attachment_link_upload'], '.'), 1));
			$name = $altname.'.'.$extension;

			if ($this->diafan->configmodules('attachment_extensions', 'files', $_POST["site_id"]) 
			&& ! in_array($extension, explode(',', str_replace(' ', '', strtolower($this->diafan->configmodules('attachment_extensions', 'files', $_POST["site_id"]))))))
			{
				echo '
				<script language="javascript" type="text/javascript">
					alert(\''
					.sprintf(_LANG_ATTACHMENT_EXTENSIONS, $name).$this->diafan->configmodules('attachment_extensions', 'files', $_POST["site_id"])
					.'. '._LANG_ATTACHMENT_NEW_EXTENSIONS
					.'\');
					window.location="'.BASE_PATH_HREF.$this->diafan->rewrite.'/'
					.($this->diafan->cat ? 'cat'.$this->diafan->cat.'/' : '')
					.($_POST["id"] ? 'edit'.$_POST["id"].'/' : 'addnew1/')
					.'";
				</script>';
				exit;
			}

			DB::query("INSERT INTO {attachments} (name,module_name,element_id) VALUES ('%s','%s','%d')",
			          $name, $this->table, $this->diafan->save);
			$newid = DB::next_id("attachment");
			
			if (! copy($_POST['attachment_link_upload'], ABSOLUTE_PATH.USERFILES.'/'.$this->table.'/files/'.$newid))
			{
				DB::query("DELETE FROM {attachments} WHERE id=%d", $newid);
				echo '<script language="javascript" type="text/javascript">alert(\''.strip_tags($err).'\');history.go(-1);</script>';
				exit;
			}

			$size = filesize(ABSOLUTE_PATH.USERFILES.'/'.$this->table.'/files/'.$newid);
			DB::query("UPDATE {attachments} SET size='%d' WHERE id=%d", $size, $newid);

			$this->query[] = "link='%h'";
			$this->value[] = "";
		}
		if ($_POST["file_type"] == 3)
		{
			$this->query[] = "link='%h'";
			$this->value[] = $_POST["attachment_link"];
		}

		return TRUE;
	}
}