<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Forum_admin_element
 *
 * Редактирование сообщений
 */
class Forum_admin_element extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'forum';

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'forum';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		$this->diafan->nastr = 30;

		//поля в базе данных для редактирования
		$this->variable_table = array(
			'act'         => 'checkbox',
			'del'         => 'checkbox',
			'author'      => 'function',
			'created'     => 'datetime',
			'user_update' => 'function',
			'cat_id'      => 'function',
			'text'        => 'textarea',
			'attachments' => 'module'
		);

		$this->config_module = array(
			'del'      => 1, //удалить
			'act'      => 1, //показать/скрыть
			'element'  => 1, //используются группы
			'trash'    => 1, //использовать корзину
			'datetime' => 1, //показывать дату и время в списке, сортировать по дате 
			'parent'   => 1  //содержит вложенности
		);
	}

	/**
	 * Выводит список сообщений
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->name = "text";
		echo '<table class="list">';
		$this->list_row();
		echo '</table>';

		return TRUE;
	}

	/**
	 * Редактирование поля "Обновление"
	 * @return boolean true
	 */
	protected function edit_user_update_module()
	{
		if (! $this->value)
			return;
		echo '
		<tr>
			<td class="td_first">'.$this->variable_names().'</td>
			<td>'
			.DB::query_result("SELECT fio FROM {users_site} WHERE id=%d", $this->value).', '.date("d.m.Y H:i", $this->values["date_update"])
			.$this->show_help_row().'
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Редактирование поля "Автор"
	 * @return boolean true
	 */
	protected function edit_author_module()
	{
		echo '
		<tr>
			<td class="td_first">'.$this->variable_names().'</td>
			<td>'
			.(! $this->value ? _LANG_GUEST : DB::query_result("SELECT fio FROM {users_site} WHERE id=%d", $this->value))
			.$this->show_help_row().'
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Сохранение поля "Обновление"
	 * @return boolean true
	 */
	protected function save_user_update_module()
	{
		return TRUE;
	}

	/**
	 * Сохранение поля "Автор"
	 * @return boolean true
	 */
	protected function save_author_module()
	{
		return TRUE;
	}

	/**
	 * Удаляет категорию
	 * @return boolean
	 */
	public function del_module()
	{
		// Прошел ли пользователь проверку идентификационного хэша
		if (! $this->diafan->_user->checked)
		{
			$this->diafan->redirect(URL);
			return FALSE;
		}

		if ($this->diafan->admin_roles('del'))
		{
			$this->diafan->redirect(URL);
			return FALSE;
		}

		if (! empty($_POST["id"]))
		{
			$ids = array($_POST["id"]);
		}
		else
		{
			$ids = $_POST["ids"];
		}
		foreach ($ids as $id)
		{
			$id = intval($id);
			$dels = $this->diafan->get_children($id, "forum");
			$dels[] = $id;
			DB::query("DELETE FROM {forum_show} WHERE table_name='forum' AND element_id IN (".implode(",", $dels).")");
		}

		parent::del_module();

		return TRUE;
	}
}