<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Forum_sitemap
 *
 * Карта модуля "Форум"
 */
class Forum_sitemap
{
	/**
	 * Генерирует карту модуля
	 * 
	 * @param integer $site_id номер страницы сайта
	 * @param integer $timeedit время редактирования страницы
	 * @return boolean true
	 */
	public function get($site_id, $timeedit)
	{
		$ids = array();
		$result = DB::query("SELECT id FROM {forum_category} WHERE trash='0' AND parent_id=0 AND act='1' AND del='0'");
		while ($row = DB::fetch_array($result))
		{
			$ids[] = $row["id"];
		}
		if (! $ids)
		{
			return TRUE;
		}
		$cats = array();
		$result = DB::query("SELECT id, message_update FROM {forum_category} WHERE trash='0' AND parent_id IN (".implode(',', $ids).") AND act='1' AND del='0'");
		while ($row = DB::fetch_array($result))
		{
			$count = DB::query_result("SELECT COUNT(*) FROM {forum_category} WHERE parent_id=%d AND act='1' AND del='0' AND trash='0'", $row["id"]);
			$nastr = $this->diafan->configmodules("nastr", "forum", $site_id);
			$link = $this->diafan->_route->link($site_id, 'forum').'cat'.$row["id"].'/';
			foreach ($this->lang as $l)
			{
				echo '<url>'
				.'<loc>'. BASE_PATH.$l["name"].$link.'</loc>'
				.'<lastmod>'.date('Y-m-d', $row["message_update"]).'</lastmod>'
				.'</url>';
				if ($count > $nastr)
				{
					for ($i = 2; $i <= ceil($count/$nastr); $i++)
					{
						echo '<url>'
						.'<loc>'.BASE_PATH.$l["name"].$link.'page'.$i.'/</loc>'
						.'<lastmod>'.date('Y-m-d', $timeedit).'</lastmod>'
						.'</url>';
					}
				}
			}
			$cats[] = $row["id"];
		}
		if (! $cats)
		{
			return TRUE;
		}
		$result = DB::query("SELECT id, message_update FROM {forum_category} WHERE trash='0' AND parent_id IN (".implode(',', $cats).") AND act='1' AND del='0'");
		while ($row = DB::fetch_array($result))
		{
			$link = $this->diafan->_route->link($site_id, 'forum').'show'.$row["id"].'/';
			foreach ($this->lang as $l)
			{
				echo '<url>'
				.'<loc>'. BASE_PATH.$l["name"].$link.'</loc>'
				.'<lastmod>'.date('Y-m-d', $row["message_update"]).'</lastmod>'
				.'</url>';
			}
		}
		return TRUE;
	}
}