<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Forum_view
 *
 * Шаблон модуля "Форум"
 */
class Forum_view extends View
{
	/**
	 * Шаблон первой страницы форума
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function first_page($result)
	{
		echo '
		<script type="text/javascript" src="'.BASE_PATH.'modules/forum/forum.js"></script>';

		if (! empty($result["new_message"]))
		{
			echo '<div class="forum_new_messages"><a href="?new=1">'.$this->_('FORUM_NEW_MESSAGE').' ('.$result["new_message"].')</a></div>';
		}
		
		echo '<table class="forum_list">
			<tr><th>'.$this->_('CATEGORIES').'</th><th>'.$this->_('COUNT_THEMES').'</th><th>'.$this->_('LAST_MESSAGE').'</th></tr>';
		// категории тем. первый уровень
		foreach ($result["cats"] as $cat)
		{
			echo '<tr><td class="forum_title" colspan="3">'.$cat["name"].'</td></tr>';
			// категории тем. второй уровень
			foreach ($cat["rows"] as $row)
			{
				echo '
				<tr>
					<td class="forum_category_name';
					// в теме есть новые сообщения
					if ($row["theme_news"])
					{
						echo ' forum_news';
					}
					echo '">
						<a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["name"].'</a>
					</td>
					<td  class="forum_count">'
						// количество тем в категории
						.$row["count_caregory"].'
					</td>
					<td class="forum_last_theme">';
					// последняя обсуждаемая тема в категории
					if ($row["last_theme"])
					{
						// название последней темы
						echo '<a href="'.BASE_PATH_HREF.$row["last_theme"]["link"].'">'.$row["last_theme"]["name"].'</a>';
						if ($row["last_theme"]["message_update"])
						{
							// дата последней темы
							echo '<br><span class="forum_date">'.$row["last_theme"]["message_update"].'</span>';
						}
					}
					echo '
					</td>
				</tr>';
				$themes = TRUE;
			}
		}
		echo '
		</table>';
		if (empty($themes))
		{
			echo '<div class="errors">'.$this->_('FORUM_EMPTY_CATEGORY').'</div>';
		}

		// форма поиска по темам и сообщениям
		self::form_search($result["action"]);

		return TRUE;
	}

	/**
	 * Шаблон списка категорий форума
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function list_category($result)
	{
		echo '
		<script type="text/javascript" src="'.BASE_PATH.'modules/forum/forum.js"></script>';

		echo ($result["access_add"] ? '<div class="forum_add"><a href="'.BASE_PATH_HREF.$result["link_add"].'">'.$this->_('FORUM_ADD').'</a></div>' : '').'

		<table class="forum_list">
			<tr><th>'.$this->_('THEMES').'</th><th>'.$this->_('ANSWERS').'</th><th>'.$this->_('AUTHOR').'</th><th colspan="2">'.$this->_('LAST_ANSWER').'</th></tr>';
		foreach ($result["rows"] as $row)
		{
			$result["row"] = $row;
			echo '<tr id="forum_category_'.$row["id"].'">'.self::list_id_category($result).'</tr>';
		}
		echo '
		</table>
		'.(! empty($result["paginator"]) ? $result["paginator"] : '');

		// форма поиска по темам и сообщениям
		self::form_search($result["action"]);

		return TRUE;
	}

	/**
	 * Шаблон вывода отдельной темы в категории
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return string
	 */
	public function list_id_category($result)
	{
		$row = $result["row"];
		$text = '<td class="forum_theme_name';
		// в теме есть новые сообщения
		if ($row["messages_new"] || $row["theme_news"])
		{
			$text .= ' forum_news';
		}
		$text .= '">';
		// тема удалена
		if ($row["del"])
		{
			$text .= '<span class="forum_blocked">'.sprintf($this->_('THEME_DELETED'), $row["user_update"], '<span class="forum_name">'.$row["name"].'</span>').'</span>';
		}
		// тема заблокирована
		elseif (! $row["act"])
		{
			$text .= '<span class="forum_blocked">'.$this->_('BLOCKED').': '.$row["name"].'</span>';
		}
		// тема активна
		else
		{
			$text .= '<a href="'.BASE_PATH_HREF.$row["link"].'" class="forum_name">'.$row["name"].'</a>';
		}
		$text .= '
		</td>
		<td class="forum_count_message">'
			// ответов новых/всего
			.($row["messages_new"] ? '<span class="forum_active">'.$row["messages_new"].'</span>/' : '').$row["messages"].'
		</td>
		
		<td class="forum_author_date">';
			// автор темы
			if ($row["author"])
			{
				$text .= '<span class="forum_author">'.self::author($row["author"]).'</span><br>';
			}
			// дата создания, редакции темы
			$text .= '<span class="forum_date">'.$row["created"].'</span>
		</td>
		<td class="forum_last_user">';
			// автор и дата последнего сообщения в теме
			if ($row["last_user"])
			{
				$text .= '<span class="forum_author">'.self::author($row["last_user"]["author"]).'</span><br>
				<span class="forum_date">'.$row["last_user"]["created"].'</span>';
			}
			$text .= '
		</td>
		<td>';
		if ($row["access_edit_delete"] || $row["access_block"])
		{
			$text .= '
			<div class="forum_actions">
			<form method="POST" action="" class="ajax">
			<input type="hidden" name="action" value="">
			<input type="hidden" name="ajax" value="">
			<input type="hidden" name="module" value="forum">
			<input type="hidden" name="check_hash_user" value="'.$result["hash"].'">
			<input type="hidden" name="id" value="'.$row["id"].'">
				<span>';
				if ($row["access_edit_delete"])
				{
					// удалить тему
					$text .= '<a href="javascript:void(0)" title="'.$this->_('CONFIRM_DELETE', FALSE).'" action="delete-category">'
					.'<img src="'.BASE_PATH.'modules/forum/img/delete.gif" width="15" height="15"'
					.' title="'.$this->_('DELETE',  FALSE).'" alt="'.$this->_('DELETE', FALSE).'">'
					.'</a>'

					// редактировать тему
					.'<a href="'.BASE_PATH_HREF.$row["link_edit"].'">'
					.'<img src="'.BASE_PATH.'modules/forum/img/edit.gif" width="12" height="14"'
					.' title="'.$this->_('EDIT', FALSE).'" alt="'.$this->_('EDIT', FALSE).'">'
					.'</a>';
				}
				if ($row["access_block"])
				{
					if ($row["act"])
					{
						// блокировать тему
						$text .= '<a href="javascript:void(0)" action="block-category">'
						.'<img src="'.BASE_PATH.'modules/forum/img/block.gif" width="12" height="18"'
						.' title="'.$this->_('FORUM_BLOCK', FALSE).'" alt="'.$this->_('FORUM_BLOCK', FALSE).'">'
						.'</a>';
					}
					else
					{
						// разблокировать тему
						$text .= '<a href="javascript:void(0)" action="unblock-category">'
						.'<img src="'.BASE_PATH.'modules/forum/img/unblock.gif" width="12" height="18"'
						.' title="'.$this->_('FORUM_UNBLOCK', FALSE).'" alt="'.$this->_('FORUM_UNBLOCK', FALSE).'">'
						.'</a>';
					}
					if ($row["close"])
					{
						// открыть тему
						$text .= '<a href="javascript:void(0)" action="open-category">'
						.'<img src="'.BASE_PATH.'modules/forum/img/lock.png" width="16" height="16"'
						.' title="'.$this->_('FORUM_OPEN', FALSE).'" alt="'.$this->_('FORUM_OPEN', FALSE).'">'
						.'</a>';
					}
					else
					{
						// закрыть тему
						$text .= '<a href="javascript:void(0)" action="close-category">'
						.'<img src="'.BASE_PATH.'modules/forum/img/lock_off.png" width="16" height="16"'
						.' title="'.$this->_('FORUM_CLOSE', FALSE).'" alt="'.$this->_('FORUM_CLOSE', FALSE).'">'
						.'</a>';
					}

					if ($row["prior"])
					{
						// открепить тему
						$text .= '<a href="javascript:void(0)" action="unprior-category">'
						.'<img src="'.BASE_PATH.'modules/forum/img/down.gif" width="14" height="16"'
						.' title="'.$this->_('UNPRIOR', FALSE).'" alt="'.$this->_('UNPRIOR', FALSE).'">'
						.'</a>';
					}
					else
					{
						// закрепить тему
						$text .= '<a href="javascript:void(0)" action="prior-category">'
						.'<img src="'.BASE_PATH.'modules/forum/img/up.gif" width="14" height="16"'
						.' title="'.$this->_('FORUM_PRIOR', FALSE).'" alt="'.$this->_('FORUM_PRIOR', FALSE).'">'
						.'</a>';
					}
				}
				$text .= '</span>
				</form>
			</div>';
		}
		$text .= '</td>';
		return $text;
	}

	/**
	 * Шаблон вывода результатов поиска сообщений
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function list_search($result)
	{
		echo '<script type="text/javascript" src="'.BASE_PATH.'modules/forum/forum.js"></script>';

		echo '
		<div class="forum_search_result">
			'.$this->_('TOTAL_FOUND').": <b>".$result["value"].": ".$result["count"]."</b>
			<br>
			".sprintf($this->_('COUNT_SEARCH'), $result["count-page"], $result["count"]).'
		</div>';

		if ($result["rows"])
		{
			foreach ($result["rows"] as $row)
			{
				if ($row["type"] == "message")
				{
					echo '
					<div class="forum_message">
						<a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["theme"].'</a>
						<br>
						<span class="forum_author">'.self::author($row["author"]).'</span>, <span class="forum_date">'.$row['created'].'</span>
						<br>
						'.$row['text'].'
					</div>';
				}
				else
				{
					echo '
					<div class="forum_category">
						<a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["theme"].'</a>
						<br>
						<span class="forum_author">'.self::author($row["author"]).'</span>, <span class="forum_date">'.$row['created'].'</span>
					</div>';
				}
			}
		}
		echo (! empty($result["paginator"]) ? $result["paginator"] : '');

		// форма поиска по темам и сообщениям
		self::form_search($result["action"], $result["value"]);

		return TRUE;
	}

	/**
	 * Шаблон страницы новых сообщений
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function list_new($result)
	{
		echo '<script type="text/javascript" src="'.BASE_PATH.'modules/forum/forum.js"></script>';

		if ($result["rows"])
		{
			foreach ($result["rows"] as $row)
			{
				echo '
				<div class="forum_message">
					<a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["theme"].'</a>
					<br>
					<span class="forum_author">'.$row["author"].'</span>, <span class="forum_date">'.$row['created'].'</span>
					<br>
					'.$row['text'].'
				</div>';
			}
		}
		echo (! empty($result["paginator"]) ? $result["paginator"] : '');

		// форма поиска по темам и сообщениям
		self::form_search($result["action"]);

		return TRUE;
	}

	/**
	 * Шаблон редактировани/добавления категории
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function edit($result)
	{
		echo ($result["premoderation"] ? '<p>'.$this->_('THEME_ADDED_MODERATOR').'</p>' : '').'

		<form action="" method="POST" class="ajax forum_form">
		<input type="hidden" name="ajax" value="0">
		<input type="hidden" name="module" value="forum">
		<input type="hidden" name="action" value="'.$result["action"].'">
		<input type="hidden" name="id" value="'.$result["id"].'">
		<input type="hidden" name="parent_id" value="'.$result["parent_id"].'">
		<input type="hidden" name="check_hash_user" value="'.$result["hash"].'">

		<div class="infofield">'.$this->_('NAME').':</div>
		<input type="text" name="name" size="40" value="'.$result["name"].'" class="inptext">
		<div class="errors error_name"'.($result["error_name"] ? '>'.$result["error_name"] : ' style="display:none">').'</div>
		
		'.($result["captcha"] ? $result["captcha"] : '').'

		<span class="button_wrap"><input type="submit" value="'.(! $result["name"] ? $this->_('CREATE', FALSE) : $this->_('SAVE', FALSE)).'" class="button"></span>
		<div class="errors error"'.($result["error"] ? '>'.$result["error"] : ' style="display:none">').'</div>

		</form>';

		return TRUE;
	}

	/**
	 * Шаблон страницы категории
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function id($result)
	{
		echo '<script type="text/javascript" src="'.BASE_PATH.'modules/forum/forum.js"></script>'

		.$result["messages"];

		return TRUE;
	}

	/**
	 * Шаблон формы поиска по темам и сообщениям
	 *
	 * @param string $action страница, на которой будут выведены результаты поиска
	 * @param string $value введенные поисковый запрос
	 * @return boolean true
	 */
	private function form_search($action, $value = '')
	{
		echo '
		<div class="forum_search">
			<form action="'.BASE_PATH_HREF.$action.'" method="GET">
				<input type="text" name="searchword" value="'.$value.'" size="20" class="inptext">
				<span class="button_wrap"><input type="submit" value="'.$this->_('SEARCH', FALSE).'" class="button"></span>
			</form>
		</div>';

		return TRUE;
	}

	/**
	 * Шаблон вывода информации о пользователе
	 *
	 * @param array $user информация о пользователе
	 * @return string
	 */
	private function author($user)
	{
		if (is_array($user))
		{
			return $user["fio"].' ('.$user["name"].')';
		}
		else
		{
			return $user;
		}
	}
}