<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(dirname(__FILE__)))).'/includes/404.php');
}

/**
 * Forum_message_view
 *
 * Шаблон сообщений модуля "Форум"
 */
class Forum_message_view extends View
{
	/**
	 * Шаблон списка и формы добавления сообщений модуля
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return string
	 */
	public function show_module($result)
	{
		$text = '';
		if (! empty($result["close"]))
		{
			$text .= '<div class="forum_active">'.$this->_('FORUM_THEME_CLOSE').'</div>';
		}
		$text .= '<script type="text/javascript" src="'.BASE_PATH.'modules/forum/bbeditor/ed.js"></script>';
		$text .= '<input type="hidden" name="check_hash_user" value="'.$result["hash"].'">';
		$text .= '<div class="message0-result">';
		if ($result["rows"])
		{
			$text .= self::show_list($result);
		}
		$text .= '</div>';
		$result["current_level"] = 0;
		$text .= self::add($result);
		return $text;
	}

	/**
	 * Шаблон списка сообщений
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return string
	 */
	public function show_list($result)
	{
		$text = '';
		foreach ($result["rows"] as $row)
		{
			if (empty($result["edit"]))
			{
				$text .= '<div id="show_message'.$row["id"].'" class="forum_message'.($row["show"] ? ' forum_news':'').'">';
			}
			$text .= '
			<form method="POST" action="'.$result["action"].'" class="ajax">
				<a name="'.$row["id"].'"></a>
				<input type="hidden" name="action" value="">
				<input type="hidden" name="ajax" value="">
				<input type="hidden" name="module" value="forum">
				<input type="hidden" name="check_hash_user" value="'.$result["hash"].'">
				<input type="hidden" name="id" value="'.$row["id"].'">';
			if ($row["del"])
			{
				$text .= '<span class="forum_blocked">';
				if ($row["access_edit_delete"])
				{
					$text .= sprintf($this->_('MESSAGE_DELETED_MODERATOR'), $row["user_update"], $row["text"]);
				}
				else
				{
					$text .= $this->_('MESSAGE_DELETED');
				}
				$text .= '</span>
				</form>';
			}
			else
			{
				$text .=
				'<div class="forum_actions">
				<span>
				<a href="#'.$row["id"].'"><img src="'.BASE_PATH.'modules/forum/img/link.gif" title="'.$this->_('LINK', FALSE).'" alt="'.$this->_('LINK', FALSE).'"></a> ';
				if ($row["access_edit_delete"])
				{
					// удалить сообщение
					$text .= '<a href="javascript:void(0)" action="delete-message" title="'.$this->_('CONFIRM_DELETE', FALSE).'">'
					.'<img src="'.BASE_PATH.'modules/forum/img/delete.gif" width="15" height="15"'
					.' title="'.$this->_('DELETE', FALSE).'" alt="'.$this->_('DELETE', FALSE).'">'
					.'</a>';

					// редактировать сообщение
					$text .= ' <a href="javascript:void(0)" action="edit-message">'
					.'<img src="'.BASE_PATH.'modules/forum/img/edit.gif" title="'.$this->_('EDIT', FALSE).'" alt="'.$this->_('EDIT', FALSE).'"></a>';
				}
				if ($row["access_block"])
				{
					$text .= ' <a href="javascript:void(0)" action="block-message">'
					.'<img src="'.BASE_PATH.'modules/forum/img/'.($row["act"] ? 'block' : 'unblock').'.gif"
					title="'.(! $row["act"] ? $this->_('FORUM_UNBLOCK', FALSE) : $this->_('FORUM_BLOCK', FALSE)).'"
					alt="'.(! $row["act"] ? $this->_('FORUM_UNBLOCK', FALSE) : $this->_('FORUM_BLOCK', FALSE)).'"></a>';
				}
				$text .= '</span></div>';

				$result["current_level"] = $row["id"];

				if (! $row["act"])
				{
					$text .= '<span class="forum_blocked">'.$this->_('BLOCKED')
					         .($row["access_edit_delete"] ? ': '.$row["text"] : '').'</span>
					</form>';
				}
				else
				{
					$text .= '<span class="forum_author">'.self::author($row["author"]).'</span>, <span class="forum_date">'.$row['created'].'</span>
					<div class="forum_text">'.$row['text'].'</div>
					<div class="errors error" style="display:none"></div>
					'.self::get_attachments($row["attachments"], $row["access_edit_delete"], $result["use_animation"]).'
					</form>';
					if (empty($result["level"]) || $result["level"] < 6)
					{
						$text .= self::add($result, $row["id"]);
					}
				}
			}
			if (empty($result["edit"]))
			{
				$text .= '</div>';
			}

			if ($row["children"])
			{
				$result_children          = $result;
				$result_children["rows"]  = $row["children"];
				$result_children["level"] = empty($result["level"]) ? 1 : $result["level"] + 1;
				$text .= '<div class="forum_message_level message'.$row["id"].'-result">'.self::show_list($result_children).'</div>';
			}
			else
			{
				$text .= '<div class="forum_message_level message'.$row["id"].'-result" style="display:none;"></div>';
			}
		}
		return $text;
	}

	/**
	 * Шаблон формы добавления сообщения
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @param integer $parent_id номер сообщения-родителя
	 * @return string|boolean false
	 */
	public function add($result)
	{
		if (empty($result["access_add"]))
			return FALSE;

		$text = "";
		
		if ($result["current_level"]==0) { $text .= '<br><br>'; }
		
		$text .= '<a href="javascript:void(0)" class="forum_dashed_link show_block" rel="message'.$result["current_level"].'-result">';
		if ($result["current_level"])
		{
			$text .= $this->_('RESPOND');
		}
		else
		{
			$text .= $this->_('ADD_MESSAGE');
		}
		$text .= '</a>';

		$text .= '<form method="POST" action="'.$result["action"].'" class="forum_form ajax" id="message'.$result["current_level"].'-result" style="display:none">';
			if ($result["premoderation"])
			{
				$text .= '<p>'.$this->_('MESSAGE_ADDED_MODERATOR').'</p>';
			}
			$text .= '<input type="hidden" name="ajax" value="0">
			<input type="hidden" name="module" value="forum">
			<input type="hidden" name="action" value="upload-message">
			<input type="hidden" name="check_hash_user" value="'.$result["hash"].'">
			<input type="hidden" name="parent_id" value="'.$result["current_level"].'">';

			$text .= self::bbcode($result["current_level"]);

		//Прикрепляемые файлы
		if ($result["add_attachments"])
		{
			$text .= '
			<div class="infofield">'.$this->_('ATTACHMENTS').':</div>
			<input type="file" name="attachments[]" class="inpfile" max="'.$result["max_count_attachments"].'">
			<div class="errors error_attachments"'.(! empty($result["error_attachments"]) ? '>'.$result["error_attachments"] : ' style="display:none">').'</div>';
			if ($result["attachment_extensions"])
			{
				$text .= '<div class="attachment_extensions">('.$this->_('FORUM_ATTACHMENT_EXTENSIONS').': '.$result["attachment_extensions"].')</div>';
			}
		}

		//Защитный код
		$text .= $result["captcha"];

		//Кнопка Отправить
			
			$text .= '<span class="button_wrap"><input type="submit" value="'.$this->_('SEND',  FALSE).'" class="button"></span>';
			
			$text .= '<div class="errors error"'.(! empty($result["error"]) ? '>'.$result["error"] : ' style="display:none">').'</div>
		</form>';
		
		if ($result["current_level"]==0) { $text .= '<br><br>'; }

		return $text;
	}

	/**
	 * Шаблон формы редактирования сообщения
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return string
	 */
	public function edit($result)
	{
		if (! $result["access_add"])
			return;

		$text = '<form method="POST" action="'.$result["action"].'" class="forum_form ajax">';
			if ($result["premoderation"])
			{
				$text .= '<p>'.$this->_('MESSAGE_ADDED_MODERATOR').'</p>';
			}
			$text .= '<input type="hidden" name="module" value="forum">
			<input type="hidden" name="action" value="save-message">
			<input type="hidden" name="ajax" value="">
			<input type="hidden" name="check_hash_user" value="'.$result["hash"].'">
			<input type="hidden" name="save_id" value="'.$result["id"].'">';

			$text .= self::bbcode($result["id"], $result["text"]);

		//Прикрепляемые файлы
		if ($result["add_attachments"])
		{
			$text .= '<div class="infofield">'.$this->_('ATTACHMENTS').':</div>
			<input type="file" name="attachments[]" class="inptext" max="'.$result["max_count_attachments"].'">
			<div class="errors error_attachments"'.(! empty($result["error_attachments"]) ? '>'.$result["error_attachments"] : ' style="display:none">').'</div>';
			if ($result["attachment_extensions"])
			{
				$text .= '<span class="attachment_extensions">('.$this->_('FORUM_ATTACHMENT_EXTENSIONS').': '.$result["attachment_extensions"].')</span>';
			}
			$text .= self::get_attachments($result["attachments"], TRUE, $result["use_animation"]);
		}
			$text .= '<br><br>

			<div class="errors error"'.(! empty($result["error"]) ? '>'.$result["error"] : ' style="display:none">').'</div>';
			$text .= '<span class="button_wrap"><input type="submit" value="'.$this->_('SEND', FALSE).'" class="button">';
			$text .= '</form>
		</div>';
		return $text;
	}

	/**
	 * Шаблон поля, для ввода сообщения
	 *
	 * @param integer $id номер элемента
	 * @param strign $value сообщение для редактирования
	 * @return string
	 */
	private function bbcode($id, $value = '')
	{
		$obj = 'textarea_message_'.$id;

		return '
		<div class="forum_message_toolbar">
			<img class="bbutton" src="'.BASE_PATH.'modules/forum/bbeditor/images/bold.gif" name="btnBold" title="Bold" onClick="doAddTags(\'[b]\', \'[/b]\', \''.$obj.'\')">
			<img class="bbutton" src="'.BASE_PATH.'modules/forum/bbeditor/images/italic.gif" name="btnItalic" title="Italic" onClick="doAddTags(\'[i]\', \'[/i]\', \''.$obj.'\')">
			<img class="bbutton" src="'.BASE_PATH.'modules/forum/bbeditor/images/underline.gif" name="btnUnderline" title="Underline" onClick="doAddTags(\'[u]\',\'[/u]\',\''.$obj.'\')">
			<img class="bbutton" src="'.BASE_PATH.'modules/forum/bbeditor/images/link.gif" name="btnLink" title="Insert URL Link" onClick="doURL(\''.$obj.'\')">
			<img class="bbutton" src="'.BASE_PATH.'modules/forum/bbeditor/images/picture.gif" name="btnPicture" title="Insert Image" onClick="doImage(\''.$obj.'\')">
			<img class="bbutton" src="'.BASE_PATH.'modules/forum/bbeditor/images/ordered.gif" name="btnList" title="Ordered List" onClick="doList(\'[LIST=1]\',\'[/LIST]\',\''.$obj.'\')">
			<img class="bbutton" src="'.BASE_PATH.'modules/forum/bbeditor/images/unordered.gif" name="btnList" title="Unordered List" onClick="doList(\'[LIST]\',\'[/LIST]\',\''.$obj.'\')">
			<img class="bbutton" src="'.BASE_PATH.'modules/forum/bbeditor/images/quote.gif" name="btnQuote" title="Quote" onClick="doAddTags(\'[quote]\',\'[/quote]\',\''.$obj.'\')">
			<img class="bbutton" src="'.BASE_PATH.'modules/forum/bbeditor/images/code.gif" name="btnCode" title="Code" onClick="doAddTags(\'[code]\',\'[/code]\',\''.$obj.'\')">
		</div>
		<div class="forum_message_toolbar">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/smile.gif" onClick="doSmile(\'smile\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/wink.gif" onClick="doSmile(\'wink\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/acute.gif" onClick="doSmile(\'acute\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/bad.gif" onClick="doSmile(\'bad\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/biggrin.gif" onClick="doSmile(\'biggrin\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/blum.gif" onClick="doSmile(\'blum\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/blush.gif" onClick="doSmile(\'blush\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/bomb.gif" onClick="doSmile(\'bomb\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/boredom.gif" onClick="doSmile(\'boredom\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/bye.gif" onClick="doSmile(\'bye\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/clapping.gif" onClick="doSmile(\'clapping\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/cool.gif" onClick="doSmile(\'cool\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/cray.gif" onClick="doSmile(\'cray\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/dance.gif" onClick="doSmile(\'dance\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/diablo.gif" onClick="doSmile(\'diablo\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/drinks.gif" onClick="doSmile(\'drinks\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/empathy.gif" onClick="doSmile(\'empathy\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/flag_of_truce.gif" onClick="doSmile(\'flag_of_truce\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/good.gif" onClick="doSmile(\'good\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/help.gif" onClick="doSmile(\'help\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/hi.gif" onClick="doSmile(\'hi\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/i_am_so_happy.gif" onClick="doSmile(\'i_am_so_happy\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/lol.gif" onClick="doSmile(\'lol\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/nea.gif" onClick="doSmile(\'nea\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/negative.gif" onClick="doSmile(\'negative\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/new_russian.gif" onClick="doSmile(\'new_russian\',\''.$obj.'\')">
		</div>
		<textarea name="message" id="'.$obj.'" class="inptext">'.$value.'</textarea>';
	}

	/**
	 * Шаблон вывода прикрепленных файлов
	 *
	 * @param array $attachments прикрепленные файлы
	 * @param boolean $access доступ на удаление
	 * @param boolean $use_animation использовать анимацию при открытии изображений
	 * @return string
	 */
	private function get_attachments($attachments, $access, $use_animation)
	{
		$text = '';
		foreach ($attachments as $row)
		{
			if ($row["is_image"])
			{
				if ($use_animation)
				{
					$a_href  = '<a href="'.$row["link"].'" rel="prettyPhoto[gallery'.$row["element_id"].$row["module_name"].'_1]">';
					$a_href2 = '<a href="'.$row["link"].'" rel="prettyPhoto[gallery'.$row["element_id"].$row["module_name"].'_2]">';
				}
				else
				{
					$a_href .= '<a href="'.$row["link"].'" rel="big_image" width="'.$row["width"].'" height="'.$row["height"].'">';
					$a_href2 = $a_href;
				}
				$text .=
				'<p id="attachment'.$row["id"].'">'
					.$a_href.$row["name"].'</a>'
					.' ('.$row["size"].')'
					.' '.$a_href2.'<img src="'.$row["link_preview"].'"></a>'
					.($access ? ' <a href="javascript:void(0)" class="delete_attachment" del_id="'.$row["id"].'" title="'.$this->_('CONFIRM_DELETE', FALSE).'">x</a>' : '')
				.'</p>';
			}
			else
			{
				$text .= '<p id="attachment'.$row["id"].'"><a href="'.$row["link"].'">'.$row["name"].'</a> ('.$row["size"].')'
				.($access ? ' <a href="javascript:void(0)" class="delete_attachment" del_id="'.$row["id"].'" title="'.$this->_('CONFIRM_DELETE', FALSE).'">x</a>' : '')
				.'</p>
				';
			}
		}
		return $text;
	}

	/**
	 * Шаблон вывода информации о пользователе
	 *
	 * @param array $user информация о пользователе
	 * @return string
	 */
	private function author($user)
	{
		if (! is_array($user))
		{
			return $user;
		}
		$text = '';
		if (! empty($user["avatar"]))
		{
			$text .= '<img src="'.$user["avatar"].'" width="'.$user["avatar_width"].'" height="'.$user["avatar_height"].'" alt="'.$user["fio"].' ('.$user["name"].')" class="avatar"> ';
		}
		$text .= $user["fio"].' ('.$user["name"].')';
		return $text;
	}
}