<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Images_admin_del
 * 
 * Удаление прикрепленных изображений
 */
class Images_admin_del
{
	/**
	 * Помечает изображения на удаление или удаляет изображения
	 * 
	 * @param string $module_name название модуля, к которому прикреплены изображения
	 * @param integer $element_id номер элемента, к которому прикреплены изображения
	 * @param integer $trash_id номер записи в корзине, с которой связано удаление
	 * @param integer $is_category удаляемый элемент - категория
	 * @return boolean true
	 */
	public static function delete($th, $module_name, $element_id, $trash_id = 0, $is_category = FALSE)
	{
		if (is_dir(ABSOLUTE_PATH.USERFILES."/".$module_name))
		{
			if ($_POST["action"] == "delete")
			{
				$th->diafan->_images->delete($element_id, $module_name.($is_category ? 'cat' : ''));
			}
			$th->del_or_trash_where("images", "element_id='".$element_id."' AND module_name='".$module_name.($is_category ? 'cat' : '')."'", $trash_id);
		}
		return TRUE;
	}

	/**
	 * Удаляет изображение
	 * 
	 * @param integer $id номер удаляемого изображения
	 * @return boolean true
	 */
	public static function del_from_trash($th, $id)
	{
		$row = DB::fetch_array(DB::query("SELECT module_name, element_id FROM {images} WHERE id=%d", $id));
		$th->diafan->_images->delete($row["element_id"], $row["module_name"], $id);
		return TRUE;
	}
}