<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Images_admin_view
 * 
 * Шаблон вывода изображений в административной части
 */
class Images_admin_view
{
	/**
	 * Выводит фотографии, прикрепленные к элементу модуля
	 *
	 * @param integer $element_id номер элемента
	 * @return string
	 */
	public static function show($th, $element_id)
	{
		$text = ' ';
		$k = 1;
		$result = DB::query("SELECT id, name, [alt], [title] FROM {images} WHERE module_name='%s' AND element_id='%d' ORDER BY sort ASC", $th->diafan->module.($th->config_module['category'] ? "cat" : ""), $element_id);
		$count = DB::num_rows($result);
		while ($row = DB::fetch_array($result))
		{
			if (! file_exists(ABSOLUTE_PATH.USERFILES."/".$th->diafan->module.'/'.$row["name"]))
				continue;

			$text .= '
			<div class="images_actions'.($k == 1 ? ' first' :'').'" element_id="'.$element_id.'" image_id="'.$row["id"].'">
				<a href="'.BASE_PATH.USERFILES."/".$th->diafan->module.'/'.$row["name"].'" class="image" target="_blank">'
			       .'<img src="'.BASE_PATH.USERFILES."/".$th->diafan->module."/small/".$row["name"].'?'.rand(0, 9999).'"'
			       .($k == 1 ? ' alt="'._ADMIN_IMAGE_MAIN.'" title="'._ADMIN_IMAGE_MAIN.'"' : '').'>'
			    .'</a>'

				.'<div>'
					.($row["alt"] ? 'alt: '.$row["alt"].' ' : '')
					.($row["title"] ? ($row["alt"] ? '<br>' : '').'title: '.$row["title"] : '&nbsp;')
				.'</div>
				<div class="images_button">
					<a href="javascript:void(0)" confirm="'._ADMIN_IMAGE_CONFIRM_DELETE.'" action="delete">
						<img src="'.BASE_PATH.'adm/img/delete.gif" width="15" height="15" alt="'._LANG_DELETE.'">
					</a>
					<a href="javascript:void(0)" action="edit"><img src="'.BASE_PATH.'adm/img/edit.gif" width="12" height="14" alt="'._LANG_EDIT.'"></a>
					'.($k != 1 ? '
					<a href="javascript:void(0)" action="up">
						<img src="'.BASE_PATH.'adm/img/up.gif" width="14" height="16" alt="'._ADMIN_UP.'">
					</a>' : '').'
					'.($k != $count ? '
					<a href="javascript:void(0)" action="down">
						<img src="'.BASE_PATH.'adm/img/down.gif" width="14" height="16" alt="'._ADMIN_DOWN.'">
					</a> ' : '').'
				</div>
				<div class="clear"></div>
			</div>';
			$k++;
		}
		return $text;
	}
	/**
	 * Выводит все изображения водяных знаков
	 *
	 * @return string
	 */
	public static function show_watermark($th)
	{
		$text = ' ';
		if ($dirr = @opendir(ABSOLUTE_PATH.USERFILES.'/watermark'))
		{
			while (($file = readdir($dirr)) !== FALSE)
			{
				if (is_dir(ABSOLUTE_PATH.USERFILES.'/watermark/'.$file))
				{
					continue;
				}
				$watermark_path = $th->diafan->configmodules("watermark_path");
				$text .= '
				<div class="watermark_actions'.($watermark_path == $file ? ' first' : '').'" file="'.$file.'">'
					.'<img src="'.BASE_PATH.USERFILES.'/watermark/'.$file.'?'.rand(0, 9999).'" class="watermark">
					<div class="images_button">
						<a href="javascript:void(0)" confirm="'._ADMIN_IMAGE_CONFIRM_DELETE.'" action="delete_watermark">
							<img src="'.BASE_PATH.'adm/img/delete.gif" width="15" height="15" alt="'._LANG_DELETE.'">
						</a>
						<input type="checkbox" action="change_watermark"'.($watermark_path == $file ? ' checked' : '').'>
					</div>
					<div class="clear"></div>
				</div>';
			}
			closedir($dirr);
		}
		return $text;
	}

	/**
	 * Форма редактирования атрибутов alt и title для изображения
	 *
	 * @param array $row данные о изображении
	 * @return string
	 */
	public static function edit_attribute($th, $row)
	{
		$text = '<a href="'.BASE_PATH.USERFILES."/".$th->diafan->module.'/'.$row["name"].'" class="image" target="_blank">'
		.'<img src="'.BASE_PATH.USERFILES."/".$th->diafan->module."/small/".$row["name"].'?'.rand(0, 9999).'">'
		.'</a>'

		.'<div>
		<p>alt:   <input name="alt"  type="text" value="'.$row["alt"].'"></p>
		<p>title: <input name="title" type="text" value="'.$row["title"].'"></p>
		<input type="button" value="'._LANG_SAVE.'" class="button ajax_save_image">
		</div>
		<div class="clear"></div>';
		return $text;
	}
}