<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Menu_admin_category
 *
 * Редактирование меню
 */
class Menu_admin_category extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'menu';

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'menu_category';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		//поля в базе данных для редактирования
		$this->variable_table = array(
			'name'             => 'text',
			'number'           => 'function',
			'act'              => 'checkbox',
			'show_title'       => 'checkbox',
			'show_all_level'   => 'checkbox',
			'hide_parent_link' => 'checkbox'
		);
		
		//переводимые поля
		$this->language_names = array(
			'name',
			'act'
		);

		$this->config_module = array(
			'del'             => 1, //удалить
			'act'             => 1, //показать/скрыть
			'category'        => 1, //часть модуля - категории
			'trash'           => 1  //использовать корзину
		);
	}

	/**
	 * Выводит список вопросов
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->addnew_init(_ADMIN_MENU_ADD);
		echo '<table class="list">';
		$this->list_row();
		echo '</table>';

		return TRUE;
	}
}