<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Menu_admin
 *
 * Редактирование пунктов меню
 */
class Menu_admin extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file	=	'menu';

	/**
	 * @var string таблица в базе данных
	 */
	public $table	=	'menu';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
		
		//поля в базе данных для редактирования
		$this->variable_table = array(
			'name'        => 'text',
			'act'         => 'checkbox',
			'module_name' => 'function',
			'parent_id'   => 'function',
			'cat_id'      => 'function',
			'othurl'      => 'text'
		);
		
		//переводимые поля
		$this->language_names = array(
			'name',
			'act'
		);

		$this->config_module = array(
			'del'           => 1, //удалить
			'act'           => 1, //показать/скрыть
			'parent'        => 1, //содержит вложенности
			'trash'         => 1, //использовать корзину
			'order'         => 1, //сортируется
			'element'       => 1, //используются группы
			'category_flat' => 1  // категори не содержат вложенности
		);
		if (! $this->diafan->cat)
		{
			$this->diafan->cat = 1;
		}
	}

	/**
	 * Выводит списко ответов
	 * @return boolean true
	 */
	public function show_module()
	{
		$p = FALSE;
		$cats = array();
		$count = 0;
		$result = DB::query("SELECT id, name FROM {menu_category} WHERE trash='0' ORDER BY id ASC");
		while ($row = DB::fetch_array($result))
		{
			$cats[0][] = $row;
			$count++;
		}
		if ($count > 1)
		{
			if (! $p)
			{
				echo '<p>';
				$p = TRUE;
			}
			echo _ADMIN_CAT_ID.': <select rel="'.path_module($this->diafan, 0, 0, 0, 1).'" class="redirect" name="cat">';
			echo $this->get_options($cats, $cats[0], array($this->diafan->cat))
			.'</select> ';
		}
		if ($p)
		{
			echo '</p>';
		}
		$this->addnew_init(_ADMIN_MENU_ITEM_ADD);
		echo '<table class="list">';
		$this->list_row();	
		echo '</table>';

		return TRUE;
	}

	/**
	 * Редактирование поля "Элемент модуля"
	 * @return boolean true
	 */
	protected function edit_module_name_module()
	{
		if ($this->diafan->addnew)
		{
			$this->values["module_name"]   = '';
			$this->values["element_id"]    = 0;
			$this->values["site_id"]       = 0;
			$this->values["module_cat_id"] = 0;
		}
		echo '
		<script type="text/javascript" src="'.BASE_PATH.'modules/menu/admin/menu.admin.js"></script>
		<tr id="images">
			<td class="td_first">'.$this->variable_names("element_id").'</td>
			<td>';
			if ($this->values["site_id"] && $this->values["module_name"] == "site")
			{
				$name = DB::query_result("SELECT [name] FROM {site} WHERE id=%d", $this->values["site_id"]);
				echo '<a href="'.BASE_PATH_HREF.'site/edit'.$this->values["site_id"].'/" class="menu_base_link">'.$name.'</a>
				<a href="javascript:void(0)"><img src="'.BASE_PATH.'adm/img/edit.gif" width="12" height="14" alt="'._LANG_EDIT.'" class="menu_check"></a>';
			}
			elseif ($this->values["element_id"])
			{
				$name = DB::query_result("SELECT [name] FROM {%s} WHERE id=%d", $this->values["module_name"], $this->values["element_id"]);
				echo '<a href="'.BASE_PATH_HREF.$this->values["module_name"].'/edit'.$this->values["element_id"].'/" class="menu_base_link">'.$name.'</a>
				<a href="javascript:void(0)"><img src="'.BASE_PATH.'adm/img/edit.gif" width="12" height="14" alt="'._LANG_EDIT.'" class="menu_check"></a>';
			}
			elseif ($this->values["module_cat_id"])
			{
				$name = DB::query_result("SELECT [name] FROM {%s_category} WHERE id=%d", $this->values["module_name"], $this->values["module_cat_id"]);
				echo '<a href="'.BASE_PATH_HREF.$this->values["module_name"].'/category/edit'.$this->values["module_cat_id"].'/" class="menu_base_link">'.$name.'</a>
				<a href="javascript:void(0)"><img src="'.BASE_PATH.'adm/img/edit.gif" width="12" height="14" alt="'._LANG_EDIT.'" class="menu_check"></a>';
			}
			else
			{
				echo '<a href="#" class="menu_base_link"></a>
				<a href="#inline" class="menu_check"><img src="'.BASE_PATH.'adm/img/edit.gif" width="12" height="14" alt="'._LANG_EDIT.'"></a>';
			}
			
			echo $this->show_help_row("element_id").'
			<input name="module_name" value="'.$this->values["module_name"].'" type="hidden">
			<input name="site_id" value="'.$this->values["site_id"].'" type="hidden">
			<input name="module_cat_id" value="'.$this->values["module_cat_id"].'" type="hidden">
			<input name="element_id" value="'.$this->values["element_id"].'" type="hidden">
			<div id="inline" class="hide"></div>
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Сохранение поля "Элемент модуля"
	 * @return boolean true
	 */
	protected function save_module_name_module()
	{
		$this->query[] = "module_cat_id='%d'";
		$this->value[] = $_POST["module_cat_id"];

		$this->query[] = "site_id='%d'";
		$this->value[] = $_POST["site_id"];

		$this->query[] = "element_id='%d'";
		$this->value[] = $_POST["element_id"];

		$this->query[] = "module_name='%h'";
		$this->value[] = $_POST["module_name"];

		return TRUE;
	}
	/**
	 * Сохранение поля "Родитель"
	 * 
	 * @return boolean
	 */
	protected function save_parent_id_module()
	{
		if (! $this->diafan->savenew && $_POST["cat_id"] != $this->oldrow["cat_id"])
		{
			if ($_POST["parent_id"] && DB::query_result("SELECT cat_id FROM {menu} WHERE id=%d", $_POST["parent_id"]) != $_POST["cat_id"])
			{
				$_POST["parent_id"] = 0;
			}
		}
		parent::save_parent_id_module();
	}
}