<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Menu_admin_save
 * 
 * Сохранение полей, связанных с работой модуля "Меню"
 */
class Menu_admin_save
{
	/**
	 * Сохранение поля "Показывать в меню"
	 * 
	 * @return boolean true
	 */
	public static function save(&$th)
	{
		if ($th->diafan->module == 'site')
		{
			$name_menu = 'site_id';
		}
		else
		{
			if (! $th->site_id)
			{
				$th->get_site_id();
			}
			if ($th->config_module["category"])
			{
				$name_menu = 'module_cat_id';
			}
			else
			{
				$name_menu = 'element_id';
			}
		}
		if (! $th->sort)
		{
			$th->get_sort();
		}

		$show_in_menu = array();
		if (! $th->diafan->savenew)
		{
			$result = DB::query("SELECT cat_id FROM {menu} WHERE module_name='%h' AND ".$name_menu."=%d AND trash='0'", $th->diafan->module, $th->diafan->save);
			while ($row = DB::fetch_array($result))
			{
				$show_in_menu[] = $row["cat_id"];
			}

                        if($th->oldrow['name']!=$_POST['name'])
                        {
                            DB::query("UPDATE {menu} SET [name]='%h' WHERE module_name='%h' AND ".$name_menu."=%d",$_POST['name'],$th->diafan->module, $th->diafan->save);
                        }

		}
		if (empty($_POST["menu"]))
		{
			if ($show_in_menu)
			{
				foreach ($show_in_menu as $menu_cat_id)
				{
					$id = DB::query_result("SELECT id FROM {menu} WHERE module_name='%h' AND ".$name_menu."=%d AND cat_id=%d AND trash='0'", $th->diafan->module, $th->diafan->save, $menu_cat_id);
					$children = $th->diafan->get_children($id, "menu");
					$children[] = $id;
					DB::query("DELETE FROM {menu_parents} WHERE parent_id IN (%s)", implode(',', $children));
					DB::query("DELETE FROM {menu_parents} WHERE element_id IN (%s)", implode(',', $children));
					DB::query("DELETE FROM {menu} WHERE id IN (%s)", implode(',', $children));

                                        if($th->diafan->module == 'site')
                                        {
                                           DB::query("UPDATE {site} SET is_menu='0' WHERE id=%d",$th->diafan->save);
                                        }

					// пересчитываем поле count_children
					$result = DB::query("SELECT id FROM {menu} WHERE cat_id=%d AND trash='0'", $menu_cat_id); 
					while ($row = DB::fetch_array($result))
					{
						$count = DB::query_result("SELECT COUNT(*) FROM  {menu_parents} WHERE parent_id=%d AND trash='0'", $row["id"]);
						DB::query("UPDATE {menu} SET count_children=%d WHERE id=%d", $count, $row["id"]);
					}
				}
			}
		}
		else
		{
			if (empty($_POST["menu_cat_ids"]))
			{
				$_POST["menu_cat_ids"][] = 1;
			}
			foreach ($_POST["menu_cat_ids"] as $menu_cat_id)
			{
				if (! in_array($menu_cat_id, $show_in_menu))
				{
					$parent_id = 0;
					if (! empty($_POST["parent_id"]))
					{
						$parent_id = DB::query_result("SELECT id FROM {menu} WHERE module_name='%h' AND ".$name_menu."=%d AND cat_id=%d AND trash='0'", $th->diafan->module, $_POST["parent_id"], $menu_cat_id);
					}
					if ($th->diafan->module == 'site')
					{
						DB::query("INSERT INTO {menu} (name, module_name, site_id, cat_id, parent_id, access, sort, act)"
								  ." VALUES ('%h', 'site', %d, %d, %d, '%d', %d, '%d')",
								  $_POST["name"],
								  $th->diafan->save,
								  $menu_cat_id,
								  $parent_id,
								  ! empty($_POST["access"]) ? 1 : 0,
								  $th->sort,
								  ! empty($_POST["act"]) || $th->diafan->save == 1 ? 1 : 0
								  );

                                                DB::query("UPDATE {site} SET is_menu='1' WHERE id=%d",$th->diafan->save);
					}
					else
					{
						if (! $parent_id && ! empty($_POST["cat_id"]))
						{
							$parent_id = DB::query_result("SELECT id FROM {menu} WHERE module_name='%h' AND module_cat_id=%d AND cat_id=%d AND trash='0'", $th->diafan->module, $_POST["cat_id"], $menu_cat_id);
						}
						if (! $parent_id && $th->site_id)
						{
							$parent_id = DB::query_result("SELECT id FROM {menu} WHERE module_name='site' AND site_id=%d AND cat_id=%d AND trash='0'", $th->site_id, $menu_cat_id);
						}
						DB::query("INSERT INTO {menu} (name, module_name, site_id, ".$name_menu.", cat_id, parent_id, sort, act)"
								  ." VALUES ('%h', '%h', %d, %d, %d, '%d', %d, '%d')",
								  $_POST["name"],
								  $th->diafan->module,
								  $th->site_id,
								  $th->diafan->save,
								  $menu_cat_id,
								  $parent_id,
								  $th->sort,
								  ! empty($_POST["act"]) ? 1 : 0
								  );
                                                DB::query("UPDATE {site} SET is_menu='1' WHERE id=%d",$th->site_id);
					}
					$new_menu_id = DB::next_id("menu");
					$table = $th->diafan->module;
					if ($th->config_module["category"])
					{
						$table .= '_category';
					}
					foreach ($th->diafan->language_all as $lang)
					{
						if ($lang[0])
						{
							$element = DB::fetch_array(DB::query("SELECT name".$lang[0]." AS name, act".$lang[0]." AS act FROM {%h} WHERE id=%d", $table, $th->diafan->save));
							DB::query("UPDATE {menu} SET act".$lang[0]."='%d', name".$lang[0]."='%h' WHERE id=%d", $element["act"], $element["name"], $new_menu_id);
						}
					}
					if ($parent_id)
					{
						$parents = $th->diafan->get_parents($parent_id, "menu");
						$parents[] = $parent_id;
						foreach ($parents as $parent_id)
						{
							DB::query("INSERT INTO {menu_parents} (element_id, parent_id) VALUES (%d, %d)", $new_menu_id, $parent_id);
						}
						DB::query("UPDATE {menu} SET count_children=count_children+1 WHERE id IN (%s)", implode(',', $parents));
					}
					if (! $th->sort)
					{
						DB::query("UPDATE {menu} SET sort=id WHERE id=%d", $new_menu_id);
					}
				}
			}
			foreach ($show_in_menu as $menu_cat_id)
			{
				if (! in_array($menu_cat_id, $_POST["menu_cat_ids"]))
				{
					$id = DB::query_result("SELECT id FROM {menu} WHERE module_name='%h' AND ".$name_menu."=%d AND cat_id=%d AND trash='0'", $th->diafan->module, $th->diafan->save, $menu_cat_id);
					$children = $th->diafan->get_children($id, "menu");
					$children[] = $id;
					DB::query("DELETE FROM {menu_parents} WHERE parent_id IN (%s)", implode(',', $children));
					DB::query("DELETE FROM {menu_parents} WHERE element_id IN (%s)", implode(',', $children));
					DB::query("DELETE FROM {menu} WHERE id IN (%s)", implode(',', $children));

					// пересчитываем поле count_children
					$result = DB::query("SELECT id FROM {menu} WHERE cat_id=%d AND trash='0'", $menu_cat_id); 
					while ($row = DB::fetch_array($result))
					{
						$count = DB::query_result("SELECT COUNT(*) FROM  {menu_parents} WHERE parent_id=%d", $row["id"]);
						DB::query("UPDATE {menu} SET count_children=%d WHERE id=%d", $count, $row["id"]);
					}
				}
			}

		}
		return TRUE;
	}
}