<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Menu
 *
 * Контроллер модуля "Меню"
 */
class Menu extends Controller
{
	/**
	 * Выводит контент модуля
	 * 
	 * @return boolean true
	 */
	public function show_module()
	{
		return TRUE;
	}

	/**
	 * Шаблонная функция: блок меню
	 * 
	 * @param array $attributes атрибуты шаблонного тэга
	 * @return boolean true
	 */
	public function show_block($attributes)
	{
		$attributes = $this->get_attributes(
			$attributes, 'id', 'template',
			'tag_start_1', 'tag_end_1', 'tag_active_start_1', 'tag_active_end_1', 'tag_level_start_1',
			'tag_level_end_1', 'tag_active_child_start_1', 'tag_active_child_end_1', 'hide_parent_link', 'separator_1','count_level'
		);

		$id = intval($attributes["id"]);

		include_once(ABSOLUTE_PATH.'modules/menu/menu.model.php');
		$model = new Menu_model($this->diafan);
		$result = $model->show_block($id);
		if (! $result)
		{
			return FALSE;
		}
		
		$result["attributes"] = $attributes;

		if ($attributes["template"] === "default")
		{
			$this->diafan->_tpl->get('show_block', 'menu', $result);
		}
		elseif ($attributes["template"])
		{
			$this->diafan->_tpl->get('show_block_'.$attributes["template"], 'menu', $result);
		}
		else
		{
			$this->diafan->_tpl->get('show_menu', 'menu', $result);
		}

		return TRUE;
	}
}