<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Order_view
 *
 * Шаблон модуля "Оформление заказа"
 */
class Order_view extends View
{
	/**
	 * Шаблон первого шага в оформлении заказа
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function show_step_1($result)
	{
		echo '<h2>'.$this->_('STEP').' 1</h2>';
		
		echo self::table_basket($result);

		echo '<div class="order_not_registrations">';
		echo $this->_('ORDER_NOT_REGISTRATION').' <a href="'.$result["to-step-2"].'" class="to_order2">'.$this->_('NEXT').'</a>';
		echo '</div>';
		
		echo '<div class="order_autorization">';
		echo $this->_('ORDER_AUTHORIZATION');
		echo '<br>';
		echo $this->get('show_login', 'registration', $result["show_login"]);
		echo '</div>';
		
		echo '<div class="order_registration">';
		echo $this->_('ORDER_REGISTRATION');
		$this->get('form', 'registration', $result["registration"]);
		echo '</div>';

		return TRUE;
	}
	/**
	 * Шаблон второго шага в оформлении заказа
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function show_step_2($result)
	{
		echo '<h2>'.$this->_('STEP').' 2</h2>';

		echo self::table_basket($result);

		echo $result["text"];

		echo '<br><br>
		<form method="POST" action="" class="order_form ajax">
		<input type="hidden" name="module" value="order">
		<input type="hidden" name="action" value="step2">
		<input type="hidden" name="ajax" value="">';

		if (! empty($result["rows_param"]))
		{
			foreach ($result["rows_param"] as $row)
			{
                                $value=$row['value'];
				if(empty($value))  $value = ! empty($result["user"]['p'.$row["id"]]) ? $result["user"]['p'.$row["id"]] : '';
                                
				echo '<div class="order_form_param'.$row["id"].'">';
				if ($row["type"] == 'text' || $row["type"] == "email")
				{
					echo '<div class="infofield">'.$row["name"].($row["required"] ? '<font color="red">*</font>' : '').':</div>
					<input type="text" name="p'.$row["id"].'" size="40" value="'.$value.'" class="inptext">';
				}
				elseif ($row["type"] == 'textarea')
				{
					echo '<div class="infofield">'.$row["name"].($row["required"] ? '<font color="red">*</font>' : '').':</div>
					<textarea name="p'.$row["id"].'" class="inptext" rows="10" cols="30">'.$value.'</textarea>';
				}
				elseif ($row["type"] == 'date')
				{
					if (empty($timecalendar))
					{
						echo '<link rel="stylesheet" href="'.BASE_PATH.'css/timecalendar.css" />
						<script type="text/javascript" src="'.BASE_PATH.'js/timecalendar.js"></script>';
					}
					echo '<div class="infofield">'.$row["name"].($row["required"] ? '<font color="red">*</font>' : '').':</div>
					<input type="text" name="p'.$row["id"].'" size="20" value="'.($value ? date("d.m.Y", $value) : '').'" class="inptext timecalendar" showTime="false">';
					$timecalendar  = TRUE;
				}
				elseif ($row["type"] == 'numtext')
				{
					echo '<div class="infofield">'.$row["name"].($row["required"] ? '<font color="red">*</font>' : '').':</div>
					<input type="text" name="p'.$row["id"].'" size="5" value="'.$value.'" class="inpnum">';
				}
				elseif ($row["type"] == 'checkbox')
				{
					echo '<div class="infofield"><input type="checkbox" name="p'.$row["id"].'" value="1" class="inpcheckbox"'.($value ? ' checked' : '').'>
					'.$row["name"].($row["required"] ? '<font color="red">*</font>' : '').'</div>';
				}
				elseif ($row["type"] == 'select')
				{
					echo '<div class="infofield">'.$row["name"].($row["required"] ? '<font color="red">*</font>' : '').':</div>
					<select name="p'.$row["id"].'" class="inpselect">
						<option value="">-</option>';
					foreach ($row["select_array"] as $select)
					{
						echo '<option value="'.$select["id"].'"'.($value == $select["id"] ? ' selected' : '').'>'.$select["name"].'</option>';
					}
					echo '
					</select>';
				}
				elseif ($row["type"] == 'multiple')
				{
					echo '<div class="infofield">'.$row["name"].($row["required"] ? '<font color="red">*</font>' : '').':</div>';
					foreach ($row["select_array"] as $select)
					{
						echo '<br><input name="p'.$row["id"].'[]" type="checkbox" value="'.$select["id"].'"'.($value && in_array($select["id"], $value) ? ' checked' : '').' class="inpcheckbox"> '.$select["name"];
					}
				}
				echo '<div class="order_form_param_text">'.$row["text"].'</div>
				</div>
				<div class="errors error_p'.$row["id"].'"'.($result["error_p".$row["id"]] ? '>'.$result["error_p".$row["id"]] : ' style="display:none">').'</div>';
			}
		}
		echo '<span class="button_wrap"><input type="submit" value="'.$this->_('TO_ISSUE', FALSE).'" class="button"></span>';
		echo '<div class="errors error"'.($result["error"] ? '>'.$result["error"] : ' style="display:none">').'</div>
		</form>';

		return TRUE;
	}

	/**
	 * Шаблон третьего шага в оформлении заказа
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function show_step_3($result)
	{
		echo '<h2>'.$this->_('STEP').' 3</h2>';
		echo '<div class="order_result">
		<form method="POST" action="" class="order_form ajax">
		<input type="hidden" name="module" value="order">
		<input type="hidden" name="action" value="step3">
		<input type="hidden" name="ajax" value="">
		<p>'.$this->_('SELECT_PAYMENT').':</p>';
		
		$i=0;
		foreach($result["payment_method"] as $row)
		{
		    echo '<p><input name="payment" value="'.$row['id'].'" type="radio" '.(empty($i)?'checked':'').'> '.$row['name'];
		    $i++;
		    if(!empty($row['text'])) echo '<div class="payment_text">'.$row['text'].'</div>';
			echo '</p>';
		}
		
		echo '<span class="button_wrap"><input type="submit" value="'.$this->_('PAY', FALSE).'" class="button"></span>';
		echo '</form>
		</div>';

		return TRUE;
	}

	/**
	 * Шаблон чтевертого шага
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function show_step_4($result)
	{
		echo $result;

		return TRUE;
	}

	/**
	 * Шаблон подтверждения/опровержения платежа
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function show_step_5($result)
	{
		echo $result;

		return TRUE;
	}

	/**
	 * Шаблон таблицы заказанных товаров
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function table_basket($result)
	{
		$text = '<table class="basket">
			<tr>
				<th class="basket_first_th"></th>
				<th>'.$this->_('NAME_GOOD').'</th>
				<th>'.$this->_('COUNT').'</th>
				<th>'.$this->_('PRICE').', '.$result["currency"].'</th>
				<th class="basket_last_th">'.$this->_('SUM').', '.$result["currency"].'</th>
			</tr>';

		if (! empty($result["rows"]))
		{
			foreach ($result["rows"] as $row)
			{
				$text .= '
				<tr>
					<td class="basket_img">';
					if (! empty($row["img"]))
					{
						$text .= '<a href="'.BASE_PATH_HREF.$row["link"].'"><img src="'.$row["img"]["src"].'" width="'.$row["img"]["width"].'" height="'.$row["img"]["height"].'" alt="'.$row["img"]["alt"].'" title="'.$row["img"]["title"].'"></a> ';
					}
					$text .= '</td>
					<td class="basket_name"><a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["name"].(!empty ($row["article"])?'<br/>'._LANG_ARTICLE.': '.$row["article"]:'').'</a></td>
					<td class="basket_count">'.$row["count"].'</td>
					<td class="basket_price">'.$row["price"].'</td>
					<td class="basket_summ">'.$row["summ"].'</td>
				</tr>';
			}
		}
                
                //способы доставки
            
            if (!empty($result["delivery"])) {
                $d=0;
                $name=$result["delivery"][$d]['name'];
                $price=$result["delivery"][$d]['price'];
                if(!empty($_SESSION["basket_delivery"])) $d=$_SESSION["basket_delivery"];
                if(!empty($d))
                {
                    foreach ($result["delivery"] as $r) {
                    if ($r['id'] != $d)
                        continue;
                    $name = $r['name'];
                    $price = $r['price'];
                    break;
                }
                }
                
                
                $text.='<tr><td colspan="4" align="right">' . $this->_('DELIVERY') . ': '.$name.'</td>
                       <td class="basket_summ" id="delivery_price">' . $price . '</td>
                       </tr>';
            }

		$text .= '
			<tr class="basket_last_tr">
				<td class="basket_total" colspan="2">'.$this->_('GOODS_TOTAL').'</td>
				<td class="basket_count">'.$result["count"].'</td>
				<td>&nbsp;</td>
				<td class="basket_summ" id="basket_last_td">'.$result["summ"].'</td>
			</tr>
		</table>';

		return $text;
	}

	/**
	 * Шаблон четвертого шага в оформлении заказа: платеж через систему WebMoney
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function webmoney($result)
	{
		echo $result["text"];
		echo '<form id="pay" name="pay" method="POST" action="https://merchant.webmoney.ru/lmi/payment.asp">
		<b>'.sprintf($this->_('PAYMENT_WM_TITLE'), $result["summ"]).'</b> &nbsp;
		<input type="hidden" name="LMI_PAYMENT_AMOUNT" value="'.$result['summ'].'">
		<input type="hidden" name="LMI_PAYMENT_DESC" value="'.$result['desc'].'">
		<input type="hidden" name="LMI_PAYMENT_NO" value="'.$result["order_id"].'">
		<input type="hidden" name="LMI_PAYEE_PURSE" value="'.$result["wm_target"].'">';
		if (isset($result["LMI_SIM_MODE"]))
		{
			echo '<input type="hidden" name="LMI_SIM_MODE" value="'.$result["LMI_SIM_MODE"].'">';
		}
		echo '<input type="hidden" name="RND" value="'.$result["rnd"].'">
		<p><input type="submit" value="'.$this->_('PAY', FALSE).'"></p>
		</form>';

		return TRUE;
	}

	/**
	 * Шаблон четвертого шага в оформлении заказа: безналичный платеж
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function non_cash($result)
	{
		echo $result["text"]
		.'<p><a href="'.BASE_PATH.'order/payment/ul/'.$result["order_id"].'/">'.$this->_('NON_CACH_ACCOUNT_UL').'</a></p>
		<p><a href="'.BASE_PATH.'order/payment/fl/'.$result["order_id"].'/">'.$this->_('NON_CACH_ACCOUNT_FL').'</a></p>';

		return TRUE;
	}

	/**
	 * Шаблон четвертого шага в оформлении заказа: платеж через систему Roboxchange
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function roboxchange($result)
	{
		echo $result["text"]
		."<html><script language=JavaScript "
		."src='http://www.roboxchange.com/mrh_summpreview.asp?"
		."mrh=".$result["login"]."&out_summ=".$result["summ"]."&inv_id=".$result["order_id"]."&inv_desc=".$result["desc"]
		."&crc=".$result["crc"]."'></script></html>";

		return TRUE;
	}
}