<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Paginator_view
 * 
 * Шаблон постраничной навигации
 */

class Paginator_view extends View
{
	/**
	 * Шаблон постраничной навигации для пользовательской части
	 *
	 * @param array $links ссылки для навигации
	 * @return string
	 */
	public function get($links)
	{
		$string = '';
		if ($links)
		{
			$string .= '<div class="paginator">';
			foreach ($links as $l)
			{
				switch($l["type"])
				{
					case "first":
						$string .= '<a href="'.BASE_PATH_HREF.$l["link"].'">&lt;&lt;</a> ';
						break;
						
					case "current":
						$string .= '<b>['.$l["name"].']</b> ';
						break;

					case "previous":
						$string .= '<a href="'.BASE_PATH_HREF.$l["link"].'" title="'.$this->_('PREVIOUS_PAGE', FALSE).'">...</a> ';
						break;

					case "next":
						$string .= '<a href="'.BASE_PATH_HREF.$l["link"].'" title="'.$this->_('NEXT_PAGE', FALSE).' '.sprintf(_LANG_TOTAL, $l["nen"]).'">...</a> ';
						break;
						
					case "last":
					$string .= '<a href="'.BASE_PATH_HREF.$l["link"].'">&gt;&gt;</a> ';
					break;

					default:
						$string .= '<a href="'.BASE_PATH_HREF.$l["link"].'">'.$l["name"].'</a> ';
						break;
				}
			}
			$string .= '</div>';
		}
		return $string;
	}

	/**
	 * Шаблон постраничной навигации для административной части
	 *
	 * @param array $links ссылки для навигации
	 * @return string
	 */
	public function get_admin($links)
	{
		$string = '';
		if ($links)
		{
			echo '<div class="paginator">';
			foreach ($links as $l)
			{
				switch($l["type"])
				{
					case "first":
						$string .= '<a href="'.BASE_PATH_HREF.$l["link"].'">&lt;&lt;</a> ';
						break;
						
					case "current":
						$string .= '<b>['.$l["name"].']</b> ';
						break;

					case "previous":
						$string .= '<a href="'.BASE_PATH_HREF.$l["link"].'" title="'._LANG_PREVIOUS_PAGE.'">...</a> ';
						break;

					case "next":
						$string .= '<a href="'.BASE_PATH_HREF.$l["link"].'" title="'._LANG_NEXT_PAGE.sprintf(_LANG_TOTAL, $l["nen"]).'">...</a> ';
						break;
					
					case "last":
					$string .= '<a href="'.BASE_PATH_HREF.$l["link"].'">&gt;&gt;</a> ';
					break;

					default:
						$string .= '<a href="'.BASE_PATH_HREF.$l["link"].'">'.$l["name"].'</a> ';
						break;
				}
			}
			$string .= '</div>';
		}
		return $string;
	}
}