<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Rating_install
 *
 * Установка модуля "Рейтинг"
 */

$title = "Рейтинг";

$sql = array(
	"CREATE TABLE {rating} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		element_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		module_name VARCHAR(10) NOT NULL DEFAULT '',
		rating float NOT NULL DEFAULT '0',
		count_votes INT(11) UNSIGNED NOT NULL DEFAULT '0',
		created INT(12) UNSIGNED NOT NULL DEFAULT '0',
		trash ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY (id),
		KEY element_id (element_id),
		KEY module_name (module_name(2))
	) CHARSET=utf8",
	
	"INSERT INTO {adminsite} (id, group_id, count_children, name, rewrite, text, act, numrow, sort) VALUES (
		32,
		'2',
		1,
		'Рейтинг',
		'rating',
		'<p>Рейтинг определяется пользователями на сайте и прикрепляется к товарам магазина, к новостям, статьям, фотогалереям и пр. Все отметки рейтинга с сайта собираются в этом модуле.<br />\r\n<a href=\"base_path/rating/config/\">Настройки модуля &quot;Рейтинг&quot;</a>.</p>\r\n<p><a target=\"_blank\" href=\"http://cms.diafan.ru/dokument/\">Полная документация и помощь</a></p>',
		'1',
		2419,
		34
	);",

	"INSERT INTO {adminsite} (`id`, `parent_id`, `group_id`, `name`, `rewrite`, `text`, `numrow`, `sort`) VALUES (
		33,
		32,
		'2',
		'Настройки',
		'rating/config',
		'<p><a target=\"_blank\" href=\"http://cms.diafan.ru/dokument/\">Полная документация и помощь</a></p>',
		1,
		33
	);",

	"INSERT INTO {adminsite_parents} (`element_id`, `parent_id`) VALUES (33, 32)",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('rating', 'security', '4')"
);


$example = array();

if (! empty($_POST["news"]))
{
	$example[] = "INSERT INTO {rating} (id, element_id, module_name, rating, count_votes, created) VALUES (
		1,
		1,
		'news',
		'5',
		2,
		".time()."
	);";

	$example[] = "INSERT INTO {rating} (id, element_id, module_name, rating, count_votes, created) VALUES (
		2,
		3,
		'news',
		'5',
		1,
		".time()."
	);";

	$example[] = "INSERT INTO {rating} (id, element_id, module_name, rating, count_votes, created) VALUES (
		3,
		4,
		'news',
		'5',
		1,
		".time()."
	);";
}

if (! empty($_POST["photo"]))
{
	$example[] = "INSERT INTO {rating} (id, element_id, module_name, rating, count_votes, created) VALUES (
		4,
		2,
		'photo',
		'5',
		1,
		".time()."
	);";
}

if (! empty($_POST["files"]))
{
	$example[] = "INSERT INTO {rating} (id, element_id, module_name, rating, count_votes, created) VALUES (
		5,
		4,
		'files',
		'3',
		1,
		".time()."
	);";
}

/**
 * Выполняет действия по установке модуля
 * 
 * @return void
 */
function module_basic_rating()
{
	$url = parse_url(DB_URL);
	$result = DB::query("SHOW TABLES FROM ".substr($url['path'], 1));
	while ($row = mysql_fetch_row($result))
	{
		if ($row[0] == DB_PREFIX."log_note") return;
	}

	DB::query(
	"CREATE TABLE {log_note} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		module_name VARCHAR(10) NOT NULL DEFAULT '',
		element_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		note INT(7) UNSIGNED NOT NULL DEFAULT '0',
		created INT(12) UNSIGNED NOT NULL DEFAULT '0',
		ip VARCHAR(62) NOT NULL DEFAULT '',
		session_id VARCHAR(64) NOT NULL DEFAULT '',
		include_name VARCHAR(10) NOT NULL DEFAULT '',
		PRIMARY KEY  (id),
		KEY element_id (element_id),
		KEY session_id (session_id(2)),
		KEY include_name (include_name(2)),
		KEY module_name (module_name(2))
	) CHARSET=utf8");
}

/**
 * Деинсталлирует модуль
 * 
 * @return void
 */
function module_basic_uninstall_rating()
{
	$module = 'rating';
	DB::query("DROP TABLE {".$module."};");
	DB::query("DELETE FROM {config} WHERE module_name='".$module."';");
	DB::query("DELETE FROM {config} WHERE name='".$module."';");
	DB::query("DELETE FROM {log_note} WHERE module_name='".$module."';");
	$admin_ids = DB::query_result("SELECT GROUP_CONCAT(id SEPARATOR ',') FROM {adminsite} WHERE rewrite IN ('".$module."', '".$module."/config')");
	if ($admin_ids)
	{
		DB::query("DELETE FROM {adminsite} WHERE id IN (".$admin_ids.")");
		DB::query("DELETE FROM {adminsite_parents} WHERE element_id IN (".$admin_ids.")");
	}
	$trash_ids = DB::query_result("SELECT GROUP_CONCAT(id SEPARATOR ',') FROM {trash} WHERE module_name='".$module."'");
	if ($trash_ids)
	{
		DB::query("DELETE FROM {trash} WHERE id IN (".$trash_ids.")");
		$trash_child_ids = DB::query_result("SELECT GROUP_CONCAT(element_id SEPARATOR ',') FROM {trash_parents} WHERE parent_id IN (".$trash_ids.")");
		if ($trash_child_ids)
		{
			DB::query("DELETE FROM {trash_parents} WHERE element_id IN (".$trash_child_ids.")");
		}
		DB::query("DELETE FROM {trash_parents} WHERE element_id IN (".$trash_ids.")");
	}
}