<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru) 
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Rating_view
 *
 * Шаблон модуля "Рейтинг"
 */
class Rating_view extends View
{
	/**
	 * Шаблон рейтинга элемента
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return string
	 */
	public function get($result)
	{
		$text = (empty($result["new"]) ? '<span id="rating'.$result["element_id"].$result["module_name"].'-result" class="rating_votes">' : '');
		for ($i = 0; $i < $result["rating"]; $i++)
		{
			$text .= '<img src="'.BASE_PATH.'modules/rating/img/rplus.png" alt="+" width="16" height="16">';
		}
		for ($i = 0; $i < 5 - $result["rating"]; $i++)
		{
			$text .= '<img src="'.BASE_PATH.'modules/rating/img/rminus.png" alt="-" width="16" height="16">';
		}
		$text .= (empty($result["new"]) ? '</span>' : '');

		return $text;
	}

	/**
	 * Шаблон формы оценки. Стандартная форма
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return string
	 */
	public function form($result)
	{
		$text = '
		<form method="POST" action="" class="rating_form ajax">
		<input type="hidden" name="ajax" value="">
		<input type="hidden" name="module" value="rating">
		<input type="hidden" name="element_id" value="'.$result["element_id"].'">
		<input type="hidden" name="module_name" value="'.$result["module_name"].'">';
		for ($i = 1; $i <= 5; $i++)
		{
			$text .= '<input type="radio" name="rating" value="'.$i.'"'.($i == 5 ? 'checked' : '').'>'.$i."\n";
		}
		$text .= $result["captcha"];
		$text .= '<span class="button_wrap"><input type="submit" value="'.$this->_('ADD_RATING', FALSE).'" class="button"></span>';
		$text .= '<div class="errors error"'.($result["error"] ? '>'.$result["error"] : ' style="display:none">').'</div>
		</form>';
		return $text;
	}
}