<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Registration_ajax
 *
 * Обработка запроса при регистрации или изменении данных о пользователе
 */
class Registration_ajax extends Model
{
	/**
	 * @var object основной объект системы
	 */
	public $diafan;

	/**
	 * @var array поля формы
	 */
	private $param;

	/**
	 * @var array внутренние сообщения
	 */
	private $result;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
	}

	/**
	 * Обрабатывает полученные данные из формы
	 * 
	 * @return boolean
	 */
	public function ajax_request()
	{
		if (empty($_POST['module']) || $_POST['module'] != 'registration' || empty($_POST["action"]) || ! in_array($_POST["action"], array('addnew', 'edit', 'delete_avatar'))
		   || $this->diafan->module != 'registration')
		{
			return FALSE;
		}

		if ($_POST["action"] == "addnew" && ! $this->diafan->_user->id)
		{
			$this->check_captcha();
			$this->validate();

			$this->param = $this->get_param();

			$this->empty_required_field();

			if ($this->send_errors())
				return TRUE;

			DB::query("INSERT INTO {users_site} (name, password, mail, created, language, fio, act)"
			          ." VALUES ('%h', '%h', '%h', '%d', '%d', '%h', '%d')",
			          $_POST["name"], code_password($_POST["password"]), $_POST["mail"],
			          time(), _LANG, $_POST["fio"],
			          $this->diafan->configmodules("act", "usersite") ? 0 : 1
			         );
			$save_id = DB::next_id("users_site");

			$this->send_mails($save_id);

			$this->insert_values($save_id);

			$this->upload_avatar();

			if (! $this->diafan->configmodules("act", "usersite"))
			{
				$this->diafan->_user->id = $save_id;
				if ($_POST["url"])
				{
					$this->result["redirect"] = $_POST["url"];
					return $this->send_errors();
				}
			}

			$this->result["errors"][0] = $this->diafan->configmodules('mes', "usersite");
			$this->result["success"] = TRUE;

			return $this->send_errors();
		}
	
		if ($_POST["action"] == "edit" && $this->diafan->_user->id)
		{
			if (! $this->diafan->_user->checked)
			{
				$this->result["errors"][0] = 'ERROR';
				return $this->send_errors();
			}
			$this->result["hash"] = $this->diafan->_user->get_hash();

			if ($this->validate_edit())
				return TRUE;

			$this->param = $this->get_param();
                        
                        if ($this->empty_required_field())
				return TRUE;
                        
                        $this->order_param = $this->get_order_param();

			if ($this->empty_required_order_field('dop_'))
				return TRUE;

			if (! empty($_POST["language"]) && ! DB::query_result("SELECT id FROM {language} WHERE id=%d", $_POST["language"]))
			{
				$this->result["errors"][0] = 'ERROR';
				return $this->send_errors();
			}
                        
                        $array = array();
                        $result = DB::query("SELECT id FROM {subscribtion_category} WHERE trash='0'");
                        while ($row = DB::fetch_array($result))
                        {
                                if (empty($_POST["subscribtion"]) || ! in_array($row["id"], $_POST["subscribtion"]))
                                {
                                        $array[] = $row["id"];
                                }
                        }
                        $subscribtion = '0 '.implode("  ", $array).' 0';

			DB::query("UPDATE {users_site} SET name='%h', mail='%h', fio='%h', subscribtion='%s'  WHERE id=%d",
			          $_POST["name"],
			          $_POST["mail"],
			         // $_POST["language"],
			          $_POST["fio"],
			          $subscribtion,
			          $this->diafan->_user->id
			         );

			if ($_POST["password"])
			{
				DB::query("UPDATE {users_site} SET password='%h' WHERE id=%d", code_password($_POST["password"]), $this->diafan->_user->id);
			}

			$this->update_values();
                        $this->update_order_values('dop_');

			$this->upload_avatar();

			$this->result["errors"][0] = _LANG_CHANGES_SAVED;

			return $this->send_errors();
		}

		if ($_POST["action"] == "delete_avatar" && $this->diafan->configmodules("avatar", "usersite") && $this->diafan->_user->id)
		{
			unlink(ABSOLUTE_PATH.'userfiles/avatar/'.$this->diafan->_user->name.'.png');
			return TRUE;
		}
		return FALSE;
	}

	/**
	 * Проверяет правильность каптчи
	 * 
	 * @return boolean
	 */
	private function check_captcha()
	{
		$this->result["code"] = '';
		if ($this->diafan->configmodules('security_code', "usersite"))
		{
			$mes = $this->diafan->_captcha->is_right($this->diafan->module);
			$this->result["code"] = $this->diafan->_captcha->get($this->diafan->module, '', TRUE);
			if ($mes)
			{
				$this->result["errors"]["code"] = $mes;
				return TRUE;
			}
		}
		return FALSE;
	}

	/**
	 * Проверяет валидность введенных при регистрации данных
	 * 
	 * @return boolean true
	 */
	private function validate()
	{
		require_once(ABSOLUTE_PATH.'includes/validate.php');
		$mes = Validate::login($_POST["name"]);
		if ($mes)
		{
			$this->result["errors"]["name"] = $mes;
		}
		$mes = Validate::mail($_POST["mail"]);
		if ($mes)
		{
			$this->result["errors"]["mail"] = $mes;
		}
		else
		{
			$mes = Validate::mail_user($_POST["mail"]);
			if ($mes)
			{
				$this->result["errors"]["mail"] = $mes;
			}
		}
		$mes = Validate::password($_POST["password"]);
		if ($mes)
		{
			$this->result["errors"]["password"] = $mes;
		}
		elseif ($_POST["password"] != $_POST["password2"])
		{
			$this->result["errors"]["password"] = _LANG_PASSWORDS_ARENT_SIMULAR;
		}

		if (! $_POST["fio"])
		{
			$this->result["errors"]["fio"] = _LANG_ENTER_NAME_SURNAME;
		}

		return TRUE;
	}

	/**
	 * Проверяет валидность введенных при редактировании данных
	 * 
	 * @return boolean
	 */
	private function validate_edit()
	{
		
		require_once(ABSOLUTE_PATH.'includes/validate.php');
		if ($_POST["name"] != $this->diafan->_user->name)
		{
			$mes = Validate::login($_POST["name"]);
			if ($mes)
			{
				$this->result["errors"]["name"] = $mes;
			}
		}
		$mes = Validate::mail($_POST["mail"]);
		if ($mes)
		{
			$this->result["errors"]["mail"] = $mes;
		}
		if ($_POST["mail"] != $this->diafan->_user->mail)
		{
			$mes = Validate::mail_user($_POST["mail"]);
			if ($mes)
			{
				$this->result["errors"]["mail"] = $mes;
			}
		}
		if ($_POST["password"])
		{
			$mes = Validate::password($_POST["password"]);
			if ($mes)
			{
				$this->result["errors"]["password"] = $mes;
			}
			elseif ($_POST["password"] != $_POST["password2"])
			{
				$this->result["errors"]["password"] = _LANG_PASSWORDS_ARENT_SIMULAR;
			}
		}

		if (empty($_POST["fio"]))
		{
			$this->result["errors"]["fio"] = _LANG_ENTER_NAME_SURNAME;
		}

		return $this->send_errors();
	}

	/**
	 * Получает массив полей формы оформления заказа
	 * 
	 * @return array
	 */
	private function get_param()
	{
		$form = $this->diafan->_user->id ? 'user' : 'reg';
		$cache_meta = array(
				    "name"     => "usersite_param_".$form,
				    "language" => _LANG
				    );
		if (! $rows_param = $this->diafan->_cache->get($cache_meta, "usersite"))
		{
			$rows_param = array();
			$result = DB::query("SELECT id, [name], type, required, [text] FROM {usersite_param} WHERE trash='0' AND `form` IN ('form', '".$form."')"
			                    ." ORDER BY sort ASC");

			while ($row = DB::fetch_array($result))
			{
				if ($row["type"] == 'select' || $row["type"] == 'multiple')
				{
					$result_select = DB::query("SELECT [name], id FROM {usersite_param_select} WHERE param_id=%d ORDER BY sort ASC", $row["id"]);
					while ($row_select = DB::fetch_array($result_select))
					{
						$row["select_array"][] = $row_select;
					}
				}
				$rows_param[] = $row;
			}
			//сохранение кеша
			$this->diafan->_cache->save($rows_param, $cache_meta, "usersite");
		}
		return $rows_param;
	}
        
        /**
     * Получает массив полей формы оформления заказа
     * 
     * @return array
     */
    private function get_order_param() {

        $cache_meta = array(
            "name" => "order_param",
            "language" => _LANG
        );
        if (!$rows_param = $this->diafan->_cache->get($cache_meta, "registration")) {
            $rows_param = array();
            $result = DB::query("SELECT id, [name], type, required, [text] FROM {shop_order_param} WHERE trash='0' AND def='1' ORDER BY sort ASC");

            while ($row = DB::fetch_array($result)) {
                if ($row["type"] == 'select' || $row["type"] == 'multiple') {
                    $result_select = DB::query("SELECT [name], id FROM {shop_order_param_select} WHERE param_id=%d ORDER BY sort ASC", $row["id"]);
                    while ($row_select = DB::fetch_array($result_select)) {
                        $row["select_array"][] = $row_select;
                    }
                }
                //$row["value"] = DB::result(DB::query("SELECT value FROM {shop_order_param_def} WHERE trash='0' AND user_id=%d AND param_id='%d'", $this->diafan->_user->id, $row['id']));
                //$this->result['error_dop_p' . $row["id"]] = $this->get_error("order", 'dop_p' . $row["id"]);
                $rows_param[] = $row;
            }
            //сохранение кеша
            $this->diafan->_cache->save($rows_param, $cache_meta, "registration");
        }
        return $rows_param;
    }

	/**
	 * Проверяет на заполнение обязательных полей
	 * 
	 * @return boolean
	 */
	private function empty_required_field()
	{
		$message = array();
		foreach ($this->param as $row)
		{
			if ($row["required"] && empty($_POST['p'.$row["id"]]))
			{
				$this->result["errors"]["p".$row["id"]] = $this->diafan->configmodules('error_empty_fields', 'usersite').' '.$row["name"];
			}
			if (empty($_POST["p".$row["id"]]) && $row["type"] != "checkbox")
				continue;

			if ($row["type"] == "email")
			{
				$this->valid_email($_POST["p".$row["id"]], "p".$row["id"]);
			}

			if ($row["type"] == "text" || $row["type"] == "textarea" || $row["type"] == "email")
			{
				$_POST["p".$row["id"]] = $this->diafan->get_param($_POST, "p".$row["id"], '', 1);
				$message[] = $row["name"].': '.$_POST["p".$row["id"]];
			}
			elseif ($row["type"] == "numtext")
			{
				$_POST["p".$row["id"]] = $this->diafan->get_param($_POST, "p".$row["id"], '', 2);
				$message[] = $row["name"].': '.$_POST["p".$row["id"]];
			}
			elseif ($row["type"] == "date")
			{
				$_POST["p".$row["id"]] = $this->diafan->unixdate($_POST["p".$row["id"]]);
				$message[] = $row["name"].': '.$this->format_date($_POST["p".$row["id"]]);
			}
			elseif ($row["type"] == "checkbox")
			{
				$value = ! empty($_POST["p".$row["id"]]) ? 1 : 0;
				$value_sel = DB::query_result("SELECT [name] FROM {usersite_param_select} WHERE value=%d AND param_id=%d", $value, $row["id"]);
				if (! $value_sel && $value == 1)
				{
					$message[] = $row["name"];
				}
				else
				{
					$message[] = $row["name"].': '.$value_sel;
				}
			}
			elseif ($row["type"] == "select" && ! empty($row["select_array"]))
			{
				foreach ($row["select_array"] as $select)
				{
					if ($select["id"] == $_POST["p".$row["id"]])
					{
						$message[] = $row["name"].': '.$select["name"];
					}
				}
			}
			elseif ($row["type"] == "multiple" && ! empty($row["select_array"]) && ! empty($_POST["p".$row["id"]]) && is_array($_POST["p".$row["id"]]))
			{
				$vals = array();
				foreach ($row["select_array"] as $select)
				{
					if (in_array($select["id"], $_POST["p".$row["id"]]))
					{
						$vals[] = $select["name"];
					}
				}
				$message[] = $row["name"].': '.implode(", ", $vals);
			}
		}
		$this->result["message"] = implode('<br>', $message);
		return FALSE;
	}
        
        /**
	 * Проверяет на заполнение обязательных полей
	 * 
	 * @return boolean
	 */
	private function empty_required_order_field($prefix)
	{
		$message = array();
		foreach ($this->order_param as $row)
		{
			if ($row["required"] && empty($_POST[$prefix.'p'.$row["id"]]))
			{
				$this->result["errors"][$prefix."p".$row["id"]] = $this->diafan->configmodules('error_empty_fields', 'usersite').' '.$row["name"];
			}
			if (empty($_POST[$prefix."p".$row["id"]]) && $row["type"] != "checkbox")
				continue;

			if ($row["type"] == "email")
			{
				$this->valid_email($_POST[$prefix."p".$row["id"]], $prefix."p".$row["id"]);
			}

			if ($row["type"] == "text" || $row["type"] == "textarea" || $row["type"] == "email")
			{
				$_POST[$prefix."p".$row["id"]] = $this->diafan->get_param($_POST, $prefix."p".$row["id"], '', 1);
				$message[] = $row["name"].': '.$_POST[$prefix."p".$row["id"]];
			}
			elseif ($row["type"] == "numtext")
			{
				$_POST[$prefix."p".$row["id"]] = $this->diafan->get_param($_POST, $prefix."p".$row["id"], '', 2);
				$message[] = $row["name"].': '.$_POST[$prefix."p".$row["id"]];
			}
			elseif ($row["type"] == "date")
			{
				$_POST[$prefix."p".$row["id"]] = $this->diafan->unixdate($_POST[$prefix."p".$row["id"]]);
				$message[] = $row["name"].': '.$this->format_date($_POST[$prefix."p".$row["id"]]);
			}
			elseif ($row["type"] == "checkbox")
			{
				$value = ! empty($_POST[$prefix."p".$row["id"]]) ? 1 : 0;
				$value_sel = DB::query_result("SELECT [name] FROM {usersite_param_select} WHERE value=%d AND param_id=%d", $value, $row["id"]);
				if (! $value_sel && $value == 1)
				{
					$message[] = $row["name"];
				}
				else
				{
					$message[] = $row["name"].': '.$value_sel;
				}
			}
			elseif ($row["type"] == "select" && ! empty($row["select_array"]))
			{
				foreach ($row["select_array"] as $select)
				{
					if ($select["id"] == $_POST[$prefix."p".$row["id"]])
					{
						$message[] = $row["name"].': '.$select["name"];
					}
				}
			}
			elseif ($row["type"] == "multiple" && ! empty($row["select_array"]) && ! empty($_POST[$prefix."p".$row["id"]]) && is_array($_POST[$prefix."p".$row["id"]]))
			{
				$vals = array();
				foreach ($row["select_array"] as $select)
				{
					if (in_array($select["id"], $_POST[$prefix."p".$row["id"]]))
					{
						$vals[] = $select["name"];
					}
				}
				$message[] = $row["name"].': '.implode(", ", $vals);
			}
		}
		$this->result["message"] = implode('<br>', $message);
		return FALSE;
	}

	/**
	 * Отправляет письмо новому пользователю и администратору сайта
	 * 
	 * @return boolean true
	 */
	private function send_mails($save)
	{
		include_once(ABSOLUTE_PATH.'includes/mail.php');
		if ($this->diafan->configmodules("sendmailadmin", "usersite"))
		{
			$subject = str_replace(
					array('%title', '%url'),
					array(TIT, BASE_URL),
					$this->diafan->configmodules('subject_admin', "usersite")
				);
			$message = str_replace(
					array('%login', '%title', '%url', '%fio', '%email'),
					array(
						$this->diafan->get_param($_POST, "name", '', 1),
						TIT,
						BASE_URL,
						$this->diafan->get_param($_POST, "fio", '', 1),
						$this->diafan->get_param($_POST, "mail", '', 1)
					),
					$this->diafan->configmodules('message_admin', "usersite")
				);

			if ($message && $subject)
			{
				send_mail(
					$this->diafan->configmodules("emailconfadmin", "usersite") ? $this->diafan->configmodules("email_admin", "usersite") : EMAIL_CONFIG,
					$subject,
					$message,
					$this->diafan->configmodules("emailconf", "usersite") ? $this->diafan->configmodules("email", "usersite") : ''
				);
			}
		}

		//send mail user
		$subject = str_replace(
				array('%title', '%url'),
				array(TITLE, BASE_URL),
				$this->diafan->configmodules('subject', "usersite")
			);

		$actlink = '';
		if ($this->diafan->configmodules("act", "usersite") == 1)
		{
			$actcode = md5(rand(111, 99999));
			DB::query("INSERT INTO {usersite_actlink} (link, user_id, created) VALUES ('%s', '%d', '%d')", $actcode, $save, time() + 86400);
			$link = BASE_PATH_HREF.$this->diafan->_route->link($this->diafan->cid).'?act='.$actcode;
			$actlink = '<a href="'.$link.'">'.$link.'</a>';
		}

		$message = str_replace(
				array('%login', '%title', '%url', '%fio', '%password', '%actlink'),
				array(
					$this->diafan->get_param($_POST, "name", '', 1),
					TITLE,
					BASE_URL,
					$this->diafan->get_param($_POST, "fio", '', 1),
					$this->diafan->get_param($_POST, "password", '', 1),
					$actlink
				),
				$this->diafan->configmodules('message', "usersite")
			);

		if ($message && $subject)
		{
			send_mail(
				$_POST["mail"],
				$subject,
				$message,
				$this->diafan->configmodules("emailconf", "usersite") ? $this->diafan->configmodules("email", "usersite") : ''
			);
		}
		return TRUE;
	}

	/**
	 * Добавляет значение полей формы в базу данных
	 *
	 * @param integer $save номер сохраняемого пользователя
	 * @return boolean true
	 */
	private function insert_values($save)
	{
		foreach ($this->param as $row)
		{
			if (empty($_POST["p".$row["id"]]))
				continue;

			if ($row["type"] == "multiple")
			{
				foreach ($_POST["p".$row["id"]] as $val)
				{
					DB::query("INSERT INTO {usersite_param_element} (value, param_id, element_id) VALUES ('%h', '%d', '%d')", $val, $row["id"], $save);
				}
			}
			else
			{
				DB::query("INSERT INTO {usersite_param_element} (value, param_id, element_id) VALUES ('%h', '%d', '%d')", $_POST["p".$row["id"]], $row["id"], $save);
			}
		}
		return TRUE;
	}

	/**
	 * Добавляет значение полей формы в базу данных
	 * 
	 * @return boolean true
	 */
	private function update_values()
	{
		foreach ($this->param as $row)
		{
			if (empty($_POST["p".$row["id"]]))
				continue;

			if ($row["type"] == "multiple")
			{
				DB::query("DELETE FROM {usersite_param_element} WHERE param_id=%d AND element_id=%d", $row["id"], $this->diafan->_user->id);
				foreach ($_POST["p".$row["id"]] as $val)
				{
					DB::query("INSERT INTO {usersite_param_element} (value, param_id, element_id) VALUES ('%h', '%d', '%d')", $val, $row["id"], $this->diafan->_user->id);
				}
			}
			elseif ($id = DB::query_result("SELECT id FROM {usersite_param_element} WHERE param_id=%d AND element_id=%d", $row["id"], $this->diafan->_user->id))
			{
				DB::query("UPDATE {usersite_param_element} SET value='%h' WHERE id=%d", $_POST["p".$row["id"]], $id);
			}
			else
			{
				DB::query("INSERT INTO {usersite_param_element} (value, param_id, element_id) VALUES ('%h', '%d', '%d')", $_POST["p".$row["id"]], $row["id"], $this->diafan->_user->id);
			}
		}
		return TRUE;
	}

        /**
	 * Добавляет значение полей формы в базу данных
	 * 
	 * @return boolean true
	 */
	private function update_order_values($prefix)
	{
		foreach ($this->order_param as $row)
		{
			if (empty($_POST[$prefix."p".$row["id"]]))
				continue;

			if ($row["type"] == "multiple")
			{
				DB::query("DELETE FROM {shop_order_param_def} WHERE param_id=%d AND user_id=%d", $row["id"], $this->diafan->_user->id);
				foreach ($_POST["p".$row["id"]] as $val)
				{
					DB::query("INSERT INTO {shop_order_param_def} (value, param_id, user_id) VALUES ('%h', '%d', '%d')", $val, $row["id"], $this->diafan->_user->id);
				}
			}
			elseif ($id = DB::query_result("SELECT id FROM {shop_order_param_def} WHERE param_id=%d AND user_id=%d", $row["id"], $this->diafan->_user->id))
			{
				DB::query("UPDATE {shop_order_param_def} SET value='%h' WHERE id=%d", $_POST[$prefix."p".$row["id"]], $id);
			}
			else
			{
				DB::query("INSERT INTO {shop_order_param_def} (value, param_id, user_id) VALUES ('%h', '%d', '%d')", $_POST[$prefix."p".$row["id"]], $row["id"], $this->diafan->_user->id);
			}
		}
		return TRUE;
	}

	/**
	 * Загружает аватар
	 * 
	 * @return boolean
	 */
	private function upload_avatar()
	{
		if (! $this->diafan->configmodules("avatar", "usersite"))
		{
			return FALSE;
		}
		if (isset($_FILES["avatar"]) && is_array($_FILES["avatar"]) && $_FILES["avatar"]['name'] != '')
		{
			list($width, $height) = getimagesize($_FILES["avatar"]['tmp_name']);
			if (! $width || ! $height)
			{
				$this->result["errors"]["avatar"] = _LANG_AVATAR_INCORRECT_FILE;
				return $this->send_errors();
			}
			if ($width < $this->diafan->configmodules("avatar_width", "usersite") || $height < $this->diafan->configmodules("avatar_height", "usersite"))
			{
				$this->result["errors"]["avatar"] = sprintf(_LANG_AVATAR_INCORRECT_SIZE, $this->diafan->configmodules("avatar_width", "usersite"), $this->diafan->configmodules("avatar_height", "usersite"));
				return $this->send_errors();
			}
			include_once(ABSOLUTE_PATH.'includes/image.php');
			if (! Image::resize($_FILES["avatar"]['tmp_name'], $this->diafan->configmodules("avatar_width", "usersite"), $this->diafan->configmodules("avatar_height", "usersite"), $this->diafan->configmodules("avatar_quality", "usersite"), TRUE, TRUE))
			{
				$this->result["errors"]["avatar"] = _LANG_AVATAR_FILE_NO_UPLOAD;
				return $this->send_json();
			}
			$dst_img = imageCreateTrueColor($this->diafan->configmodules("avatar_width", "usersite"), $this->diafan->configmodules("avatar_height", "usersite"));
			$original  = @imageCreateFromString(file_get_contents($_FILES["avatar"]['tmp_name'])); 
			imageCopy($dst_img, $original, 0, 0, 0, 0, $this->diafan->configmodules("avatar_width", "usersite"), $this->diafan->configmodules("avatar_height", "usersite"));
			imagePNG($dst_img, ABSOLUTE_PATH.USERFILES.'/avatar/'.$_POST["name"].'.png');
			if ($this->diafan->_user->id)
			{
				$result["name"] = $this->diafan->_user->name;
				$result["fio"]  = $this->diafan->_user->fio;
				$result["avatar_width"]  = $this->diafan->configmodules("avatar_width",  "usersite");
				$result["avatar_height"] = $this->diafan->configmodules("avatar_height", "usersite");

				$this->result["data"] = $this->diafan->_tpl->get('avatar', 'registration', $result);
				$this->result["target"] = '.registration_avatar';
			}
		}
		return TRUE;
	}

	/**
	 * Отправляет несколько ошибок
	 *
	 * @return boolean
	 */
	private function send_errors()
	{
		if (! empty($this->result["errors"]) || ! empty($this->result["redirect"]))
		{
			if (! empty($_POST['ajax']))
			{
				include_once(ABSOLUTE_PATH.'plugins/json.php');
				echo to_json($this->result);
			}
			else
			{
				$query = '';
				if (! empty($this->result["errors"]))
				{
					foreach ($this->result["errors"] as $field => $mes)
					{
						if (empty($_POST["update"]))
						{
							$query .= '&mess'.($field ? '-'.$field : '').'='.$mes;
						}
					}
				}
				$this->diafan->redirect($this->diafan->_route->current_link().($query ? '?error=registration'.$query : ''));
			}
			return TRUE;
		}
		return FALSE;
	}
}