<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
    include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Registration_model
 *
 * Модель модуля "Регистрация"
 */
class Registration_model extends Model
{

    /**
     * @var array сгенерированные в моделе данные, передаваемые в шаблон
     */
    protected $result;

    /**
     * @var object основной объект системы
     */
    protected $diafan;

    /**
     * Конструктор класса
     * 
     * @return void
     */
    public function __construct(&$diafan)
    {
	$this->diafan = &$diafan;
    }

    public function order()
    {
	//sif($this->diafan->_user->id) return false;
	$result = DB::query("SELECT id, status, summ, created FROM {shop_order} WHERE trash='0' AND user_id='%d' ORDER by created DESC", $this->diafan->_user->id);

	$itogo = 0;
	while ($row = DB::fetch_array($result))
	{
	    $order = array('status' => $row['status'],
		'summ' => $this->diafan->format_price($row["summ"]).' '.$this->diafan->configmodules("currency", "shop"),
		'created' => $this->format_date($row['created'], $this->diafan->module), 'id' => $row['id']);
	
		if ($row["status"]=='3') { $itogo = $itogo + $row["summ"]; }

	    $good_ids = array();
	    $r = DB::query("SELECT good_id FROM {shop_order_goods} WHERE trash='0' AND order_id='%d'", $row['id']);
	    while ($r2 = DB::fetch_array($r))
	    {
		$good_ids[] = $r2['good_id'];
	    }

	    if (!empty($good_ids))
	    {

		$r = DB::query("SELECT id, site_id, cat_id, name FROM {shop} WHERE trash='0' AND id IN (%h)", implode(",", $good_ids));
		while ($r2 = DB::fetch_array($r))
		{
		    $order['goods'][] = '<a href="'.BASE_PATH_HREF.$this->diafan->_route->link($r2['site_id'], 'shop', $r2['cat_id'], $r2['id']).'">'.$r2['name'].'</a>';
		}
	    }

	    $this->result['order'][] = $order;
	}
	
	$this->result['itogo']=$this->diafan->format_price($itogo).' '.$this->diafan->configmodules("currency", "shop");
	
	return $this->result;
    }

    /**
     * Генерирует данные для формы регистрации
     * 
     * @return array
     */
    public function form()
    {
	if (!empty($_GET["act"]))
	{
	    if ($actlink = DB::fetch_array(DB::query("SELECT user_id, created FROM {usersite_actlink} WHERE link='%h'", $_GET["act"])))
	    {
		if ($actlink["created"] < time())
		{
		    $this->result["actlink"] = _LANG_ACTLINK_OLD;
		}
		else
		{
		    DB::query("UPDATE {users_site} SET act='1' WHERE id=%d", $actlink["user_id"]);
		    DB::query("DELETE FROM {usersite_actlink} WHERE link='%h' AND user_id='%d'", $_GET["act"], $actlink["user_id"]);
		    $result = array('user' => 0, 'error' => '', 'action' => BASE_PATH_HREF, 'hide' => TRUE);
		    $this->result["actlink"] = _LANG_USER_ACT.$this->diafan->_tpl->get('show_login', 'registration', $result);
		}
	    }
	    else
	    {
		$this->result["actlink"] = _LANG_ACTLINK_INCORRECT;
	    }
	}

	$this->result["captcha"] = '';
	if ($this->diafan->configmodules('security_code', "usersite") && !$this->diafan->_user->id)
	{
	    $this->result["captcha"] = $this->diafan->_captcha->get("registration", $this->get_error("registration", "code"));
	}
	$this->result["fio"] = '';
	$this->result["mail"] = '';
	$this->result["name"] = '';

	if ($this->diafan->_user->id)
	{
	    $this->result["fio"] = $this->diafan->_user->fio;
	    $this->result["hash"] = $this->diafan->_user->get_hash();
	    $this->result["mail"] = $this->diafan->_user->mail;
	    $this->result["name"] = $this->diafan->_user->name;


	    if (count($this->diafan->language_all) > 1)
	    {
		foreach ($this->diafan->language_all as $key => $language)
		{
		    $this->result["language"][] = array("value" => $language[0],
			"selected" => ($language[0] == $this->diafan->_user->language ? ' selected' : ''),
			"name" => $language[2]
		    );
		}
	    }

	    $this->result["subscribtion"] = '';
	    $this->parent_id_subscribtion_module_registration(0, '', array(), DB::title("users_site", $this->diafan->_user->id, 'subscribtion'));

	    $this->get_param();
	}
	$this->result["action"] = BASE_PATH_HREF.$this->diafan->_route->current_link();
	$this->result["error"] = $this->get_error("registration");
	$this->result["error_name"] = $this->get_error("registration", 'name');
	$this->result["error_fio"] = $this->get_error("registration", 'fio');
	$this->result["error_password"] = $this->get_error("registration", 'password');
	$this->result["error_mail"] = $this->get_error("registration", 'mail');
	$this->result["user_id"] = $this->diafan->_user->id;
	$this->result["url"] = '';
	$this->result["use_avatar"] = $this->diafan->configmodules("avatar", "usersite");
	if ($this->result["use_avatar"])
	{
	    if ($this->diafan->_user->id)
	    {
		$this->result["avatar"] = file_exists(ABSOLUTE_PATH.'userfiles/avatar/'.$this->diafan->_user->name.'.png');
	    }
	    $this->result["avatar_width"] = $this->diafan->configmodules("avatar_width", "usersite");
	    $this->result["avatar_height"] = $this->diafan->configmodules("avatar_height", "usersite");
	    $this->result["error_avatar"] = $this->get_error("registration", 'avatar');
	}

	if (!empty($_SERVER["HTTP_REFERER"]) && !$this->diafan->configmodules("act", "usersite"))
	{
	    $ref = parse_url($_SERVER["HTTP_REFERER"]);

	    if ($ref["host"] == $_SERVER["HTTP_HOST"])
	    {
		$this->result["url"] = $_SERVER["HTTP_REFERER"];
	    }
	}

	$form = $this->diafan->_user->id ? 'user' : 'reg';
	$cache_meta = array(
	    "name" => "usersite_param_".$form,
	    "language" => _LANG
	);
	if (!$rows_param = $this->diafan->_cache->get($cache_meta, "usersite"))
	{
	    $rows_param = array();
	    $result = DB::query("SELECT id, [name], type, required, [text] FROM {usersite_param} WHERE trash='0' AND `form` IN ('form', '".$form."')"
			    ." ORDER BY sort ASC");

	    while ($row = DB::fetch_array($result))
	    {
		if ($row["type"] == 'select' || $row["type"] == 'multiple')
		{
		    $result_select = DB::query("SELECT [name], id FROM {usersite_param_select} WHERE param_id=%d ORDER BY sort ASC", $row["id"]);
		    while ($row_select = DB::fetch_array($result_select))
		    {
			$row["select_array"][] = $row_select;
		    }
		}
		$rows_param[] = $row;
	    }
	    //сохранение кеша
	    $this->diafan->_cache->save($rows_param, $cache_meta, "usersite");
	}
	$this->result["rows_param"] = $rows_param;
	$multiple = array();
	foreach ($rows_param as $row)
	{
	    $this->result['error_p'.$row["id"]] = $this->get_error("registration", 'p'.$row["id"]);
	    if ($row["type"] == "multiple")
	    {
		$multiple[] = $row["id"];
	    }
	}

	if ($this->diafan->_user->id)
	{
	    $result = DB::query("SELECT value, param_id FROM {usersite_param_element} WHERE trash='0' AND element_id=%d", $this->diafan->_user->id);
	    while ($row = DB::fetch_array($result))
	    {
		if (in_array($row["param_id"], $multiple))
		{
		    $this->result["user"]['p'.$row["param_id"]][] = $row["value"];
		}
		else
		{
		    $this->result["user"]['p'.$row["param_id"]] = $row["value"];
		}
	    }
	}

	return $this->result;
    }

    /**
     * Генерирует данные для формы авторизации
     * 
     * @return array|boolean false
     */
    function show_login()
    {
	$result["registration"] = BASE_PATH_HREF.$this->diafan->_route->module("registration");
	$result["user"] = $this->diafan->_user->id;
	if (!$result["user"])
	{
	    switch ($this->diafan->_user->errauth)
	    {
		case 'wrong_login_or_pass':
		    $result["error"] = _LANG_WRONG_LOGIN_OR_PASS;
		    break;

		case 'blocked_30_min':
		    $result["error"] = _LANG_BLOCKED_30_MIN;
		    break;

		case 'blocked':
		    $result["error"] = _LANG_LOGIN_BLOCKED;
		    break;

		default:
		    $result["error"] = '';
	    }
	    $result["reminding"] = BASE_PATH_HREF.$this->diafan->_route->module("reminding");
	    $result["action"] = $this->diafan->module == "registration" ? BASE_PATH_HREF : '';
	}
	else
	{
	    $result["fio"] = $this->diafan->_user->fio;
	    $result["type"] = $this->diafan->_user->discount_type['name'];
	    if ($this->diafan->configmodules("avatar", "usersite"))
	    {
		$result["avatar"] = file_exists(ABSOLUTE_PATH.'userfiles/avatar/'.$this->diafan->_user->name.'.png');
		$result["avatar_width"] = $this->diafan->configmodules("avatar_width", "usersite");
		$result["avatar_height"] = $this->diafan->configmodules("avatar_height", "usersite");
		$result["name"] = $this->diafan->_user->name;
	    }
	}
	return $result;
    }

    /**
     * Формирует список рассылок
     * @return array
     */
    private function parent_id_subscribtion_module_registration($parent_id, $rew, $array, $subscribtion)
    {
	$result = DB::query("SELECT name,id FROM {subscribtion_category} WHERE parent_id='%d' AND trash='0'", $parent_id);
	while ($row = DB::fetch_array($result))
	{
	    $this->result["subscribtion"].=$rew.'<input type="checkbox" name="subscribtion[]" value="'.$row["id"].'"'
		    .(!strstr($subscribtion, ' '.$row["id"].' ') ? ' checked' : '')
		    .'> '.$row["name"].'<br>';
	    if (in_array($row["id"], $array))
	    {
		return $array;
	    }
	    $array[] = $row["id"];
	    $array = $this->parent_id_subscribtion_module_registration($row["id"], '&nbsp;&nbsp;&nbsp;'.$rew, $array, $subscribtion);
	}
	return $array;
    }

    public function get_param()
    {
	if (empty($this->diafan->_user->id))
	    return false;

	$cache_meta = array(
	    "name" => "order_param",
	    "language" => _LANG
	);
	if (!$rows_param = $this->diafan->_cache->get($cache_meta, "registration"))
	{
	    $rows_param = array();
	    $result = DB::query("SELECT id, [name], type, required, [text] FROM {shop_order_param} WHERE trash='0' AND def='1' ORDER BY sort ASC");

	    while ($row = DB::fetch_array($result))
	    {
		if ($row["type"] == 'select' || $row["type"] == 'multiple')
		{
		    $result_select = DB::query("SELECT [name], id FROM {shop_order_param_select} WHERE param_id=%d ORDER BY sort ASC", $row["id"]);
		    while ($row_select = DB::fetch_array($result_select))
		    {
			$row["select_array"][] = $row_select;
		    }
		}
		$row["value"] = DB::result(DB::query("SELECT value FROM {shop_order_param_def} WHERE trash='0' AND user_id=%d AND param_id='%d'", $this->diafan->_user->id, $row['id']));
		$this->result['error_dop_p'.$row["id"]] = $this->get_error("order", 'dop_p'.$row["id"]);
		$rows_param[] = $row;
	    }
	    //сохранение кеша
	    $this->diafan->_cache->save($rows_param, $cache_meta, "registration");
	}
	$this->result["dop_rows_param"] = $rows_param;


	return TRUE;
    }

}