<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Search_view
 *
 * Шаблон модуля "Поиск по сайту"
 */
class Search_view extends View
{
	/**
	 * Шаблон вывода результатов поиска по сайту
	 * 
	 * @param array $result сгенерированные в моделе данные
	 * @return boolean true
	 */
	public function show_module($result)
	{
		self::show_search($result);

		if (! empty($result["value"]))
		{
			echo '<div class="search_result">'.$this->_('TOTAL_FOUND').": <b>".$result["value"].": ".$result["count"]."</b>
			<br>".sprintf($this->_('COUNT_SEARCH'), $result["count-page"], $result["count"])
			.'</div>';

			if (! empty($result["rows"]))
			{
				foreach ($result["rows"] as $row)
				{
					echo '
				<div class="search_list">
					'.$row["i"].'. '
					.($row["site"] ? '<a href="'.BASE_PATH_HREF.$row["site"]["link"].'">'.$row["site"]["name"].'</a> / ' : '')
					.($row["cat"]  ? '<a href="'.BASE_PATH_HREF.$row["cat"]["link"].'">'.$row["cat"]["name"].'</a> / '   : '')
					.'<a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["name"]."</a>
					<br>".$row["snippet"]."
				</div>";				
				}
			}
			echo (! empty($result["paginator"]) ? $result["paginator"] : '');
		}
                else
                {
                   echo '<div class="search_result">'.$this->_('NOT_SEARCHWORD').'</div>'; 
                }

		return TRUE;
	}

	/**
	 * Шаблон формы поиска по сайту
	 * 
	 * @param array $result сгенерированные в моделе данные
	 * @return boolean true
	 */
	public function show_search($result)
	{	
		echo '
		<div class="search">
			<form action="'.$result["action"].'" method="get">
			<input type="text" name="searchword" value="'.($result["value"]?$result["value"]:'Поиск по сайту').'" class="input_search" >
			<input type="submit" value="'.$result["button"].'" class="submit_search">
			</form>
		</div>';

		return TRUE;
	}

	/**
	 * Шаблон формы поиска по сайту
	 * 
	 * @param array $result сгенерированные в моделе данные
	 * @return boolean true
	 */
	public function show_search_top($result)
	{	
		echo '
		<div class="top_search">
			<form action="'.$result["action"].'" method="get">
			<input type="text" name="searchword" value="'.($result["value"]?$result["value"]:'Поиск по сайту').'" class="input_search" >
			<input type="submit" value="'.$result["button"].'" class="submit_search">
			</form>
		</div>';

		return TRUE;
	}
}