<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.4
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
    include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Shop_admin_ajax
 * 
 * Обработка Ajax-запросов в административной части модуля Магазин
 */
class Shop_admin_ajax
{

    /**
     * @var object основной объект системы
     */
    public $diafan;

    /**
     * @var array результаты, передаваемы Ajaxом
     */
    private $result;

    /**
     * Конструктор класса
     * 
     * @return void
     */
    public function __construct($frame)
    {
	$this->diafan = $frame->diafan;

	// Прошел ли пользователь проверку идентификационного хэша
	if ($_POST["action"] != "show_rel_goods")
	{
	    if (!$this->diafan->_user->checked)
	    {
		$this->result["error"] = 'ERROR_HASH';
		$this->send_json();
	    }
	}
	$this->result["hash"] = $this->diafan->_user->get_hash();

	if (!empty($_POST["action"]))
	{
	    switch ($_POST["action"])
	    {
		case 'up_param':
		case 'down_param':
		    $this->sort_param();
		    break;
		case 'delete_param':
		    $this->delete_param();
		    break;
		case 'rel_goods':
		    $this->rel_goods();
		    break;
		case 'show_rel_goods':
		    $this->show_rel_goods();
		    break;
		case 'delete_rel_good':
		    $this->delete_rel_good();
		    break;
		case 'show_discount_goods':
		    $this->show_discount_goods();
		    break;
		case 'discount_good':
		    $this->discount_good();
		    break;
		case 'delete_discount_good':
		    $this->delete_discount_good();
		    break;
		case 'delete_order_good':
		    $this->delete_order_good();
		    break;
		case 'clone_good':
		    $this->clone_good();
		    break;
	    }
	}
    }

    /**
     * Сортирует значения списка параметров
     * 
     * @return void
     */
    private function sort_param()
    {
	$id = intval($_POST['id']);
	if (!empty($id))
	{
	    $oldsort = DB::query_result("SELECT sort FROM {shop_param_select} WHERE param_id=%d AND id=%d", $this->diafan->edit, $id);
	    $row = DB::fetch_array(DB::query("SELECT id, sort FROM {shop_param_select} WHERE param_id=%d AND id<>%d AND"
				    .($_POST["action"] == "up_param" ? " sort<=%d ORDER BY sort DESC" : " sort>=%d ORDER BY sort ASC")." LIMIT 1", $this->diafan->edit, $id, $oldsort));
	    if ($row)
	    {
		DB::query("UPDATE {shop_param_select} SET sort=%d WHERE id=%d", $oldsort, $row["id"]);
		DB::query("UPDATE {shop_param_select} SET sort=%d WHERE id=%d", $row["sort"], $id);
	    }
	}
	$this->diafan->_cache->delete("", $this->diafan->module);

	$this->send_json();
    }

    private function clone_good()
    {
	$id = intval($_POST['id']);
	if (empty($id))
	    return FALSE;

	$row = DB::fetch_array(DB::query("SELECT * from {shop} WHERE id='%d'", $id));

	foreach ($row as $k => $v)
	{
	    if ($k == 'name')
	    {
		$v = 'КОПИЯ '.$v;
	    }
	    $row[$k] = "'".$v."'";
	}
	unset($row['id']);
	unset($row['buy']);
	unset($row['view']);

	DB::query('INSERT INTO {shop} ('.implode(',', array_keys($row)).') VALUES ('.implode(',', $row).')');
	
	$n_id = DB::next_id("shop");
	$site_id = $row['site_id'];
	
	$result=DB::query("SELECT cat_id,trash FROM {shop_category_rel} WHERE element_id='%d'",$id);
	while($row=DB::fetch_array($result))
	{
	  DB::query("INSERT INTO {shop_category_rel} (element_id, cat_id, trash) VALUES ('%d','%d','%s')",$n_id,$row['cat_id'],$row['trash']);  
	}
	
	$result = DB::query("SELECT price, param_id, param_value, count_goods FROM {shop_price} WHERE good_id=%d AND trash='0' ORDER BY param_value ASC", $id);	
	while($row=DB::fetch_array($result))
	{
	    $row['good_id']=$n_id;
	    foreach ($row as $k => $v) $row_param[$k] = "'".$v."'";
	    DB::query('INSERT INTO {shop_price} ('.implode(',', array_keys($row_param)).') VALUES ('.implode(',', $row_param).')');
	}
	
	$result= DB::query("SELECT value, param_id FROM {shop_param_element} WHERE element_id='%d' AND trash='0'",$id);
	while($row=DB::fetch_array($result))
	{
	    $row['element_id']=$n_id;
	    foreach ($row as $k => &$v) $v = "'".$v."'";
	    DB::query('INSERT INTO {shop_param_element} ('.implode(',', array_keys($row)).') VALUES ('.implode(',', $row).')');  
	}

	
	
	/*// парам

	$values = array();
	$rvalues = array();

	$result = DB::query("SELECT p.id, p.name, p.type FROM {shop_param} as p "
			.($this->diafan->configmodules("cat", "shop", $site_id) ? " LEFT JOIN {shop_category_rel} as c ON c.element_id=".$id
				." INNER JOIN {shop_param_category_rel} as cp ON (cp.cat_id=c.cat_id OR cp.cat_id=0) AND cp.element_id=p.id" : "")
			." WHERE p.trash='0' AND p.site_id=%d GROUP BY p.id"
			." ORDER BY p.sort ASC", $site_id
	);
	$result_el = DB::query("SELECT value as rv, [value], param_id FROM {shop_param_element} WHERE element_id=%d", $id);
	while ($row_el = DB::fetch_array($result_el))
	{
	    $values[$row_el["param_id"]][] = $row_el["value"];
	    $rvalues[$row_el["param_id"]][] = $row_el["rv"];
	}
	while ($row = DB::fetch_array($result))
	{
		DB::query("INSERT INTO {shop_param_element} (value,param_id,element_id) VALUES ('%s','%d','%d')", $rvalues[$row["id"]][0], $row["id"], $n_id);
	}
	
	$result = DB::query("SELECT p.price, p.param_id, p.param_value, p.count_goods FROM {shop_price} as p"
							." LEFT JOIN {shop_param_select} as s ON p.param_id=s.param_id AND p.param_value=s.id"
							." WHERE p.good_id=%d AND p.trash='0' GROUP BY p.id ORDER BY s.sort ASC", $id);
	
	while ($row_param = DB::fetch_array($result))
		{
			$row_param['good_id']=$n_id;
			foreach ($row_param as $k => $v) $row_param[$k] = "'".$v."'";
			DB::query('INSERT INTO {shop_price} ('.implode(',', array_keys($row_param)).') VALUES ('.implode(',', $row_param).')');
		}

*/

	include_once(ABSOLUTE_PATH.'plugins/json.php');
	$json["redirect"] = URL.'edit'.$n_id.'/';
	echo to_json($json);

	return TRUE;
    }
    /**
     * Удаляет значения списка параметров
     * 
     * @return void
     */
    private function delete_param()
    {
	$id = intval($_POST['id']);
	if (!empty($id))
	{
	    DB::query("DELETE FROM {shop_param_select} WHERE param_id=%d AND id=%d", $this->diafan->edit, $id);
	}
	$this->diafan->_cache->delete("", $this->diafan->module);

	$this->send_json();
    }

    /**
     * Прикрепляет похожие товары
     * 
     * @return void
     */
    private function rel_goods()
    {
	if (empty($_POST["element_id"]))
	{
	    DB::query("INSERT INTO {shop} () VALUES ()");
	    $_POST["element_id"] = DB::next_id("shop");
	    $this->result["id"] = $_POST["element_id"];
	}
	include_once(ABSOLUTE_PATH.'modules/shop/admin/shop.admin.view.php');
	if ($_POST["element_id"] != $_POST["rel_id"] &&
		!DB::query_result("SELECT COUNT(*) FROM {shop_rel} WHERE good_id=%d AND rel_good_id=%d OR rel_good_id=%d AND good_id=%d", $_POST["element_id"], $_POST["rel_id"], $_POST["element_id"], $_POST["rel_id"]))
	{
	    DB::query("INSERT INTO {shop_rel} (good_id, rel_good_id) VALUES (%d, %d)", $_POST["element_id"], $_POST["rel_id"]);
	}

	$this->result["data"] = Shop_admin_view::rel_goods($this, $_POST["element_id"]);

	$this->send_json();
    }

    /**
     * Подгружает список товаров для выбора похожих
     * 
     * @return void
     */
    private function show_rel_goods()
    {
	if (empty($_POST["element_id"]))
	{
	    $_POST["element_id"] = 0;
	}
	$nastr = 24;
	$list = '';
	if (empty($_POST["page"]))
	{
	    $start = 0;
	    $page = 1;
	    if (!isset($_POST["search"]))
	    {
		$list = _LANG_SEARCH.': <input type="text" size="30" class="rel_shop_search">
				<div class="rel_all_goods_container">';
	    }
	}
	else
	{
	    $page = intval($_POST["page"]);
	    $start = ($page - 1) * $nastr;
	}
	$rel_goods = array();
	if ($_POST["element_id"])
	{
	    $result = DB::query("SELECT good_id, rel_good_id FROM {shop_rel} WHERE good_id=%d OR rel_good_id=%d", $_POST["element_id"]);
	    while ($row = DB::fetch_array($result))
	    {
		$rel_goods[] = $row["good_id"];
		$rel_goods[] = $row["rel_good_id"];
	    }
	}

	if (!empty($_POST["search"]))
	{
	    $count = DB::query_result("SELECT COUNT(*) FROM {shop} WHERE trash='0' AND name LIKE '%h%%' AND id<>%d", $_POST["search"], $_POST["element_id"]);
	    $result = DB::query_range("SELECT id, name FROM {shop} WHERE trash='0' AND name LIKE '%h%%' AND id<>%d", $_POST["search"], $_POST["element_id"], $start, $nastr);
	}
	else
	{
	    $count = DB::query_result("SELECT COUNT(*) FROM {shop} WHERE trash='0' AND id<>%d", $_POST["element_id"]);
	    $result = DB::query_range("SELECT id, name FROM {shop} WHERE trash='0' AND id<>%d", $_POST["element_id"], $start, $nastr);
	}
	while ($row = DB::fetch_array($result))
	{
	    $img = DB::query_result("SELECT name FROM {images} WHERE element_id=%d AND module_name='shop' AND trash='0' ORDER BY sort ASC LIMIT 1", $row["id"]);
	    $list .= '<div class="rel_shop" element_id="'.$row["id"].'">
			<div'.(in_array($row["id"], $rel_goods) ? ' class="rel_shop_selected"' : '').'>
			'.($img ? '<a href="#"><img src="'.BASE_PATH.USERFILES.'/shop/small/'.$img.'"></a><br>' : '').'
			<a href="#">'.$row["name"].'</a>
			</div>
			</div>';
	}
	$list .= '<div class="clearing rel_shop_navig">';
	for ($i = 1; $i <= ceil($count / $nastr); $i++)
	{
	    if ($i != $page)
	    {
		$list .= '<a href="#" page="'.$i.'">'.$i.'</a> ';
	    }
	    else
	    {
		$list .= '['.$i.'] ';
	    }
	}
	$list .= '</div>';
	if (empty($_POST["page"]) && !isset($_POST["search"]))
	{
	    $list .= '</div>';
	}

	$this->result["data"] = $list;

	$this->send_json();
    }

    /**
     * Удаляет похожие товары
     * 
     * @return void
     */
    private function delete_rel_good()
    {
	DB::query("DELETE FROM {shop_rel} WHERE good_id=%d AND rel_good_id=%d", $_POST['element_id'], $_POST['rel_id']);
	DB::query("DELETE FROM {shop_rel} WHERE rel_good_id=%d AND good_id=%d", $_POST['element_id'], $_POST['rel_id']);

	$this->diafan->_cache->delete("", $this->diafan->module);

	$this->send_json();
    }

    /**
     * Подгружает список товаров
     * 
     * @return void
     */
    private function show_discount_goods()
    {
	if (empty($_POST["discount_id"]))
	{
	    $_POST["discount_id"] = 0;
	}
	$nastr = 24;
	$list = '';
	if (empty($_POST["page"]))
	{
	    $start = 0;
	    $page = 1;
	    if (!isset($_POST["search"]))
	    {
		$list = _LANG_SEARCH.': <input type="text" size="30" class="rel_shop_search">
				<div class="rel_all_goods_container">';
	    }
	}
	else
	{
	    $page = intval($_POST["page"]);
	    $start = ($page - 1) * $nastr;
	}
	$discount_goods = array();
	if ($_POST["discount_id"])
	{
	    $result = DB::query("SELECT good_id FROM {shop_discount_object} WHERE discount_id=%d", $_POST["discount_id"]);
	    while ($row = DB::fetch_array($result))
	    {
		$discount_goods[] = $row["good_id"];
	    }
	}
	if (!empty($_POST["search"]))
	{
	    $count = DB::query_result("SELECT COUNT(*) FROM {shop} WHERE trash='0' AND name LIKE '%h%%'", $_POST["search"]);
	    $result = DB::query_range("SELECT id, name FROM {shop} WHERE trash='0' AND name LIKE '%h%%'", $_POST["search"], $start, $nastr);
	}
	else
	{
	    $count = DB::query_result("SELECT COUNT(*) FROM {shop} WHERE trash='0'");
	    $result = DB::query_range("SELECT id, name FROM {shop} WHERE trash='0'", $start, $nastr);
	}
	while ($row = DB::fetch_array($result))
	{
	    $img = DB::query_result("SELECT name FROM {images} WHERE element_id=%d AND module_name='shop' AND trash='0' ORDER BY sort ASC LIMIT 1", $row["id"]);
	    $list .= '<div class="rel_shop" element_id="'.$row["id"].'">
			<div'.(in_array($row["id"], $discount_goods) ? ' class="rel_shop_selected"' : '').'>
			'.($img ? '<a href="#"><img src="'.BASE_PATH.USERFILES.'/shop/small/'.$img.'"></a><br>' : '').'
			<a href="#">'.$row["name"].'</a>
			</div>
			</div>';
	}
	$list .= '<div class="clearing rel_shop_navig">';
	for ($i = 1; $i <= ceil($count / $nastr); $i++)
	{
	    if ($i != $page)
	    {
		$list .= '<a href="#" page="'.$i.'">'.$i.'</a> ';
	    }
	    else
	    {
		$list .= '['.$i.'] ';
	    }
	}
	$list .= '</div>';
	if (empty($_POST["page"]) && !isset($_POST["search"]))
	{
	    $list .= '</div>';
	}

	$this->result["data"] = $list;

	$this->send_json();
    }

    /**
     * Прикрепляет скидку к товару
     * 
     * @return void
     */
    private function discount_good()
    {
	if (!$_POST["discount_id"])
	{
	    DB::query("INSERT INTO {shop_discount} () VALUES ()");
	    $_POST["discount_id"] = DB::next_id("shop_discount");
	    $this->result["id"] = $_POST["discount_id"];
	}
	include_once(ABSOLUTE_PATH.'modules/shop/admin/shop.admin.view.php');
	if (!DB::query_result("SELECT COUNT(*) FROM {shop_discount_object} WHERE good_id=%d AND discount_id=%d", $_POST["good_id"], $_POST["discount_id"]))
	{
	    DB::query("INSERT INTO {shop_discount_object} (good_id, discount_id) VALUES (%d, %d)", $_POST["good_id"], $_POST["discount_id"]);
	}

	$this->result["data"] = Shop_admin_view::discount_goods($this, $_POST["discount_id"]);

	$this->send_json();
    }

    /**
     * Удаляет скидку на товар
     * 
     * @return void
     */
    private function delete_discount_good()
    {
	DB::query("DELETE FROM {shop_discount_object} WHERE good_id=%d AND discount_id=%d", $_POST['good_id'], $_POST['discount_id']);

	$this->diafan->_cache->delete("", $this->diafan->module);

	$this->send_json();
    }

    /**
     * Удаляет товар из заказа
     * 
     * @return void
     */
    private function delete_order_good()
    {
	$this->result["summ"] = 0;
	$this->result["count"] = 0;

	if (!DB::query("DELETE FROM {shop_order_goods} WHERE id=%d", intval($_POST['id'])))
	{
	    $this->result["error"] = 'ERROR';
	    $this->send_json();
	    return false;
	}
	$this->diafan->_cache->delete("", $this->diafan->module);

	$result = DB::query("SELECT count_goods,price FROM {shop_order_goods} where order_id=%d", $this->diafan->edit);
	while ($row = DB::fetch_array($result))
	{
	    $this->result["summ"] += $row["price"] * $row["count_goods"];
	    $this->result["count"] += $row["count_goods"];
	}
	$this->result["summ"] = $this->diafan->format_price($this->result["summ"]);
	$this->send_json();
    }

    /**
     * Отдает ответ Ajax
     * 
     * @return void
     */
    private function send_json()
    {
	if ($this->result)
	{
	    include_once(ABSOLUTE_PATH.'plugins/json.php');
	    echo to_json($this->result);
	    exit;
	}
    }

}