<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Shop_admin_config
 *
 * Конфигурация магазина
 */
class Shop_admin_config extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'shop_config';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
		
		$this->variable_table = array(
			'base' => array(
				
				'not_buy'                 => 'checkbox',
				'security_user'           => 'checkbox',
				'hr1'                     => 'hr',
				
				'nastr'                   => 'numtext',
				'count_rel_goods'         => 'numtext',
				'hr2'                     => 'hr',
				
				'use_count_goods'         => 'checkbox',
				'hr3'                     => 'hr',
				
				'cat'                     => 'checkbox',
				'count_list'              => 'numtext',
				'childrens_elements'      => 'checkbox',
				'hr4'                     => 'hr',
				
				'currency'                => 'text',
				'format_price'            => 'function',
				'format_price_1'          => 'none',
				'format_price_2'          => 'none',
				'format_price_3'          => 'none',
				'hr5'                     => 'hr',
				
				'search_price'            => 'checkbox',
				'search_text'             => 'checkbox',
				'search_name'             => 'checkbox',
				'search_article'          => 'checkbox',
				'hr6'                     => 'hr',
				
				'comments'                => 'module',
				'tags'                    => 'module',
				'rating'                  => 'module'
			),
			'images' => array(
				'images'                  => 'module',
			),
			'yandex_shop' => array(
				'yandex'                  => 'checkbox',
				'nameshop'                => 'text',
				'currencyyandex'          => 'function',
				'currencyratesel'         => 'none',
				'currencyrate'            => 'none',
				'show_yandex_category'    => 'select',
				'show_yandex_element'     => 'select',
				'bid'                     => 'numtext',
				'cbid'                    => 'numtext'
			),
			'send_mails' => array(
				//'hr7'                     => 'hr',
				
				'mes'                     => 'textarea',
				//'order_step_2_text'       => 'editor',
				
			    'desc_order'              => 'text',
				'error_empty_fields'      => 'text',
			
				'hr9'                     => 'hr',

				'subject'                 => 'text',
				'message'                 => 'textarea',
				'emailconf'               => 'function',
				'email'                   => 'none',

				'hr10'                     => 'hr',

				'subject_admin'           => 'text',
				'message_admin'           => 'textarea',
				'emailconfadmin'          => 'function',
				'email_admin'             => 'none'
			)
		);

		$this->language_names = array(
			'currency',
			'mes',
			'subject',
			'message',
			'desc_order',
			'courier_text',
			'wm_text',
			'robox_text',
			'non_cash_text',
			'payment_success_text',
			'payment_fail_text'
		);

		$this->config_module = array(
			'tab_card'     => 1, //делить редактирование на вкладки
			'element_site' => 1, //делит элементы по разделам (страницы сайта, к которым прикреплен модуль)
			'config'       => 1  //файл настроек модуля
		);

		$this->select_arr["currencyyandex"] = array(
			'RUR' => 'RUR',
			'USD' => 'USD',
			'EUR' => 'EUR',
			'UAH' => 'UAH'
		);

		$this->select_arr["show_yandex_category"] = array(
			'0' => _ADMIN_SHOP_YANDEX_0,
			'1' => _ADMIN_SHOP_YANDEX_1
		);

		$this->select_arr["show_yandex_element"] = array(
			'0' => _ADMIN_SHOP_YANDEX_0,
			'1' => _ADMIN_SHOP_YANDEX_1
		);

		$this->select_arr["currencyratesel"] = array(
			'1' => _ADMIN_SHOP_CONFIG_CURRENCYRATESEL_1,
			'2' => _ADMIN_SHOP_CONFIG_CURRENCYRATESEL_2,
			'3' => _ADMIN_SHOP_CONFIG_CURRENCYRATESEL_3
		);

		$this->show_tr_click_checkbox = array(
			'cat' => array(
					'count_list'
				),
			'yandex' => array(
					'nameshop',
					'currencyyandex',
					'bid',
					'cbid',
					'show_yandex_category',
					'show_yandex_element'
				)
		);
	}

	/**
	 * Редактирование поля "Формат цены"
	 * 
	 * @return boolean true
	 */
	function edit_format_price_module_config()
	{
		echo '
		<tr'.$this->get_other().'>
			<td class="td_first">'.$this->variable_names().'</td>
			<td>
				'
			.sprintf(
				_ADMIN_SHOP_CONFIG_FORMAT_PRICE_NUM,
				'<input type="text" name="format_price_1" size="2" value="'.$this->values["format_price_1"].'" class="inpnum">'
				.'<br>',
				
				'<input type="text" name="format_price_2" size="2" value="'.$this->values["format_price_2"].'">'
				.'<br>',
				
				'<input type="text" name="format_price_3" size="2" value="'.$this->values["format_price_3"].'">'
			)
			.$this->show_help_row().'
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Редактирование поля "Валюта для Яндекс.Маркета"
	 * 
	 * @return boolean true
	 */
	protected function edit_currencyyandex_module_config()
	{
		echo '
		<tr'.$this->get_other().' valign="top">
			<td class="td_first">'.$this->variable_names().'</td>
			<td>
				<select name="'.$this->key.'">
					'.$this->select_option($this->key, '', '', '', $this->value).'
				</select>
				<div class="currencyratesel">
					<br>
					<select name="currencyratesel">
						'.$this->select_option('currencyratesel', '', '', '', $this->values['currencyratesel']).'
					</select>
					<div class="currencyrate">
						<br>
						<input type="text" name="currencyrate" size="20" value="'.$this->values["currencyrate"].'">
						'.$this->variable_names("currencyrate").'
					</div>
				</div>';
		?>
		<script language="javascript" type="text/javascript">
		$(document).ready(function() {
			$("select[name=currencyyandex]").change(function(){
				show_currency($(this));
			});
			$("select[name=currencyratesel]").change(function(){
				show_currencysel($(this));
			});
			
			show_currency($("select[name=currencyyandex]"));
			show_currencysel();
                        
			function show_currency(th)
			{
				if (th && th.val() == 'RUR')
				{
					$(".currencyratesel").hide();
				}
				else
				{
					$(".currencyratesel").show();
				}
			}
			function show_currencysel(th)
			{
				if (th && th.val() == '2')
				{
					$(".currencyrate").hide();
				}
				else
				{
					$(".currencyrate").show();
				}
			}
		});
		</script>
		<?php
		echo $this->show_help_row().'
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Выводит вкладку "Наличными курьеру"
	 * 
	 * @return boolean true
	 */
	protected function edit_tab_1_module_config()
	{
		echo '</table>
		<script language="javascript" type="text/javascript">
			var tabs_mini = new Array("courier", "wm", "robox", "non_cash");
			var current_tab_mini = "";
		</script>
		<table class="table_edit">
			<tr'.$this->get_other().'>
				<td>
					<a href="javascript:void(0)" class="show_tab_mini href" rel="courier">'._ADMIN_SHOP_CONFIG_COURIER.'</a>
				</td>
			</tr>
		</table>
		<div  class="tab_mini courier">
		<table class="table_edit">
			<tr>
				<td class="td_first"></td>
				<td></td>
			</tr>';

		return TRUE;
	}

	/**
	 * Выводит вкладку "Webmoney"
	 * 
	 * @return boolean true
	 */
	protected function edit_tab_2_module_config()
	{
		echo '</table>
		</div>
		<table class="table_edit">
			<tr'.$this->get_other().'>
				<td align="left">
					<a href="javascript:void(0)" class="show_tab_mini href" rel="wm">'._ADMIN_SHOP_CONFIG_WEBMONEY.'</a>
				</td>
			</tr>
		</table>
		<div class="tab_mini wm">
		<table class="table_edit">
			<tr>
				<td class="td_first"></td>
				<td></td>
			</tr>';

		return TRUE;
	}

	/**
	 * Выводит вкладку "Robokassa"
	 * 
	 * @return boolean true
	 */
	protected function edit_tab_3_module_config()
	{
		echo '</table>
		</div>
		<table class="table_edit">
			<tr'.$this->get_other().'>
				<td align="left">
					<a href="javascript:void(0)" class="show_tab_mini href" rel="robox">'._ADMIN_SHOP_CONFIG_ROBOX.'</a>
				</td>
			</tr>
		</table>
		<div class="tab_mini robox">
		<table class="table_edit">
			<tr>
				<td class="td_first"></td>
				<td></td>
			</tr>';

		return TRUE;
	}

	/**
	 * Выводит вкладку "Банковские платежи"
	 * 
	 * @return boolean true
	 */
	protected function edit_tab_4_module_config()
	{
		echo '</table>
		</div>
		<table class="table_edit">
			<tr'.$this->get_other().'>
				<td align="left">
					<a href="javascript:void(0)" class="show_tab_mini href" rel="non_cash">'._ADMIN_SHOP_CONFIG_NON_CASH.'</a>
				</td>
			</tr>
		</table>
		<div class="tab_mini non_cash">
		<table class="table_edit">
			<tr>
				<td class="td_first"></td>
				<td></td>
			</tr>';

		return TRUE;
	}

	/**
	 * Закрывает вкладку "Банковские платежи"
	 * 
	 * @return boolean true
	 */
	protected function edit_tab_5_module_config()
	{
		echo '</table>
		</div>
		<table class="table_edit">
			<tr>
				<td class="td_first"></td>
				<td></td>
			</tr>';

		return TRUE;
	}

	/**
	 * Выводит вкладку "Название магазина для Яндекс.Маркета"
	 * 
	 * @return boolean true
	 */
	protected function edit_nameshop_module_config()
	{
		echo '
		<tr'.$this->get_other().'>
			<td class="td_first">'.$this->variable_names().'</td>
			<td>
				<input type="text" name="'. $this->key.'" size="40" value="'
				.(! $this->diafan->addnew ? str_replace('"', '&quot;', $this->value) : '')
				.'" maxlength="20" class="inp_maxlength"> <span class="maxlength">'.(20 - utf::strlen($this->value)).'</span>
				'.$this->show_help_row().'
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Сохранение поля "Robokassa: логин"
	 * 
	 * @return boolean true
	 */
	protected function save_robox_login_module_config()
	{
		return TRUE;
	}

	/**
	 * Сохранение поля "Robokassa: пароль 1"
	 * 
	 * @return boolean true
	 */
	protected function save_robox_pass_1_module_config()
	{
		return TRUE;
	}

	/**
	 * Сохранение поля "Robokassa: пароль 2"
	 * 
	 * @return boolean true
	 */
	protected function save_robox_pass_2_module_config()
	{
		return TRUE;
	}

	/**
	 * Сохранение поля "Webmoney: кошелек"
	 * 
	 * @return boolean true
	 */
	protected function save_wm_target_module_config()
	{
		return TRUE;
	}

	/**
	 * Сохранение поля "Webmoney: секретный ключ"
	 * 
	 * @return boolean true
	 */
	protected function save_wm_secret_module_config()
	{
		$new_values = array(
				'ROBOX_LOGIN'  => $this->diafan->get_param($_POST, "robox_login", '', 1),
				'ROBOX_PASS_1' => $this->diafan->get_param($_POST, "robox_pass_1", '', 1),
				'ROBOX_PASS_2' => $this->diafan->get_param($_POST, "robox_pass_2", '', 1),
				'WM_SECRET'    => $this->diafan->get_param($_POST, "wm_secret", '', 1),
				'WM_TARGET'    => $this->diafan->get_param($_POST, "wm_target", '', 1)
			);
		include_once(ABSOLUTE_PATH.'includes/config.php');
		Config::save($new_values, $this->diafan->language_all);
		return TRUE;
	}

	/**
	 * Поготавливает значения для формы
	 * 
	 * @return array
	 */
	protected function get_values()
	{
		$values = array(
			"wm_secret"            => defined('WM_SECRET') ? WM_SECRET : '',
			"wm_target"            => defined('WM_TARGET') ? WM_TARGET : '',
			"robox_login"          => defined('ROBOX_LOGIN') ? ROBOX_LOGIN : '',
			"robox_pass_1"         => defined('ROBOX_PASS_1') ? ROBOX_PASS_1 : '',
			"robox_pass_2"         => defined('ROBOX_PASS_2') ? ROBOX_PASS_2 : ''
		);
		return $values;
	}
}