<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Shop_admin_import_element
 *
 * Редактирование сообщений
 */
class Shop_admin_import_element extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'shopimport';

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'shop_import';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		$this->diafan->nastr = 30;

		//поля в базе данных для редактирования
		$this->variable_table = array(
			'name'        => 'text',
			'type'        => 'select',
			'param_id'    => 'select',
			'cat_id'      => 'select',
			//'sort'        => 'function',
			'js'          => 'function'
		);

		$this->config_module = array(
			'del'      => 1, //удалить
			'element'  => 1, //используются группы
			'trash'    => 1, //использовать корзину
			'order'    => 1, //сортируется
			'category_flat' => 1
		);

		$this->select["param_id"] = array(
			"shop_param",
			"id",
			"name",
			"",
			"-"
		);

		$this->select["cat_id"] = array(
			"shop_import_category",
			"id",
			"name",
			"",
			"-"
		);

		$this->select_arr["type"] = array(
			"id"      => _ADMIN_SHOP_IMPORT_ID,
			"name"    => _ADMIN_SHOP_IMPORT_NAME,
			"article" => _ADMIN_SHOP_IMPORT_ARTICLE,
			"anons"   => _ADMIN_SHOP_IMPORT_ANONS,
			"text"    => _ADMIN_SHOP_IMPORT_TEXT,
			"price"   => _ADMIN_SHOP_IMPORT_PRICE,
			"count"   => _ADMIN_SHOP_IMPORT_COUNT,
			"cats"    => _ADMIN_SHOP_IMPORT_CATS,
			"empty"   => _ADMIN_SHOP_IMPORT_EMPTY,
			"parent"  => _ADMIN_SHOP_IMPORT_PARENT,
			"param"   => _ADMIN_SHOP_IMPORT_PARAM
		);
	}

	/**
	 * Выводит список сообщений
	 * @return boolean true
	 */
	public function show_module()
	{
		if (! empty($_POST["upload"]) || ! empty($_GET["upload"]))
		{
			$this->upload();
		}

		if (DB::query_result("SELECT COUNT(*) FROM {shop_import} WHERE cat_id=%d AND trash='0'", $this->diafan->cat))
		{
			echo '
			<div style="float: right;">
				<br>
				<form action="" enctype="multipart/form-data" method="post">
				<input type="hidden" name="upload" value="true">
				<input type="file" name="file">
				<input type="submit" value="'._LANG_SEND.'">
				<p>'._ADMIN_SHOP_IMPORT_ONLY_CSV.'</p>
				</form>
			</div>';
		}

		$this->addnew_init(_ADMIN_ADD_FIELD);

		echo '<table class="list">';
		$this->list_row($this->diafan->cat);
		echo '</table>';

		return TRUE;
	}

	/**
	 * Загружает файл импорта
	 * @return boolean true
	 */
	private function upload()
	{
		if (isset($_FILES["file"]) && is_array($_FILES["file"]) && $_FILES["file"]['name'] != '')
		{
			move_uploaded_file($_FILES["file"]['tmp_name'],  ABSOLUTE_PATH.USERFILES.'/tmp');
			echo '<meta http-equiv="Refresh" content="0; url='.URL.'?ftell=0&amp;upload=true">';
			exit;
		}
		elseif (! file_exists(ABSOLUTE_PATH.USERFILES.'/tmp'))
		{
			$this->diafan->redirect_js(URL);
			exit;
		}

		// количество строк, выгружаемых за один проход скрипта
		$count_part = 500;
		// разделитель данных в строке
		$delimiter = ";";
		// кодировка: cp1251, utf-8
		$encoding = 'cp1251';

		$import = DB::fetch_array(DB::query("SELECT * FROM {shop_import_category} WHERE id=%d", $this->diafan->cat));

		$k = 0;
		$params = array();
		$req_fileds = array();
		$result = DB::query("SELECT type, param_id FROM {shop_import} WHERE trash='0' AND cat_id=%d ORDER BY sort ASC", $this->diafan->cat);
		while ($row = DB::fetch_array($result))
		{
			if ($row["type"] == "param")
			{
				$params[$k]["id"] = $row["param_id"];
				$params[$k]["type"] = DB::query_result("SELECT type FROM {shop_param} WHERE id=%d", $row["param_id"]);
				$params[$k]["values"] = array();
				if ($params[$k]["type"] == 'select' || $params[$k]["type"] == 'multiple')
				{
					$result2 = DB::query("SELECT id, name FROM {shop_param_select} WHERE param_id=%d", $row["param_id"]);
					while ($row2 = DB::fetch_array($result2))
					{
						$params[$k]["values"][$row2["name"]] = $row2["id"];
					}
				}
			}
			$req_fileds[$row["type"]] = $k;
			$k++;
		}
		if ($req_fileds)
		{
			if (empty($_GET['ftell']))
			{
				if ($import["type"] == 'category')
				{
					DB::query("ALTER TABLE {shop_category} ADD `import_parent_id` VARCHAR( 32 ) NOT NULL AFTER `import_id`");
				}
			}
			if ($import["delete_items"] && empty($_GET['ftell']))
			{
				if (! isset($req_fileds["id"]))
				{
					if ($import["type"] == 'good')
					{
						DB::query("DELETE FROM {shop_category_rel} WHERE element_id IN (SELECT id FROM {shop} WHERE site_id=%d)", $import["site_id"]);
						DB::query("DELETE FROM {shop_rel} WHERE good_id IN (SELECT id FROM {shop} WHERE site_id=%d)", $import["site_id"]);
						DB::query("DELETE FROM {shop_rel} WHERE rel_good_id IN (SELECT id FROM {shop} WHERE site_id=%d)", $import["site_id"]);
						DB::query("DELETE FROM {shop_price} WHERE good_id IN (SELECT id FROM {shop} WHERE site_id=%d)", $import["site_id"]);
						DB::query("DELETE FROM {shop_param_element} WHERE element_id IN (SELECT id FROM {shop} WHERE site_id=%d)", $import["site_id"]);
						DB::query("DELETE FROM {shop_discount_object} WHERE good_id IN (SELECT id FROM {shop} WHERE site_id=%d)", $import["site_id"]);
						$result = DB::query("SELECT * FROM {images} WHERE module_name='shop' AND element_id IN (SELECT id FROM {shop} WHERE site_id=%d)", $import["site_id"]);
						while ($row = DB::fetch_array($result))
						{
							unlink(ABSOLUTE_PATH.USERFILES."/shop/".$row["name"]);
							unlink(ABSOLUTE_PATH.USERFILES."/shop/medium/".$row["name"]);
							unlink(ABSOLUTE_PATH.USERFILES."/shop/small/".$row["name"]);
						}
						DB::query("DELETE FROM {images} WHERE module_name='shop' AND element_id IN (SELECT id FROM {shop} WHERE site_id=%d)", $import["site_id"]);
						
						DB::query("DELETE FROM {shop} WHERE site_id=%d", $import["site_id"]);
					}
					else
					{
						DB::query("DELETE FROM {shop_category_parents} WHERE element_id IN (SELECT id FROM {shop_category} WHERE site_id=%d)", $import["site_id"]);
						DB::query("DELETE FROM {shop_param_category_rel} WHERE cat_id IN (SELECT id FROM {shop_category} WHERE site_id=%d)", $import["site_id"]);
						DB::query("DELETE FROM {shop_category_rel} WHERE cat_id IN (SELECT id FROM {shop_category} WHERE site_id=%d)", $import["site_id"]);
						DB::query("DELETE FROM {shop_discount_object} WHERE cat_id IN (SELECT id FROM {shop_category} WHERE site_id=%d)", $import["site_id"]);
						DB::query("DELETE FROM {shop_category} WHERE site_id=%d", $import["site_id"]);
					}
				}
				else
				{
					if ($import["type"] == 'good')
					{
						DB::query("UPDATE {shop} SET `import`='0'");
					}
					else
					{
						DB::query("UPDATE {shop_category} SET `import`='0'");
					}
				}
			}
			$handle = fopen(ABSOLUTE_PATH.USERFILES.'/tmp', "r");
			if (isset($_GET['ftell']))
			{
				fseek($handle, $_GET['ftell']);
			}
			$i = 0;
			// построчное считывание и анализ строк из файла
			while (($data_f = fgets($handle)) !== FALSE)
			{
				if ($encoding == 'cp1251')
				{
					$data_f = utf::to_utf($data_f);
				}
				$data = explode($delimiter, $data_f);
				if (! isset($req_fileds["id"]))
				{
					DB::query("INSERT INTO {shop".($import["type"] == 'category' ? "_category" : "")."} (act, site_id"
					          .(isset($req_fileds["name"]) ? ", name" : "")
							  .(isset($req_fileds["article"]) ? ", article" : "")
					          .(isset($req_fileds["anons"]) ? ", anons" : "")
					          .(isset($req_fileds["text"]) ? ", text" : "")
					          .(isset($req_fileds["parent"]) && $import["type"] == 'category' ? ", import_parent_id" : "")
					          .") VALUES ('0', '".$import["site_id"]."'"
					          .(isset($req_fileds["name"]) ? ", '".(! empty($data[$req_fileds["name"]]) ? trim($data[$req_fileds["name"]]) : '')."'" : "")
							  .(isset($req_fileds["article"]) ? ", '".(! empty($data[$req_fileds["article"]]) ? trim($data[$req_fileds["article"]]) : '')."'" : "")
					          .(isset($req_fileds["anons"]) ? ", '".(! empty($data[$req_fileds["anons"]]) ? trim($data[$req_fileds["anons"]]) : '')."'" : "")
					          .(isset($req_fileds["text"]) ? ", '".(! empty($data[$req_fileds["text"]]) ? trim($data[$req_fileds["text"]]) : '')."'" : "")
					          .(isset($req_fileds["parent"]) && $import["type"] == 'category' ? ", '".(! empty($data[$req_fileds["parent"]]) ? trim($data[$req_fileds["parent"]]) : '')."'" : "")
					          .")");
					$id = DB::next_id("shop");
				}
				else
				{
					if ($id = DB::query_result("SELECT id FROM {shop".($import["type"] == 'category' ? "_category" : "")."} WHERE import_id='%s'AND trash='0'", $data[$req_fileds["id"]]))
					{
						DB::query("UPDATE {shop".($import["type"] == 'category' ? "_category" : "")."} SET import='1', site_id='".$import["site_id"]."'"
						          .(isset($req_fileds["name"]) ? ", name='".(! empty($data[$req_fileds["name"]]) ? trim($data[$req_fileds["name"]]) : '')."'" : "")
								  .(isset($req_fileds["article"]) ? ", article='".(! empty($data[$req_fileds["article"]]) ? trim($data[$req_fileds["article"]]) : '')."'" : "")
						          .(isset($req_fileds["anons"]) ? ", anons='".(! empty($data[$req_fileds["anons"]]) ? trim($data[$req_fileds["anons"]]) : '')."'" : "")
						          .(isset($req_fileds["text"]) ? ", text='".(! empty($data[$req_fileds["text"]]) ? trim($data[$req_fileds["text"]]) : '')."'" : "")
						          .(isset($req_fileds["parent"]) && $import["type"] == 'category' ? ", import_parent_id='".(! empty($data[$req_fileds["parent"]]) ? trim($data[$req_fileds["parent"]]) : '')."'" : "")
						          ." WHERE id=%d", $id);
					}
					else
					{
						DB::query("INSERT INTO {shop".($import["type"] == 'category' ? "_category" : "")."} (act, import, import_id, site_id"
						          .(isset($req_fileds["name"]) ? ", name" : "")
								  .(isset($req_fileds["article"]) ? ", article" : "")
						          .(isset($req_fileds["anons"]) ? ", anons" : "")
						          .(isset($req_fileds["text"]) ? ", text" : "")
						          .(isset($req_fileds["parent"]) && $import["type"] == 'category' ? ", import_parent_id" : "")
						          .") VALUES ('0', '1', '".$data[$req_fileds["id"]]."', '".$import["site_id"]."'"
						          .(isset($req_fileds["name"]) ? ", '".(! empty($data[$req_fileds["name"]]) ? trim($data[$req_fileds["name"]]) : '')."'" : "")
						          .(isset($req_fileds["article"]) ? ", '".(! empty($data[$req_fileds["article"]]) ? trim($data[$req_fileds["article"]]) : '')."'" : "")
						          .(isset($req_fileds["anons"]) ? ", '".(! empty($data[$req_fileds["anons"]]) ? trim($data[$req_fileds["anons"]]) : '')."'" : "")
						          .(isset($req_fileds["text"]) ? ", '".(! empty($data[$req_fileds["text"]]) ? trim($data[$req_fileds["text"]]) : '')."'" : "")
						          .(isset($req_fileds["parent"]) && $import["type"] == 'category' ? ", '".(! empty($data[$req_fileds["parent"]]) ? trim($data[$req_fileds["parent"]]) : '')."'" : "")
						          .")");
						$id = DB::next_id("shop");
					}
				}
				if ($import["type"] == 'good')
				{
					if (isset($req_fileds["price"]) || isset($req_fileds["count"]))
					{
						if (isset($req_fileds["id"]))
						{
							DB::query("DELETE FROM {shop_price} WHERE good_id=%d", $id);
						}
						$price = isset($req_fileds["price"]) ? trim($data[$req_fileds["price"]]) : 0;
						$count = isset($req_fileds["count"]) ? trim($data[$req_fileds["count"]]) : 0;
						DB::query("INSERT INTO {shop_price} (good_id, price, count_goods) VALUES (%d, %f, %f)", $id, $price, $count);
					}
					if (isset($req_fileds["cats"]))
					{
						if (isset($req_fileds["id"]))
						{
							DB::query("DELETE FROM {shop_category_rel} WHERE element_id=%d", $id);
						}
						$cat_id = 0;
						if (! empty($data[$req_fileds["cats"]]))
						{
							$data[$req_fileds["cats"]] = trim($data[$req_fileds["cats"]]);
							if (! isset($cache["cats"][$data[$req_fileds["cats"]]]))
							{
								$cache["cats"][$data[$req_fileds["cats"]]] =
								DB::query_result("SELECT id FROM {shop_category} WHERE import_id='%h' AND trash='0'", $data[$req_fileds["cats"]]);
							}
							$cat_id = $cache["cats"][$data[$req_fileds["cats"]]];
							DB::query("INSERT INTO {shop_category_rel} (element_id, cat_id) VALUES (%d, %d)", $id, $cat_id);
						}
						DB::query("UPDATE {shop} SET cat_id=%d WHERE id=%d", $cat_id, $id);
					}
					foreach ($params as $k => $param)
					{
						if (! $param["id"])
							continue;
						$value = trim($data[$k]);
						if ($param["type"] == 'select' || $param["type"] == 'multiple')
						{
							$value = ! empty($param["values"][trim($data[$k])]) ? $param["values"][trim($data[$k])] : '';
						}

						if (isset($req_fileds["id"]))
						{
							DB::query("DELETE FROM {shop_param_element} WHERE param_id=%d AND element_id=%d", $param["id"], $id);
						}
						if (! empty($data[$k]))
						{
							DB::query("INSERT INTO {shop_param_element} (value, param_id, element_id) VALUES ('%s', %d, %d)", $value, $param["id"], $id);
						}
					}
				}

				if ($i == $count_part)
				{
					echo '<meta http-equiv="Refresh" content="0; url='.URL.'?ftell='.ftell($handle).'&amp;upload=true">';
					exit;
				}
				
				$i++;
			}
			fclose($handle);
			unlink(ABSOLUTE_PATH.USERFILES.'/tmp');

			if ($import["type"] == 'good')
			{
				DB::query("UPDATE {shop} SET sort=id WHERE sort=0");
			}
			else
			{
				DB::query("UPDATE {shop_category} SET sort=id WHERE sort=0");
			}

			if (isset($req_fileds["id"]))
			{
				if ($import["type"] == 'good')
				{
					if ($import["delete_items"])
					{
						DB::query("DELETE FROM {shop_category_rel} WHERE element_id IN (SELECT id FROM {shop} WHERE `import`='0' AND site_id=%d)", $import["site_id"]);
						DB::query("DELETE FROM {shop_rel} WHERE good_id IN (SELECT id FROM {shop} WHERE `import`='0' AND site_id=%d)", $import["site_id"]);
						DB::query("DELETE FROM {shop_rel} WHERE rel_good_id IN (SELECT id FROM {shop} WHERE `import`='0' AND site_id=%d)", $import["site_id"]);
						DB::query("DELETE FROM {shop_price} WHERE good_id IN (SELECT id FROM {shop} WHERE `import`='0' AND site_id=%d)", $import["site_id"]);
						DB::query("DELETE FROM {shop_param_element} WHERE element_id IN (SELECT id FROM {shop} WHERE `import`='0' AND site_id=%d)", $import["site_id"]);
						DB::query("DELETE FROM {shop_discount_object} WHERE good_id IN (SELECT id FROM {shop} WHERE `import`='0' AND site_id=%d)", $import["site_id"]);
						$result = DB::query("SELECT * FROM {images} WHERE module_name='shop' AND element_id IN (SELECT id FROM {shop} WHERE `import`='0' AND site_id=%d)", $import["site_id"]);
						while ($row = DB::fetch_array($result))
						{
							unlink(ABSOLUTE_PATH.USERFILES."/shop/".$row["name"]);
							unlink(ABSOLUTE_PATH.USERFILES."/shop/medium/".$row["name"]);
							unlink(ABSOLUTE_PATH.USERFILES."/shop/small/".$row["name"]);
						}
						DB::query("DELETE FROM {images} WHERE module_name='shop' AND element_id IN (SELECT id FROM {shop} WHERE `import`='0' AND site_id=%d)", $import["site_id"]);

						DB::query("DELETE FROM {shop} WHERE `import`='0' AND site_id=%d", $import["site_id"]);
					}
				}
				else
				{
					if ($import["delete_items"])
					{
						DB::query("DELETE FROM {shop_category_parents} WHERE element_id IN (SELECT id FROM {shop_category} WHERE `import`='0' AND site_id=%d)", $import["site_id"]);
						DB::query("DELETE FROM {shop_param_category_rel} WHERE cat_id IN (SELECT id FROM {shop_category} WHERE `import`='0' AND site_id=%d)", $import["site_id"]);
						DB::query("DELETE FROM {shop_category_rel} WHERE cat_id IN (SELECT id FROM {shop_category} WHERE `import`='0' AND site_id=%d)", $import["site_id"]);
						DB::query("DELETE FROM {shop_discount_object} WHERE cat_id IN (SELECT id FROM {shop_category} WHERE `import`='0' AND site_id=%d)", $import["site_id"]);
						DB::query("DELETE FROM {shop_category} WHERE `import`='0' AND site_id=%d", $import["site_id"]);
					}
					if (isset($req_fileds["parent"]))
					{
						$result = DB::query("SELECT id, import_parent_id FROM {shop_category} WHERE `import`='1'");
						while ($row = DB::fetch_array($result))
						{
							DB::query("DELETE FROM {shop_category_parents} WHERE element_id=%d", $row["id"]);
							if ($row["import_parent_id"])
							{
								if (! isset($cache["cats"][$row["import_parent_id"]]))
								{
									$cache["cats"][$row["import_parent_id"]] =
									DB::query_result("SELECT id FROM {shop_category} WHERE import_id='%h' AND trash='0'", $row["import_parent_id"]);
								}
								$parent_id = $cache["cats"][$row["import_parent_id"]];
								DB::query("UPDATE {shop_category} SET parent_id=%d WHERE id=%d", $parent_id, $row["id"]);
								$parents = array();
								while ($parent_id > 0 && ! in_array($parent_id, $parents))
								{
									$parents[] = $parent_id;
									DB::query("INSERT INTO {shop_category_parents} (`element_id`, `parent_id`) VALUES (%d, %d)", $row["id"], $parent_id);
									$parent_id = DB::query_result("SELECT parent_id FROM {shop_category} WHERE id=%d", $parent_id);
								}
							}
						}
						$result = DB::query("SELECT id FROM {shop_category}"); 
						while ($row = DB::fetch_array($result))
						{
							$count = DB::query_result("SELECT COUNT(*) FROM  {shop_category_parents} WHERE parent_id=%d", $row["id"]);
							DB::query("UPDATE {shop_category} SET count_children=%d WHERE id=%d", $count, $row["id"]);
						}
					}
				}
			}
			if ($import["type"] == 'category')
			{
				DB::query("ALTER TABLE {shop_category} DROP `import_parent_id`");
			}
			$this->diafan->_cache->delete("", "shop");
		}

		$this->diafan->redirect_js(URL.'error1/');
		exit;
	}

	/**
	 * Выводит порядковый номер поля
	 *
	 * @param array $row информация о текущем элменте списка
	 * @return string
	 */
	protected function get_parent_name($row)
	{
		return '<td width="1%">'.($this->k - 1).'.</td>';
	}

	/**
	 * Редактирование поля "JS"
	 * @return boolean true
	 */
	protected function edit_js_module()
	{
		echo '<script type="text/javascript" src="'.BASE_PATH.'modules/shop/admin/shop.admin.import.element.js"></script>';
		return TRUE;
	}

	/**
	 * Сохранение поля "JS"
	 * @return boolean true
	 */
	protected function save_js_module()
	{
		return TRUE;
	}
}