<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Shop_admin_param
 *
 * Редактирование дополнительных характеристик товаров
 */
class Shop_admin_param extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'shopparam';

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'shop_param'; 

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		//поля в базе данных для редактирования
		$this->variable_table = array(
			'name'		=> 'text',
			'type'		=> 'select',
			'required'	=> 'checkbox',
			'param'		=> 'function',
			'page'		=> 'checkbox',
			'cat_id'	=> 'function',
			'hr1'		=> 'hr',
			'search'	=> 'checkbox',
			'list'		=> 'checkbox',
			'block'		=> 'checkbox',
			'hr2'		=> 'hr',
			'text'		=> 'textarea',
			'site_id'	=> 'function',
			//'sort'     => 'function'
		);

		//поля, которые прячутся в Дополнительно
		$this->variable_other = array(
			//'sort' => 1
			'site_id' => 1
		);

		//переводимые поля
		$this->language_names = array(
			'name',
			'text'
		);

		$this->config_module = array(
			'del'   => 1,	//удалить
			'order' => 1,	//сортируется
			'trash' => 1	//использовать корзину
		);

		//выводить в списке содержание полей:
		$this->config_other_row = array(
			'type',
			'id',
			'text'
		);

		$this->select_arr["type"] = array(
			"text"     => _ADMIN_PARAM_TEXT_FIELD,
			"numtext"  => _ADMIN_PARAM_NUMTEXT_FIELD,
			"date"     => _ADMIN_PARAM_DATE_FIELD,
			"textarea" => _ADMIN_PARAM_TEXTAREA_FIELD,
			"checkbox" => _ADMIN_PARAM_CHECKBOX_FIELD,
			"select"   => _ADMIN_PARAM_SELECT_FIELD,
			"multiple" => _ADMIN_PARAM_MULTIPLE_FIELD,
			"editor"   => _ADMIN_PARAM_EDITOR_FIELD,
			"title"    => _ADMIN_PARAM_TITLE_FIELD
		);
		if (! $this->diafan->configmodules("cat", "shop", $this->diafan->site))
		{
			unset($this->variable_table["cat_id"]);
		}
	}

	/**
	 * Выводит список дополнительных характеристик товара
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->addnew_init(_ADMIN_SHOP_ADD_PARAM);

		if ($this->diafan->configmodules("cat", "shop", $this->diafan->site))
		{
			echo '<p>'._ADMIN_CAT_ID.': <select rel="'.path_module($this->diafan, 0, 0, 0, 1, 1).'" class="redirect" name="cat">'
			.'<option value="">'._LANG_ALL.'</option>'
			.'<option value="9999"'.($this->diafan->cat == 9999 ? ' selected' : '').'>'._LANG_COMMON.'</option>';
			$result = DB::query("SELECT id, name FROM {shop_category} WHERE trash='0'".($this->diafan->site ? " AND site_id=".$this->diafan->site : "")." ORDER BY sort ASC");
			while ($row = DB::fetch_array($result))
			{
				$cats[0][] = $row;
			}
			echo $this->get_options($cats, $cats[0], array($this->diafan->cat))
			.'</select></p>';
		}

		if ($this->diafan->cat)
		{
			$this->diafan->cat = $this->diafan->cat == 9999 ? 0 : $this->diafan->cat;
			$this->where .= " AND e.id IN (SELECT element_id FROM {shop_param_category_rel} WHERE cat_id='".$this->diafan->cat."')";
		}

		echo '<table class="list">
		<col width="25%">
		<col width="15%">
		<col width="5%">
		<col width="40%">
		<col width="4%">
		<col width="1%">';
		$this->list_row();
		echo '</table>';

		return TRUE;
	}

	/**
	 * Выводит категории в списке характеристик
	 * @return boolean true
	 */
	protected function other_row_type($row)
	{
		return '</td><td>'.$this->select_arr["type"][$row["type"]];
	}

	/**
	 * Выводит тип характеристики в списке характеристик
	 * @return boolean true
	 */
	protected function other_row_id($row)
	{
		$cats = array();
		$result = DB::query("SELECT s.[name] FROM {shop_param_category_rel} as c INNER JOIN {shop_category} as s ON s.id=c.cat_id"
		                    ." WHERE element_id='%d'", $row["id"]);
		while ($row_cat = DB::fetch_array($result))
		{
			$cats[] = $row_cat["name"];
		}
		if (! $cats)
		{
			$cats[] = _LANG_COMMON;
		}
		return '</td><td>'.implode(', ', $cats);
	}

	/**
	 * Редактирование поля "Параметры"
	 * @return boolean true
	 */
	protected function edit_param_module()
	{
		$value = array();
		if (empty($this->values["type"]))
		{
			$this->values["type"] = '';
		}
		if (! $this->diafan->addnew && in_array($this->values["type"], array('select', 'multiple', 'checkbox')))
		{
			$result_select = DB::query("SELECT [name], value, id FROM {shop_param_select} WHERE param_id=%d ORDER BY sort ASC", $this->diafan->edit);
			while ($row_select = DB::fetch_array($result_select))
			{
				if ($this->values["type"] == 'checkbox')
				{
					$value[$row_select["value"]] = $row_select["name"];
				}
				else
				{
					$value[$row_select["id"]] = $row_select["name"];
				}
			}
		}

		echo '
		<script type="text/javascript" src="'.BASE_PATH.'modules/shop/admin/shop.admin.param.js"></script>

		<tr id="param" valign="top">
			<td class="td_first">'._ADMIN_SHOPPARAM_PARAM_REWRITE.'</td>
			<td>
			<table>';

		$fileds = false;
		$m = 1;
		if (in_array($this->values["type"], array('select', 'multiple')))
		{
			foreach ($value as $k => $v)
			{
				$rewrite = DB::query_result("SELECT rewrite FROM {rewrite} WHERE module_name='shop' AND param_id=%d", $k);
				echo '
				<tr class="param">
					<td>
						<input type="hidden" name="param_id[]" value="'.$k.'" class="param_id">
						<input type="text" name="paramv[]" size="30" value="'.str_replace('"', '&quot;', $v).'">
						<input type="text" name="param_rewrite[]" size="20" value="'.$rewrite.'">
						<span class="param_actions">
							<a href="javascript:void(0)" action="delete_param" confirm="'._ADMIN_CONFIRM_DELETE.'">
								<img src="'.BASE_PATH.'adm/img/delete.gif" width="15" height="15" alt="'._LANG_DELETE.'">
							</a>
							<a href="javascript:void(0)" action="up_param">
								<img src="'.BASE_PATH.'adm/img/up.gif" width="14" height="16" alt="'._ADMIN_UP.'">
							</a>
							<a href="javascript:void(0)" action="down_param">
								<img src="'.BASE_PATH.'adm/img/down.gif" width="14" height="16" alt="'._ADMIN_DOWN.'">
							</a>
						</span>
					</td>
				</tr>';
				$m++;
				$fileds = true;
			}
		}
		if (! $fileds)
		{
			echo '
			<tr class="param">
				<td>
					<input type="text" name="paramv[]" size="30" value="">
					<input type="text" name="param_rewrite[]" size="20" value="">
					<span class="param_actions">
						<a href="javascript:void(0)" action="delete_param" confirm="'._ADMIN_CONFIRM_DELETE.'">
							<img src="'.BASE_PATH.'adm/img/delete.gif" width="15" height="15" alt="'._LANG_DELETE.'">
						</a>
					</span>
				</td>
			</tr>';
		}
		echo '</table>
				<a href="javascript:void(0)" class="param_plus" title="'._LANG_ADD.'"><img src="'.BASE_PATH.'adm/img/add.gif" width="16" height="16" alt="'._LANG_ADD.'"></a>
			</td>
		</tr>
		<tr id="param_check">
			<td class="td_first">'.$this->variable_names().'</td>
			<td>
				'._LANG_YES.' <input type="text" name="paramk_check1" size="20" value="'
				.(! empty($value[1]) && $this->values["type"] == 'checkbox' ? str_replace('"', '&quot;', $value[1]) : '')
				.'">
				&nbsp;&nbsp;
				'._LANG_NO.' <input type="text" name="paramk_check0" size="20" value="'
				.(! empty($value[0]) && $this->values["type"] == 'checkbox' ? str_replace('"', '&quot;', $value[0]) : '').'">
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Редактирование поля "Категория"
	 * 
	 * @return boolean
	 */
	protected function edit_cat_id_module()
	{
		if (! $this->diafan->configmodules("cat", "shop"))
		{
			return FALSE;
		}

		echo '
		<tr'.$this->get_other().' valign="top">
			<td align="right">'.$this->variable_names().'</td>
			<td>';

		$marker = "&nbsp;&nbsp;";
		$result = DB::query("SELECT id, name, parent_id FROM {shop_category} WHERE trash='0' ORDER BY id ASC");
		while ($row = DB::fetch_array($result))
		{
			$cats[$row["parent_id"]][] = $row;
		}

		$values = array();
		if (! $this->diafan->addnew)
		{
			$result = DB::query("SELECT cat_id FROM {shop_param_category_rel} WHERE element_id='%d'", $this->diafan->edit);
			while ($row = DB::fetch_array($result))
			{
				$values[] = $row["cat_id"];
			}
		}
		echo '
				<select name="cat_ids[]" multiple="multiple">'
				.$this->get_options($cats, $cats[0], $values).'
				</select>'.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Сохранение поля "Параметры"
	 * @return boolean true
	 */
	protected function save_param_module()
	{
                switch($_POST["type"])
                {
                    case "select":
                    case "multiple":
                        
                        $ids = array();
			foreach ($_POST["paramv"] as $key => $value)
			{                          
				$id = 0;
				if (! empty($_POST["param_id"][$key]))
				{
					$id = $_POST["param_id"][$key];
				}
				if ($id)
				{
					DB::query("UPDATE {shop_param_select} SET [name]='%h' WHERE id=%d", $value, $id);
				}
				elseif ($value)
				{
					DB::query("INSERT INTO {shop_param_select} (param_id, [name]) VALUES (%d, '%h')", $this->diafan->save, $value);
					$id = DB::next_id("shop_param_select");
					DB::query("UPDATE {shop_param_select} SET sort=id WHERE id=%d", $id);
				}
                                else 
                                {
                                    continue;
                                }
				if (! empty($_POST["param_rewrite"][$key]))
				{
					$rewrite = DB::fetch_array(DB::query("SELECT id, rewrite FROM {rewrite} WHERE module_name='shop' AND param_id=%d", $id));
					if (! empty($rewrite["id"]))
					{
					
						if ($rewrite["rewrite"] != trim($_POST["param_rewrite"][$key]))
						{
							DB::query("UPDATE {rewrite} SET site_id=%d, rewrite='%h' WHERE param_id=%d",
							          $_POST["site_id"], trim($_POST["param_rewrite"][$key]), $id);
						}
					}
					else
					{
						DB::query("INSERT INTO {rewrite} (module_name, site_id, param_id, rewrite) VALUES ('shop', %d, %d, '%h')",
						          $_POST["site_id"], $id, trim($_POST["param_rewrite"][$key]));
					}
				}
				else
				{
                                    DB::query("DELETE FROM {rewrite} WHERE module_name='shop' AND param_id=%d", $id);
				}
				$ids[] = $id;
			}
                        
                        if(!empty($ids)) 
                        {
                            DB::query("DELETE FROM {shop_param_select} WHERE param_id=%d AND id NOT IN (%h)", $this->diafan->save, implode(",", $ids)); 
                        }
                        
                        break;
                    case "checkbox":
                        
                        if ($this->oldrow["type"] == "checkbox" && ($_POST["paramk_check1"] || $_POST["paramk_check0"]))
			{
				$result = DB::query("SELECT id, value FROM {shop_param_select} WHERE param_id=%d", $this->diafan->save);
				while ($row = DB::fetch_array($result))
				{
					if ($row["value"] == 1)
					{
						DB::query("UPDATE {shop_param_select} SET [name]='%h' WHERE id=%d", $_POST["paramk_check1"], $row["id"]);
						$check1 = TRUE;
					}
					elseif ($row["value"] == 0)
					{
						DB::query("UPDATE {shop_param_select} SET [name]='%h' WHERE id=%d", $_POST["paramk_check0"], $row["id"]);
						$check0 = TRUE;
					}
				}
				DB::query("DELETE FROM {shop_param_select} WHERE param_id=%d AND value NOT IN (0,1)", $this->diafan->save);

			}
			else
			{
				DB::query("DELETE FROM {shop_param_select} WHERE param_id=%d", $this->diafan->save);
			}
			if (empty($check0) && $_POST["paramk_check0"])
			{
				DB::query("INSERT INTO {shop_param_select} (param_id, value, [name]) VALUES (%d, 0, '%h')", $this->diafan->save, $_POST["paramk_check0"]);
			}
			if (empty($check1) && $_POST["paramk_check1"])
			{
				DB::query("INSERT INTO {shop_param_select} (param_id, value, [name]) VALUES (%d, 1, '%h')", $this->diafan->save, $_POST["paramk_check1"]);
			}
                        
                        break;
                        
                    default:
                        DB::query("DELETE FROM {shop_param_select} WHERE param_id=%d", $this->diafan->save);
                }
		return TRUE;
	}

	/**
	 * Сохранение поля "Доступен к выбору при заказе"
	 * 
	 * @return boolean true
	 */
	protected function save_required_module()
	{
		$this->query[] = "required='%d'";
		$this->value[] = $_POST["type"] == 'multiple' && ! empty($_POST["required"]) ? 1 : 0;
		return TRUE;
	}

	/**
	 * Сохранение поля "Отдельная страница для значений"
	 * 
	 * @return boolean true
	 */
	protected function save_page_module()
	{
		$this->query[] = "page='%d'";
		$this->value[] = ($_POST["type"] == 'multiple' || $_POST["type"] == 'select') && ! empty($_POST["page"]) ? 1 : 0;
		return TRUE;
	}

	/**
	 * Сохранение поля "Категория"
	 * 
	 * @return boolean
	 */
	protected function save_cat_id_module()
	{
		DB::query("DELETE FROM {shop_param_category_rel} WHERE element_id=%d", $this->diafan->save);

		if (! empty($_POST["cat_ids"]) && is_array($_POST["cat_ids"]))
		{
			foreach ($_POST["cat_ids"] as $cat_id)
			{
				DB::query("INSERT INTO {shop_param_category_rel} (element_id, cat_id) VALUES('%d', '%d')", $this->diafan->save, $cat_id);
				$select_cat_id = TRUE;
			}
		}
		if (empty($select_cat_id))
		{
			DB::query("INSERT INTO {shop_param_category_rel} (element_id, cat_id) VALUES('%d', '0')", $this->diafan->save);
		}
		return TRUE;
	}

	/**
	 * Сопутствующие действия при удалении элемента модуля
	 * @return boolean true
	 */
	protected function delete($del_id, $trash_id)
	{
		$this->del_or_trash_where("shop_param_element", "param_id=".$del_id, $trash_id);
		$this->del_or_trash_where("shop_param_select",  "param_id=".$del_id, $trash_id);
		$this->del_or_trash_where("shop_price",         "param_id=".$del_id, $trash_id);

		return TRUE;
	}
}