<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
    include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Shop_admin_order
 *
 * Редактирование заказов товаров
 */
class Shop_admin_payment extends Frame_admin
{

    /**
     * @var string название файла. используется в имени констант, определяющих названия полей
     */
    public $file = 'shoppayment';

    /**
     * @var string таблица в базе данных
     */
    public $table = 'shop_payment_method';

    /**
     * Конструктор класса
     * 
     * @return void
     */
    public function __construct($diafan)
    {
	$this->diafan = $diafan;

	//поля в базе данных для редактирования
	$this->variable_table = array(
	    'name' => 'text',
	    'act' => 'checkbox',
	    'modules' => 'function',
	    'text' => 'editor',
	);

	$this->config_module = array(
	    'act' => 1,
	    'del' => 1, //удалить
	    'order'=>1,
	    'trash' => 1  //использовать корзину
	    
	);

	$this->select_arr["module_id"] = array(
	    0 => '-',
	    1 => _ADMIN_SHOPPAYMENT_WEBMONEY,
	    2 => _ADMIN_SHOPPAYMENT_ROBOX,
	    3 => _ADMIN_SHOPPAYMENT_NON_CASH
	);

	$this->input = array(
	    1 => array('wm_target', 'wm_secret'),
	    2 => array(
		'robox_login',
		'robox_pass_1',
		'robox_pass_2',
	    ),
	    3 => array(
		'non_cash_name',
		'non_cash_ogrn',
		'non_cash_inn',
		'non_cash_kpp',
		'non_cash_rs',
		'non_cash_bank',
		'non_cash_bik',
		'non_cash_ks',
		'non_cash_address',
		'non_cash_director',
		'non_cash_glbuh',
		'non_cash_kbk',
		'non_cash_tax_department',
		'non_cash_okato'
		)
	);
    }

    /**
     * Выводит список новостей
     * @return boolean true
     */
    public function show_module()
    {

	$this->addnew_init(_LANG_ADD);

	echo '<table class="list">';
	$this->list_row();
	echo '</table>';

	return TRUE;
    }

    private function my_json_encode($a = false)
    {
	if (is_null($a))
	    return 'null';
	if ($a === false)
	    return 'false';
	if ($a === true)
	    return 'true';
	if (is_scalar($a))
	{
	    if (is_float($a))
	    {
		// Always use "." for floats.
		$a = str_replace(",", ".", strval($a));
	    }

	    static $jsonReplaces = array(
	array("\\", "/", "\n", "\t", "\r", "\b", "\f", '"'),
	array('\\\\', '\\/', '\\n', '\\t', '\\r', '\\b', '\\f', '\"')
	    );
	    return '"'.str_replace($jsonReplaces[0], $jsonReplaces[1], $a).'"';
	}
	$isList = true;
	for ($i = 0, reset($a); $i < count($a); $i++, next($a))
	{
	    if (key($a) !== $i)
	    {
		$isList = false;
		break;
	    }
	}
	$result = array();
	if ($isList)
	{
	    foreach ($a as $v)
	    {
		$result[] = $this->json_encode($v);
	    }
	    return '[ '.join(', ', $result).' ]';
	}
	else
	{
	    foreach ($a as $k => $v)
	    {
		$result[] = $this->my_json_encode($k).': '.$this->my_json_encode($v);
	    }
	    return '{ '.join(', ', $result).' }';
	}
    }

    protected function edit_modules_module()
    {
	


	echo '
	    <script type="text/javascript">
	    $(document).ready(function(){';

if (!$this->diafan->addnew)
	{
	    $values = DB::query_result("SELECT module_values FROM {".$this->table."} WHERE id='%d'", $this->diafan->edit);
	    echo 'var values='.$values.';
		if(values)
		{
		$("#sel_mod option[value=\'"+values.module_id+"\']").attr("selected","selected");
		for(var name in values) { $("input[name=\'"+name+"\']").val(values[name]); }
		$(".tr_module_"+values.module_id).show();
		}		
';
	}
    echo '
	    $("#sel_mod").change(function () {
	    $(this).find("option").each(function(){ $(".tr_module_"+$(this).attr("value")).hide(); }  );
	    $(".tr_module_"+$(this).find("option:selected").attr("value")).show();
});	
});
</script>
		<tr'.$this->get_other().'>
			<td class="td_first">
				'.$this->variable_names().'
			</td>
			<td><select name="modules" id="sel_mod">
				';
	foreach ($this->select_arr["module_id"] as $value => $option)
	{
	    echo '<option value="'.$value.'">'.$option.'</option>';
	}
	echo '</select></td>
		</tr>';

	foreach ($this->input as $class => $rows)
	{
	    foreach ($rows as $name)
	    {
		echo '<tr class="tr_module_'.$class.'" style="display:none"><td class="td_first">'.$this->variable_names($name).'</td><td><input type="text" value="" size="40" name="'.$name.'"></td></tr>';
	    }
	}

	return TRUE;
    }

    protected function save_modules_module()
    {
	if (!isset($_POST['modules']))
	    return FALSE;
	$id = (int) preg_replace("/\D/", "", $_POST['modules']);
	$values = array('module_id' => $id);
	foreach ($this->input[$id] as $name)
	{
	    if (!empty($_POST[$name]))
	    {
		$values[$name] = $this->diafan->get_param($_POST, $name, '', 1);
	    }
	}

	$this->query[] = "module_values='%s'";
	$this->value[] = $this->my_json_encode($values);
	return TRUE;
    }

}