<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Shop_ajax
 *
 * Обработка запроса при добавлении товара в корзину
 */
class Shop_ajax extends Model
{
	/**
	 * @var object основной объект системы
	 */
	public $diafan;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
	}

	/**
	 * Обрабатывает полученные данные из формы
	 * 
	 * @return boolean
	 */
	public function ajax_request()
	{
		if (empty($_POST['module']) || $_POST['module'] != 'shop')
		{
			return FALSE;
		}

		if (! empty($_POST['addshop']) && (! $this->diafan->configmodules('security_user') || $this->diafan->_user->id))
		{
			$_POST['addshop'] = intval($_POST['addshop']);
			if (! DB::query_result("SELECT id FROM {shop} WHERE id=%d AND trash='0' AND [act]='1'", $_POST['addshop']))
			{
				$this->result["errors"][0][] = 'ERROR';
				return $this->send_errors();
			}

			$count = ! empty($_POST["count"]) ? intval($_POST["count"]) : 0;
			$count = $count > 0 ? $count : 1;
			$params = array();

			//зависимая цена. параметр, влияющий на цену не определен
			if (empty($_POST["depend"]) && ! DB::query_result("SELECT id FROM {shop_price} WHERE good_id=%d AND param_id=0", $_POST['addshop']))
			{
				$this->result["errors"][0][] = _LANG_PLEASE_SELECT.' '
				                               .DB::query_result("SELECT [name] FROM {shop_param} WHERE type='multiple' AND id IN"
						                                         ." (SELECT param_id FROM {shop_price} WHERE good_id=%d) LIMIT 1", $_POST['addshop']);
				$this->send_errors();
				return TRUE;
			}
			elseif (isset($_POST["depend"]))
			{
				if (! DB::query_result("SELECT id FROM {shop_price} WHERE good_id=%d AND param_value=%d", $_POST['addshop'], $_POST["depend"]))
				{
					$this->result["errors"][0][] = 'ERROR';
					$this->send_errors();
					return TRUE;
				}
				$params["depend"] = intval($_POST["depend"]);
			}

			$result = DB::query("SELECT p.[name], p.id FROM {shop_param} as p WHERE p.`type`='multiple' AND p.required='1'"
								." AND (SELECT COUNT(*) FROM {shop_param_element} WHERE element_id=%d AND param_id=p.id) > 1", $_POST['addshop']);
			while ($row_param = DB::fetch_array($result))
			{
				if (isset($_POST["param".$row_param["id"]]))
				{
					if (empty($_POST["param".$row_param["id"]]))
					{
						$this->result["errors"][0][] = _LANG_PLEASE_SELECT.' '.$row_param["name"];
						$this->send_errors();
						return TRUE;
					}
					else
					{
						$params[$row_param["id"]] = intval($_POST["param".$row_param["id"]]);
					}
				}
			}
			asort($params);
			$param = '|';
			foreach ($params as $key => $value)
			{
				$param .= $key.'='.$value.'|';
			}
			$count_good = 0;
			if (! empty($_SESSION["basket"][$_POST['addshop']]))
			{
				foreach ($_SESSION["basket"][$_POST['addshop']] as $key => $basket)
				{
					if (empty($_POST["depend"]) || strstr($key, '|depend='.$_POST["depend"].'|'))
					{
						$count_good += $basket["count"];
					}
				}
			}
			$count_good += $count;
			if ($this->diafan->configmodules('use_count_goods', 'shop'))
			{
				$count_good_in_shop = DB::query_result("SELECT count_goods FROM {shop_price} WHERE good_id=%d AND param_value=%d", $_POST['addshop'], ! empty($_POST["depend"]) ? $_POST["depend"] : 0);
				if ($count_good > $count_good_in_shop)
				{
					$this->result["errors"][0][] = sprintf(_LANG_NOT_GOOD, $count_good_in_shop);
					$this->send_errors();
					return TRUE;
				}
			}

			if (isset($_SESSION["basket"][$_POST['addshop']][$param]))
			{
				$_SESSION["basket"][$_POST['addshop']][$param]["count"] +=$count;
			}
			else
			{
				$_SESSION["basket"][$_POST['addshop']][$param]["count"] = $count;
				$_SESSION["basket"][$_POST['addshop']][$param]["param"] = $params;
			}

			$summ  = 0;
			$count = 0;
			foreach ($_SESSION["basket"] as $good_id => $array)
			{
				foreach ($array as $param => $c)
				{
					if (isset($c["param"]["depend"]))
					{
						$price = DB::query_result("SELECT price FROM {shop_price} WHERE good_id=%d AND param_value=%d", $good_id, $c["param"]["depend"]);
					}
					else
					{
						$price = DB::query_result("SELECT price FROM {shop_price} WHERE good_id=%d", $good_id);
					}
                                        
                                        $row=array('id'=>$good_id,'price'=>$price);
                                        $this->diafan->_shop->pricing($row);
                                        $price=$row['price'];
					//$discount = $this->get_discount($good_id);
					//$price = $price * (100 - $discount) / 100;
					
					$summ += $price * $c["count"];
					$count += $c["count"];
				}
			}
			$_SESSION["basket_summ"]     = $summ;
			$_SESSION["basket_count"]    = $count;
			
			DB::query("UPDATE {shop} SET buy=buy+1 WHERE id='%d'",$_POST['addshop']);

			$this->result["errors"][0][] = sprintf(_LANG_GOOD_IN_BASKET, BASE_PATH_HREF.$this->diafan->_route->module("basket"), $count_good);
			$this->result["basketcount"] = $count;
			$this->result["basket"]      = $this->diafan->format_price($summ);

			return $this->send_errors();
		}
		return FALSE;
	}

	/**
	 * Определяет скидку на товар
	 *
	 * @param array $row данные о товаре
	 * @return float
	 */
	private function get_discount($id)
	{
		// выбираем все скидки, актуальные на текущий момент
		$discounts = array();
		$result = DB::query("SELECT id, discount FROM {shop_discount} WHERE trash='0' AND act='1' AND (date_start='0' OR date_start<=%d) AND (date_finish='0' OR date_finish>=%d)", time(), time());
		while ($dis = DB::fetch_array($result))
		{
			$discounts[$dis["id"]] = $dis["discount"];
		}
		if ($discounts)
		{
			// проверяем установлена ли скидка на товар
			$discount = DB::query_result("SELECT discount_id FROM {shop_discount_object} WHERE good_id=%d AND discount_id IN (%h) ORDER BY id ASC LIMIT 1", $id, implode(",", array_keys($discounts)));
			if ($discount)
			{
				return $discounts[$discount];
			}
			$cat_id = DB::query_result("SELECT cat_id FROM {shop} WHERE id=%d", $id);

			// проверяем установлена ли скидка на категорию
			if ($cat_id)
			{
				$discount = DB::query_result("SELECT discount_id FROM {shop_discount_object} WHERE cat_id=%d AND discount_id IN (%h) ORDER BY id ASC LIMIT 1", $cat_id, implode(",", array_keys($discounts)));
				if ($discount)
				{
					return $discounts[$discount];
				}
			}

			// проверяем установлена ли скидка на все товары
			$discount = DB::query_result("SELECT discount_id FROM {shop_discount_object} WHERE cat_id=0 AND good_id=0 AND discount_id IN (%h) ORDER BY id ASC LIMIT 1", implode(",", array_keys($discounts)));
			if ($discount)
			{
				return $discounts[$discount];
			}
		}
		return 0;
	}

	/**
	 * Отправляет результат
	 *
	 * @return boolean
	 */
	private function send_errors()
	{
		if (! empty($this->result["errors"][0]))
		{
			$message = implode(', ', $this->result["errors"][0]);
			unset($this->result["errors"][0]);
			$this->result["errors"][0] = $message;

			if (! empty($_POST['ajax']))
			{
				include_once(ABSOLUTE_PATH.'plugins/json.php');
				echo to_json($this->result);
			}
			else
			{
				$this->diafan->redirect(BASE_PATH_HREF.$this->diafan->_route->current_link().'?error=shop'.$_POST['addshop'].'&mess='.$message);
			}
			return TRUE;
		}
		return FALSE;
	}
}