<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
    include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Shop_inc
 */
class Shop_inc
{

    /**
     * @var object основной объект системы
     */
    public $diafan;

    /**
     * Конструктор класса
     * 
     * @return void
     */
    public function __construct($diafan)
    {
	$this->diafan = $diafan;
    }

    // return array
    private function get_discount($row, $discount_type)
    {
	// выбераем 
	$discounts = array();
	$result = DB::query("SELECT id, discount, date_start, date_finish,amount,deduction FROM {shop_discount} WHERE trash='0' AND act='1' AND type='%d'", $discount_type);
	$time = time();
	while ($dis = DB::fetch_array($result))
	{
	    if (!empty($dis['date_start']) && $dis['date_start'] > $time)
		continue;
	    if (!empty($dis['date_finish']) && $dis['date_finish'] < $time)
		continue;
	    $discounts[$dis["id"]] = $dis;
	}

	if (!empty($discounts))
	{
	    // проверяем установлена ли скидка на товар
	    $discount = DB::query_result("SELECT discount_id FROM {shop_discount_object} WHERE good_id=%d AND discount_id IN (%h) ORDER BY id ASC LIMIT 1", $row['id'], implode(",", array_keys($discounts)));
	    if ($discount)
	    {
		return $discounts[$discount];
	    }


	    // проверяем установлена ли скидка на категорию
	    if ($row['cat_id'])
	    {
		$discount = DB::query_result("SELECT discount_id FROM {shop_discount_object} WHERE cat_id=%d AND discount_id IN (%h) ORDER BY id ASC LIMIT 1", $row['cat_id'], implode(",", array_keys($discounts)));
		if ($discount)
		{
		    return $discounts[$discount];
		}
	    }

	    // проверяем установлена ли скидка на все товары
	    $discount = DB::query_result("SELECT discount_id FROM {shop_discount_object} WHERE cat_id=0 AND good_id=0 AND discount_id IN (%h) ORDER BY id ASC LIMIT 1", implode(",", array_keys($discounts)));
	    if ($discount)
	    {
		return $discounts[$discount];
	    }
	}

	return NULL;
    }

    private function calc_price($discount, &$row)
    {
	// если определена ссылка
	if (!empty($discount))
	{
	    $row['old_price'] = $row['price'];
	    // скидка действует от суммы
	    if (!empty($discount['amount']) && $row['price'] > $discount['amount'])
	    {
		$row['price'] = $row['price'] * (100 - $discount['discount']) / 100;
	    }
	    else
	    {
		// если не задано
		if (empty($discount['amount']))
		{
		    $row['price'] = $row['price'] * (100 - $discount['discount']) / 100;
		}
	    }
	    if (!empty($discount['deduction']))
	    {
		$row['price'] -= $discount['deduction']; // фиксированная сумма к вычету.  
	    }



	    $row['discount_finish'] = $discount['date_finish'];
	    $row['discount'] = $discount['discount'];
	}
    }

    /*
     *  Передаем массив информации о товаре
     * id = good_id
     * cat_id = каталог
     * price = цена
     * return BOOL
     * 
     * 
     * параметр row надо передовать по ссылке  - чтобы можно было добавить к нему новое поле!
     */

    public function pricing(&$row)
    {
	if (empty($row['cat_id']))
	    $row['cat_id'] = DB::query_result("SELECT cat_id FROM {shop} WHERE id=%d", $row['id']);

	$discount_type = 0;
	if (!empty($this->diafan->_user->id))
	{
	    $discount_type = $this->diafan->_user->discount_type['id'];
	}


	$discount = $this->get_discount($row, $discount_type);
	if (empty($discount))
	    $discount = $this->get_discount($row, 0);

	$this->calc_price($discount, $row);

	if (!empty($row["depend"]["rows"]))
	{
	    $new_params = array();
	    foreach ($row["depend"]["rows"] as $param)
	    {

		$this->calc_price($discount, $param);

		if (!empty($_GET["p".$row["depend"]["param_id"]]) && in_array($param["value"], $_GET["p".$row["depend"]["param_id"]]))
		{
		    $param["selected"] = TRUE;

		    $row["count"] = $param["count"];
		    $row["selected"] = TRUE;
		}

		$new_params[] = $param;
	    }
	    $row["depend"]["rows"] = $new_params;
	}

	return TRUE;
    }

}