<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Subscribtion_admin
 *
 * Рассылки
 */
class Subscribtion_admin extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'subscribtion';

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'subscribtion';

	/**
	 * @var integer количество отправленных писем
	 */
	var $count = 0;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		//поля в базе данных для редактирования
		$this->variable_table = array(
			'name'    => 'text',
			'created' => 'date',
			'send'    => 'checkbox',
			'lang'    => 'checkbox',
			'hr1'     => 'hr',
			'cat_id'  => 'select',
			'hr2'     => 'hr',
			'text'    => 'editor'
		);

		//поля, которые прячутся в Дополнительно
		$this->variable_other = array(
			'cat_id' => 1,
			'hr1'    => 1
		);

		//переводимые поля
		$this->language_names = array(
			'name',
			'text'
		);

		$this->config_module = array(
			'del'              => 1, //удалить
			'date'             => 1, //показывать дату в списке, сортировать по дате
			'element'          => $this->diafan->configmodules("cat", "subscribtion", $this->diafan->site) ? 1 : 0, //используются группы
			'element_multiple' => $this->diafan->configmodules("cat", "subscribtion", $this->diafan->site) ? 1 : 0, //модуль может быть прикреплен к нескольким группам
			'search_name'      => 1, //искать по названию
			'trash'            => 1  //использовать корзину
		);

		if (count($this->diafan->language_all) < 2)
		{
			unset($this->variable_table['lang']);
		}

		if ($this->diafan->error >= 10)
		{
			$this->count = $this->diafan->error - 10;
			$this->diafan->error = 0;
		}
	}

	/**
	 * Выводит список рассылок
	 * @return boolean true
	 */
	public function show_module()
	{
		if ($this->count)
		{
			echo '<span class="admin_error">'._ADMIN_ERROR_10.' '.$this->count.'</span><br /><br />';
		}

		if ($this->config_module['element'] && ! $this->not_empty_categories)
		{
			echo '<p class="red">'.sprintf(_ADMIN_SUBSCRIBTION_EMPTY_CATEGORIES, '<a href="'.BASE_PATH_HREF.'subscribtion/category/">', '</a>').'</p>';
		}
		else
		{
			$this->addnew_init(_ADMIN_SUBSCRIBTION_ADD);
		}

		echo '<table class="list">';
		$this->list_row($this->diafan->cat);
		echo '</table>';

		return TRUE;
	}

	/**
	 * Редактирование поля "Отправить сообщение"
	 * @return boolean true
	 */
	protected function edit_send_module()
	{

		if (! empty($this->values["sends"]))
			return FALSE;

		echo '
		<tr'.$this->get_other().'>
			<td align="right">
				'.(! empty($this->values["send"]) ? _ADMIN_SUBSCRIBTION_SENDS : $this->variable_names()).'
			</td>
			<td>
				<input type="checkbox" name="'.$this->key.'" value="1"'.(! empty($this->values["sends"]) ? ' checked' : '').'>'
				.$this->show_help_row().'
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Редактирование поля "Дата отправки"
	 * @return boolean true
	 */
	protected function edit_created_module()
	{
		if ($this->diafan->addnew)
			return FALSE;

		echo '
		<tr'.$this->get_other().'>
			<td align="right">
				'.($this->values["send"] ? _ADMIN_SUBSCRIBTION_CREATEDS : $this->variable_names()).'
			</td>
			<td>
				'.date("D, d M Y H:i:s", ($this->value ? $this->value : time()))
				.$this->show_help_row().'
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Сохранение поля "Дата отправки"
	 * @return boolean true
	 */
	protected function save_created_module()
	{
		$created = $this->oldrow["created"];

		if (! $created || ! empty($_POST["text"]) && ! empty($_POST["send"]))
		{
			$created = time();
		}

		$this->query[] = "created='%d'";
		$this->value[] = $created;

		return TRUE;
	}

	/**
	 * Сохранение поля "Язык рассылки"
	 * @return boolean true
	 */
	protected function save_lang_module()
	{
		return TRUE;
	}

	/**
	 * Сохранение поля "Отправить рассылку"
	 * @return boolean true
	 */
	protected function save_send_module()
	{
		if (empty($_POST["text"]) && ! empty($_POST["send"]))
		{
			$this->diafan->err = 10;
			return FALSE;
		}

		if (empty($_POST["send"]) || empty($_POST["text"]))
		{
			return FALSE;
		}

		$subject = str_replace(
			array(
				'%title',
				'%url',
				'%subject'
			),
			array(
				TITLE,
				BASE_URL,
				$this->diafan->get_param($_POST, "name", '', 1)
			),
			$this->diafan->configmodules('subject')
		);

		$message = str_replace(
						'/'.USERFILES,
						'http://'.BASE_URL.'/'.USERFILES,
						$_POST["text"]
		);

		$k = 0;
		$cats = '';
		if ($this->diafan->configmodules("cat"))
		{
			$cats .= " AND (subscribtion NOT LIKE '% ".$_POST["cat_id"]." %'";
			if (! empty($_POST["cat_ids"]))
			{
				foreach ($_POST["cat_ids"] as $cat_id)
				{
					$cats .= " OR subscribtion NOT LIKE '% ".$cat_id." %'";
				}
			}
			$cats .= ")";
		}
		$result = DB::query("SELECT mail FROM {users_site} WHERE act='1'".$cats
		                    .(! empty($this->variable_table['lang']) && empty($_POST["lang"]) ? " AND language='"._LANG."'" : '')
		);

		while ($row = DB::fetch_array($result))
		{
			include_once(ABSOLUTE_PATH."includes/mail.php");
			send_mail(
				$row["mail"],
				$subject,
				$message,
				($this->diafan->configmodules("emailconf") && $this->diafan->configmodules("email") ? $this->diafan->configmodules("email") : '')
			);
			
			$k++;
		}
		$this->diafan->err = 10 + $k;

		$this->query[] = "send='%d'";
		$this->value[] = 1;

		return TRUE;
	}
}