<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Tags_admin
 *
 * Редактирование тэгов
 */
class Tags_admin extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'tags';

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'tags_name';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
		
		//поля в базе данных для редактирования
		$this->variable_table = array(
			'name'        => 'text',
			'rewrite'     => 'function',
			'map_no_show' => 'checkbox',
			//'sort'        => 'function'
		);
		
		//переводимые поля
		$this->language_names = array(
			'name'
		);

		//поля, которые прячутся в Дополнительно
		$this->variable_other = array(
			'map_no_show' => 1,
			//'sort'        => 1
		);

		$this->config_module = array(
			'del'   => 1, // удалить
			'trash' => 1, // использовать корзину
			'order' => 1  // сортировать
		);
	}

	/**
	 * Вывод списка тэгов
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->addnew_init(_ADMIN_TAGS_ADD_TAG);
		echo '<table class="list">';
			$this->list_row();
		echo '</table>';

		return TRUE;
	}

	/**
	 * Выводит объект, к которому прикреплен тэг, в списке
	 * 
	 * @return string
	 */
	protected function other_row_element_id($row)
	{
		$name = DB::query_result("SELECT name FROM {".$row["module_name"]."} WHERE id='%d'", $row["element_id"]);
		return '</td><td>'.($name ? $name : $row["element_id"]);
	}

	/**
	 * Выводит название модуля в списке
	 * 
	 * @return string
	 */
	protected function other_row_module_name($row)
	{
		$const = strtoupper('_LANG_'.$row["module_name"]);
		return '</td><td>'.(defined($const) ? constant($const) : $row["module_name"]);
	}

	/**
	 * Сохранение поля "Псевдоссылка"
	 * @return boolean true
	 */
	protected function edit_rewrite_module()
	{
		$this->values["site_id"] = DB::query_result("SELECT id FROM {site} WHERE addmodule='tags'");
		parent::edit_rewrite_module();

		return TRUE;
	}

	/**
	 * Сохранение поля "Псевдоссылка"
	 * @return boolean true
	 */
	protected function save_rewrite_module()
	{
		$_POST["site_id"] = DB::query_result("SELECT id FROM {site} WHERE addmodule='tags'");
		parent::save_rewrite_module();

		return TRUE;
	}

	/**
	 * Сопутствующие действия при удалении элемента модуля
	 * @return boolean true
	 */
	protected function delete($del_id, $trash_id)
	{
		$this->del_or_trash_where("tags", "tags_name_id=".$del_id, $trash_id);

		return TRUE;
	}
}