<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Tags_inc
 *
 * Работа с тэгами
 */
class Tags_inc
{
	/**
	 * @var object основной объект системы
	 */
	public $diafan;

	/**
	 * @var array имена тэгов
	 */
	public $cache;

	/**
	 * @var integer номер страницы тэгов
	 */
	public $site_id;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct(&$diafan)
	{
		$this->diafan = &$diafan;
	}

	/**
	 * Выводит подключенные к элементу тэги
	 *
	 * @param integer $element_id номер элемента, к котором прикреплены теги
	 * @param strint $module_name название модуля
	 * @return string|boolean false
	 */
	public function get($element_id = 0, $module_name = '')
	{
		if (! $module_name)
		{
			$module_name = $this->diafan->module;
		}
		if (! $element_id)
		{
			$element_id = $this->diafan->show;
		}
		if (! $this->site_id)
		{
			$this->site_id = DB::query_result("SELECT id FROM {site} WHERE addmodule='tags' AND [act]='1' AND block='0'");
		}
		if (! $this->site_id)
		{
			return FALSE;
		}

		//выводит метки, если в конфигурации текущего модуля они подключены
		if (! $this->diafan->configmodules("tags", $module_name) || ! $element_id)
			return FALSE;
	
		$result = DB::query("SELECT n.[name], n.id FROM {tags_name} AS n"
		                    ." INNER JOIN {tags} AS t ON t.tags_name_id=n.id"
		                    ." WHERE t.module_name='%h' AND t.element_id='%d'"
		                    ." AND n.trash='0' AND t.trash='0'"
		                    ." GROUP BY n.id ORDER BY n.sort ASC",
		                    $module_name, $element_id);
		$rows = array();
		
		while ($row = DB::fetch_array($result))
		{
			$row["link"] = $this->diafan->_route->link($this->site_id, "tags", 0, $row["id"]);
			$rows[] = $row;
		}
		return $this->diafan->_tpl->get('show_get', 'tags', $rows);
	}
}