<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Users_admin
 *
 * Редактирование администраторов сайта
 */
class Users_admin extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file	=	'users';

	/**
	 * @var string таблица в базе данных
	 */
	public $table	=	'users';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
		
		//поля в базе данных для редактирования
		$this->variable_table = array(
			'name'		=> 'text',
			'password'	=> 'password',
			'mail'		=> 'text',
			'created'	=> 'date',
			'fio'		=> 'text',
			'role_id'	=> 'select',
			'act'		=> 'checkbox'	
		);
		
		
		$this->config_module = array(
			'del'	=> 1,	//удалить
			'act'	=> 1,	//показать/скрыть
			'trash' => 1	//использовать корзину
		);
		
		//выводить в списке содержание полей:
		$this->config_other_row = array(
			'name as n',
			'role_id'
		);

		$this->select["role_id"] = array(
			"users_role",
			"id",
			"name",
			"",
			"",
			"trash='0'"
		);

		if (! $this->diafan->addnew && $this->diafan->edit == $this->diafan->_user->id || ! $this->diafan->savenew && $this->diafan->save == $this->diafan->_user->id)
		{
			unset($this->variable_table['role_id']);
			unset($this->variable_table['act']);
		}
	}

	/**
	 * Выводит список пользователей
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->addnew_init(_ADMIN_USERS_ADD);
		$this->name = 'fio';
		echo '<table border="0" cellpadding="1" cellspacing="3" class="list">';
		$this->list_row();	
		echo '</table>';

		return TRUE;
	}

	/**
	 * Выводит статус пользователя (на сайте) в списке
	 * 
	 * @return string
	 */
	protected function other_row_nameasn($row)
	{
		return '</td><td>'.$row["n"]
		.($this->diafan->_user->id == $row["id"]
		  || DB::query_result("SELECT COUNT(*) FROM {sessions} WHERE timestamp>=%d AND user_id='%d'", (time() - 900), $row["id"])
		 ? ' <font style="color: #ffffff; background-color: red;">'._ADMIN_USERS_ON_SITE.'</font>'
		 : ''
		 );
	}

	/**
	 * Выводит тип пользователя в списке
	 * 
	 * @return string
	 */
	protected function other_row_role_id($row)
	{
		global $roles;
		if (! $roles)
		{
			$result = DB::query("SELECT name, id FROM {users_role}");
			while ($role = DB::fetch_array($result))
			{
				$roles[$role["id"]] = $role["name"];
			}
		}
		return '</td><td>'.$roles[$row["role_id"]];
	}

	/**
	 * Сохранение поля "Логин"
	 * 
	 * @return boolean true
	 */
	protected function save_name_module()
	{
		$this->query[] = "name='%h'";
		$this->value[] = $this->diafan->translit($_POST["name"]);

		return TRUE;
	}		
}
