<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Usersite_admin_config
 *
 * Конфигурация модуля "Пользователи сайта"
 */
class Usersite_admin_config extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'usersite_config';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		$this->variable_table = array(
			'act'                => 'select',
			'security_code'      => 'checkbox',
			
			'mes'                => 'text',
			'error_empty_fields' => 'text',
			'hr1'				 => 'hr',

			'avatar'             => 'checkbox',
			'avatar_width'       => 'function',
			'avatar_height'      => 'none',
			'avatar_quality'     => 'none',
			'hr2'				 => 'hr',

			'sendmailadmin'      => 'checkbox',
			'emailconfadmin'     => 'function',
			'email_admin'        => 'none',
			'subject_admin'      => 'text',
			'message_admin'      => 'textarea',
			'hr3'				 => 'hr',
			
			'emailconf'          => 'function',
			'subject'            => 'text',
			'message'            => 'textarea',
			'email'              => 'none',
			'mes_reminding'      => 'text',
			'subject_reminding'  => 'text',
			'message_reminding'  => 'textarea'
		);

		$this->config_module = array(
			'config' => 1 //файл настроек модуля
		);

		$this->language_names = array(
			'mes',
			'subject',
			'message',
			'mes_reminding',
			'subject_reminding',
			'message_reminding'
		);

		$this->select_arr["act"] = array(
			0 => _ADMIN_USERSITE_CONFIG_ACT_0,
			1 => _ADMIN_USERSITE_CONFIG_ACT_1,
			2 => _ADMIN_USERSITE_CONFIG_ACT_2
		);

		$this->show_tr_click_checkbox = array(
			"sendmailadmin" => array(
				'emailconfadmin',
				'subject_admin',
				'message_admin'
			),
			"avatar" => array("avatar_width")
		);
	}

	/**
	 * Редактирование поля "Размер и качество аватара"
	 * 
	 * @return boolean true
	 */
	public function edit_avatar_width_module_config()
	{
		echo '
		<tr'.$this->get_other().'>
			<td class="td_first">'.$this->variable_names().'</td>
			<td><input type="text" name="avatar_width" size="3" value="'.$this->values["avatar_width"].'" class="inpnum"> x
				<input type="text" name="avatar_height" size="3" value="'.$this->values["avatar_height"].'" class="inpnum">,
				'._LANG_QUALITY.'
				<input type="text" name="avatar_quality" size="2" value="'.$this->values["avatar_quality"].'" class="inpnum">'
				.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}
}