<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Usersite_admin
 *
 * Редактирование пользователей сайта сайта
 */
class Usersite_admin extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'usersite';

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'users_site';

	/**
	 * @var boolean установлен модуль "Форум"
	 */
	public $forum = FALSE;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		$this->nastr = 30;

		//поля в базе данных для редактирования
		$this->variable_table = array(
			'fio'			=> 'text',
			'created'		=> 'date',
			'act'			=> 'checkbox',
			'hr1'			=> 'hr',
			'name'			=> 'text',
			'password'		=> 'password',
			'mail'			=> 'text',
			'param'			=> 'function',
			'hr2'			=> 'hr',
			'moderator'		=> 'checkbox',
			//'language'	=> 'select',
            'discount_type'	=> 'select',
			'avatar'		=> 'function',

			'hr3'			=> 'hr',
			'subscribtion'	=> 'function'
		);

		$this->config_module = array(
			'del'   => 1, //удалить
			'act'   => 1, //показать/скрыть
			'trash' => 1  //использовать корзину
		);

		$this->config_other_row = array(
			'name as n'
		);

		foreach ($this->diafan->language_all as $key => $language)
		{
			$this->select_arr["language"][$language[0]] = $language[2];
		}
                
                $result=DB::query("SELECT id,name from {shop_discount_type}");
                
                while($row=DB::fetch_array($result)) {
                        $this->select_arr["discount_type"][$row['id']] = $row['name'];
                }
                
	}

	/**
	 * Выводит список пользователей сайта
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->name = 'fio';

		$this->addnew_init(_ADMIN_USERS_ADD);
		echo '<table class="list">';
		$this->list_row();
		echo '</table>';

		DB::query("DELETE FROM {usersite_actlink} WHERE created<%d", time());
		DB::query("DELETE FROM {usersite_actlink} WHERE user_id IN (SELECT id FROM {users_site} WHERE act='1')");

		return TRUE;
	}

	/**
	 * Выводит статус пользователя (на сайте)
	 * @return string
	 */
	protected function other_row_nameasn($row)
	{
		return '</td><td>'.$row["n"]
		.(DB::query_result("SELECT COUNT(session_id) AS count FROM {sessions_site} WHERE timestamp >= %d AND user_id='%d'", (time()-900), $row["id"])
		 ? ' <font style="color: #ffffff; background-color: red;">'._ADMIN_USERS_ON_SITE.'</font>'
		 : '');
	}

	/**
	 * Редактирование поля "Подписан на рассылки"
	 * @return boolean true
	 */
	protected function edit_subscribtion_module()
	{
		if (! $this->diafan->configmodules("cat", "subscribtion"))
			return FALSE;

		echo '
		<tr'.$this->get_other().' valign="top">
			<td align="right">
				'.$this->variable_names().'
			</td>
			<td>';
		$this->parent_id_subscribtion_module_registration(0, '', array(), $this->value);
		echo $this->show_help_row().'
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Редактирование поля "Аватар"
	 * @return boolean true
	 */
	protected function edit_avatar_module()
	{
		if (! $this->diafan->configmodules("avatar", "usersite"))
			return FALSE;

		echo '
		<tr'.$this->get_other().' valign="top">
			<td align="right">
				'.$this->variable_names().'
			</td>
			<td>';
		if (file_exists(ABSOLUTE_PATH.'userfiles/avatar/'.$this->values["name"].'.png'))
		{
			echo '<img src="'.BASE_PATH.'userfiles/avatar/'.$this->values["name"].'.png?'.rand(0, 99).'" width="'
			.$this->diafan->configmodules("avatar_width", "usersite").'" height="'
			.$this->diafan->configmodules("avatar_height", "usersite").'" alt="'.$this->values["fio"].' ('.$this->values["name"].')">'
			.'<input type="checkbox" name="delete_avatar" value="1"> '._LANG_DELETE
			.'<br><br>';
		}
		echo '
		<input type="file" name="avatar" size="40" class="inptext">'
		.$this->show_help_row().'
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Формирует список рассылок
	 * @return array
	 */
	private function parent_id_subscribtion_module_registration($parent_id, $rew, $array, $subscribtion)
	{
		$result = DB::query("SELECT name,id FROM {subscribtion_category} WHERE parent_id='%d' AND trash='0'", $parent_id);
		while ($row = DB::fetch_array($result))
		{
			echo $rew.'<input type="checkbox" name="subscribtion[]" value="'.$row["id"].'"'
			.(! strstr($subscribtion, ' '.$row["id"].' ') ? ' checked' : '')
			.'> '.$row["name"].'<br>';
			if (in_array($row["id"], $array))
			{
				return $array;
			}
			$array[] = $row["id"];
			$array = $this->parent_id_subscribtion_module_registration($row["id"], '&nbsp;&nbsp;&nbsp;'.$rew, $array, $subscribtion);
		}
		return $array;
	}

	/**
	 * Редактирование поля "Дополнительные параметры"
	 * 
	 * @return boolean true
	 */
	protected function edit_param_module()
	{
		$values = array();
		$rvalues = array();
		$result_el = DB::query("SELECT value as rv, [value], param_id FROM {usersite_param_element} WHERE element_id=%d", $this->diafan->edit);
		while ($row_el = DB::fetch_array($result_el))
		{
			$values[$row_el["param_id"]][]  = $row_el["value"];
			$rvalues[$row_el["param_id"]][] = $row_el["rv"];
		}

		/*echo '
		<tr>
			<td></td>
			<td>
				<a href="'.BASE_PATH_HREF.$this->diafan->rewrite.'/param/addnew1/" target="_blank">'._ADMIN_USERSITE_ADD_PARAM.'</a>
				'.$this->show_help_row().'
			</td>
		</tr>';*/

		$result = DB::query("SELECT id, name, type FROM {usersite_param} WHERE trash='0' ORDER BY sort ASC");

		while ($row = DB::fetch_array($result))
		{
			$option = array();
			if (! $this->diafan->addnew && in_array($row["type"], array('select', 'multiple')))
			{
				$result_select = DB::query("SELECT [name], id FROM {usersite_param_select} WHERE param_id=%d ORDER BY sort ASC", $row["id"]);
				while ($row_select = DB::fetch_array($result_select))
				{
					$option[] = $row_select;
				}
			}
			if ($row["type"] == 'text' || $row["type"] == 'email')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="text" name="param'.$row["id"].'" size="40" value="'
						.(! empty($values[$row["id"]]) ? str_replace('"', '&quot;', $values[$row["id"]][0]) : '')
						.'">
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'date')
			{
				if (! $this->show_datepicker)
				{
					echo '
					<link rel="stylesheet" href="'.BASE_PATH.'css/timecalendar.css" />
					<script type="text/javascript" src="'.BASE_PATH.'js/timecalendar.js"></script>';
					$this->show_datepicker = TRUE;
				}
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="text" id="param'.$row["id"].'" name="param'.$row["id"].'" size="20" value="'.(! empty($rvalues[$row["id"]]) ? str_replace('"', '&quot;', date("d.m.Y", $rvalues[$row["id"]][0])) : '').'" class="timecalendar" showTime="false">
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'numtext')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="text" name="param'.$row["id"].'" size="20" value="'
						.(! empty($values[$row["id"]]) ? str_replace('"', '&quot;', $values[$row["id"]][0]) : '')
						.'" class="inpnum">
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'textarea')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<textarea name="param'.$row["id"].'" cols="60" rows="5">'
						.(! empty($values[$row["id"]]) ? str_replace('"', '&quot;', $values[$row["id"]][0]) : '')
						.'</textarea>
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'checkbox')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="checkbox" name="param'.$row["id"].'" value="1"'
						.(! $this->diafan->addnew && ! empty($values[$row["id"]]) ? " checked":'').'>
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'select')
			{
				$value = (! empty($rvalues[$row["id"]][0]) ? $rvalues[$row["id"]][0] : '');
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<select name="param'.$row["id"].'">
						<option value="">-</option>';
						foreach ($option as $select)
						{
							echo '<option value="'.$select["id"].'"'.($value == $select["id"] ? ' selected' : '').'>'.$select["name"].'</option>';
						}
						echo '</select>
					</td>
				</tr>';
			}
			elseif ($row["type"] == 'multiple')
			{
				$value = (! empty($rvalues[$row["id"]]) ? $rvalues[$row["id"]] : array());
				echo '
				<tr>
					<td align="right">
						'.$row["name"].'
					</td>
					<td>
						<select name="param'.$row["id"].'[]" multiple="multiple">';
						foreach ($option as $select)
						{
							echo '<option value="'.$select["id"].'"'.(in_array($select["id"], $value) ? ' selected' : '').'>'.$select["name"].'</option>';
						}
						echo '</select>
					</td>
				</tr>';
			}
		}
		return TRUE;
	}

	/**
	 * Сохранение поля "Логин"
	 * @return boolean true
	 */
	protected function save_name_module()
	{
		if (! $this->diafan->save || $_POST["name"] != $this->oldrow["name"])
		{
			require_once(ABSOLUTE_PATH.'includes/validate.php');
			$err = Validate::login($_POST["name"]);
			if ($err)
			{
				echo '<script language="javascript" type="text/javascript">alert(\''.strip_tags($err).'\');history.go(-1);</script>';
				exit;
			}
		}

		$this->query[] = "name='%h'";
		$this->value[] = $this->diafan->translit($_POST["name"]);

		return TRUE;
	}

	/**
	 * Сохранение поля "Список рассылок"
	 * @return boolean
	 */
	protected function save_subscribtion_module()
	{
		if (! $this->diafan->configmodules("cat", "subscribtion"))
			return FALSE;

		$array = array();
		$result = DB::query("SELECT id FROM {subscribtion_category} WHERE trash='0'");
		while ($row = DB::fetch_array($result))
		{
			if (empty($_POST["subscribtion"]) || ! in_array($row["id"], $_POST["subscribtion"]))
			{
				$array[] = $row["id"];
			}
		}
		$cats = '0 '.implode("  ", $array).' 0';
		$this->query[] = "subscribtion='%s'";
		$this->value[] = $cats;

		return TRUE;
	}

	/**
	 * Сохранение поля "Аватар"
	 * 
	 * @return boolean true
	 */
	protected function save_avatar_module()
	{
		if (! $this->diafan->configmodules("avatar", "usersite"))
		{
			return FALSE;
		}
		if (! empty($_POST["delete_avatar"]))
		{
			unlink(ABSOLUTE_PATH.USERFILES.'/avatar/'.$this->oldrow["name"].'.png');
		}
		if (isset($_FILES["avatar"]) || is_array($_FILES["avatar"]) && $_FILES["avatar"]['name'] != '')
		{
			list($width, $height) = getimagesize($_FILES["avatar"]['tmp_name']);
			if (! $width || ! $height)
			{
				echo '<script language="javascript" type="text/javascript">alert(\''
				._LANG_AVATAR_INCORRECT_FILE
				.'\');history.go(-1);</script>';
				return FALSE;
			}
			if ($width < $this->diafan->configmodules("avatar_width", "usersite") || $height < $this->diafan->configmodules("avatar_height", "usersite"))
			{
				echo '<script language="javascript" type="text/javascript">alert(\''
				.sprintf(_LANG_AVATAR_INCORRECT_SIZE, $this->diafan->configmodules("avatar_width", "usersite"), $this->diafan->configmodules("avatar_height", "usersite"))
				.'\');history.go(-1);</script>';
				return FALSE;
			}
			include_once(ABSOLUTE_PATH.'includes/image.php');
			if (! Image::resize($_FILES["avatar"]['tmp_name'], $this->diafan->configmodules("avatar_width", "usersite"), $this->diafan->configmodules("avatar_height", "usersite"), $this->diafan->configmodules("avatar_quality", "usersite"), TRUE, TRUE))
			{
				echo '<script language="javascript" type="text/javascript">alert(\''
				._LANG_AVATAR_FILE_NO_UPLOAD
				.'\');history.go(-1);</script>';
				return FALSE;
			}
			$dst_img = imageCreateTrueColor($this->diafan->configmodules("avatar_width", "usersite"), $this->diafan->configmodules("avatar_height", "usersite"));
			$original  = @imageCreateFromString(file_get_contents($_FILES["avatar"]['tmp_name'])); 
			imageCopy($dst_img, $original, 0, 0, 0, 0, $this->diafan->configmodules("avatar_width", "usersite"), $this->diafan->configmodules("avatar_height", "usersite"));
			imagePNG($dst_img, ABSOLUTE_PATH.USERFILES.'/avatar/'.$this->oldrow["name"].'.png');
		}
		return TRUE;
	}

	/**
	 * Сохранение поля "Дополнительные параметры"
	 * 
	 * @return boolean true
	 */
	protected function save_param_module()
	{
		$ids = array();
		$result = DB::query("SELECT id, name, type FROM {usersite_param} WHERE trash='0' ORDER BY sort ASC");

		while ($row = DB::fetch_array($result))
		{
			if ($row["type"] == "multiple")
			{
				DB::query("DELETE FROM {usersite_param_element} WHERE param_id=%d AND element_id=%d", $row["id"], $this->diafan->save);
				if (! empty($_POST['param'.$row["id"]]) && is_array($_POST['param'.$row["id"]]))
				{
					foreach ($_POST['param'.$row["id"]] as $v)
					{
						DB::query(
							"INSERT INTO {usersite_param_element} (value, param_id, element_id) VALUES ('%s', %d, %d)",
							$v,
							$row["id"],
							$this->diafan->save
						);
					}
				}
				
			}
			elseif (! empty($_POST['param'.$row["id"]]))
			{
				$id = 0;
				if (! $this->diafan->savenew)
				{
					$id = DB::query_result("SELECT id FROM {usersite_param_element} WHERE param_id=%d AND element_id=%d", $row["id"], $this->diafan->save);
				}
				if ($row["type"] == "date")
				{
					$_POST['param'.$row["id"]] = $this->diafan->unixdate($_POST['param'.$row["id"]]);
				}
				if ($id)
				{
					DB::query(
						"UPDATE {usersite_param_element} SET ".(in_array($row["type"], array("text", "editor", "textarea")) ? '[value]' : 'value')
						."='%s' WHERE id=%d",
						$_POST['param'.$row["id"]],
						$id
					);
					DB::query("DELETE FROM {usersite_param_element} WHERE param_id=%d AND element_id=%d AND id<>%d", $row["id"], $this->diafan->save, $id);
				}
				else
				{
					DB::query(
						"INSERT INTO {usersite_param_element} (".(in_array($row["type"], array("text", "editor", "textarea")) ? '[value]' : 'value')
						.", param_id, element_id) VALUES ('%s', %d, %d)",
						$_POST['param'.$row["id"]],
						$row["id"],
						$this->diafan->save
					);
				}
			}
			$ids[] = $row["id"];
		}
		DB::query("DELETE FROM {usersite_param_element} WHERE param_id NOT IN (".implode(", ", $ids).") AND element_id=%d", $this->diafan->save);
		return TRUE;
	}

	/**
	 * Добавляет пользователя (вместо основной фунции)
	 * @return boolean true
	 */
	public function new_module()
	{
		require_once(ABSOLUTE_PATH.'includes/validate.php');
		$err = Validate::login($_POST["name"]);
		if ($err)
		{
			echo '<script language="javascript" type="text/javascript">alert(\''.strip_tags($err).'\');history.go(-1);</script>';
			return FALSE;
		}
		parent::new_module();

		return TRUE;
	}

	/**
	 * Удаляет пользователя (вместо основной функции)
	 * @return boolean
	 */
	public function del_module()
	{
		// Прошел ли пользователь проверку идентификационного хэша
		if (! $this->diafan->_user->checked)
		{
			$this->diafan->redirect(URL);
			return FALSE;
		}

		if ($this->diafan->admin_roles('del'))
		{
			$this->diafan->redirect(URL);
			return FALSE;
		}

		if (! empty($_POST["id"]))
		{
			$ids = array($_POST["id"]);
		}
		else
		{
			$ids = $_POST["ids"];
		}
		foreach ($ids as $id)
		{
			$id = intval($id);
			DB::query("DELETE FROM {usersite_actlink} WHERE user_id='%d'", $id);
			DB::query("DELETE FROM {forum_show} WHERE user_id='%d'", $id);
		}
		parent::del_module();

		return TRUE;
	}
}